/*
 * Ascent MMORPG Server
 * Copyright (C) 2005-2007 Ascent Team <http://www.ascentemu.com/>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef _OPCODES_H
#define _OPCODES_H

// NOTE: All SERVER opcodes are now uint16's, as of patch 4 (3807/0.9.0)
//	   Client opcodes are still uint32 as far as we know.
//1.8.0 client opcodes

enum Opcodes {
	MSG_NULL_ACTION                              = 0,	//(0x0000)
	CMSG_BOOTME                                  = 1,	//(0x0001)
	CMSG_DBLOOKUP                                = 2,	//(0x0002)
	SMSG_DBLOOKUP                                = 3,	//(0x0003)
	CMSG_QUERY_OBJECT_POSITION                   = 4,	//(0x0004)
	SMSG_QUERY_OBJECT_POSITION                   = 5,	//(0x0005)
	CMSG_QUERY_OBJECT_ROTATION                   = 6,	//(0x0006)
	SMSG_QUERY_OBJECT_ROTATION                   = 7,	//(0x0007)
	CMSG_WORLD_TELEPORT                          = 8,	//(0x0008)
	CMSG_TELEPORT_TO_UNIT                        = 9,	//(0x0009)
	CMSG_ZONE_MAP                                = 10,	//(0x000A)
	SMSG_ZONE_MAP                                = 11,	//(0x000B)
	CMSG_DEBUG_CHANGECELLZONE                    = 12,	//(0x000C)
	CMSG_EMBLAZON_TABARD_OBSOLETE                = 13,	//(0x000D)
	CMSG_UNEMBLAZON_TABARD_OBSOLETE              = 14,	//(0x000E)
	CMSG_RECHARGE                                = 15,	//(0x000F)
	CMSG_LEARN_SPELL                             = 16,	//(0x0010)
	CMSG_CREATEMONSTER                           = 17,	//(0x0011)
	CMSG_DESTROYMONSTER                          = 18,	//(0x0012)
	CMSG_CREATEITEM                              = 19,	//(0x0013)
	CMSG_CREATEGAMEOBJECT                        = 20,	//(0x0014)
	CMSG_MAKEMONSTERATTACKME_OBSOLETE            = 21,	//(0x0015)
	CMSG_MAKEMONSTERATTACKGUID                   = 22,	//(0x0016)
	CMSG_ENABLEDEBUGCOMBATLOGGING_OBSOLETE       = 23,	//(0x0017)
	CMSG_FORCEACTION                             = 24,	//(0x0018)
	CMSG_FORCEACTIONONOTHER                      = 25,	//(0x0019)
	CMSG_FORCEACTIONSHOW                         = 26,	//(0x001A)
	SMSG_FORCEACTIONSHOW                         = 27,	//(0x001B)
	SMSG_ATTACKERSTATEUPDATEDEBUGINFO_OBSOLETE   = 28,	//(0x001C)
	SMSG_DEBUGINFOSPELL_OBSOLETE                 = 29,	//(0x001D)
	SMSG_DEBUGINFOSPELLMISS_OBSOLETE             = 30,	//(0x001E)
	SMSG_DEBUG_PLAYER_RANGE_OBSOLETE             = 31,	//(0x001F)
	CMSG_UNDRESSPLAYER                           = 32,	//(0x0020)
	CMSG_BEASTMASTER                             = 33,	//(0x0021)
	CMSG_GODMODE                                 = 34,	//(0x0022)
	SMSG_GODMODE                                 = 35,	//(0x0023)
	CMSG_CHEAT_SETMONEY                          = 36,	//(0x0024)
	CMSG_LEVEL_CHEAT                             = 37,	//(0x0025)
	CMSG_PET_LEVEL_CHEAT                         = 38,	//(0x0026)
	CMSG_LEVELUP_CHEAT_OBSOLETE                  = 39,	//(0x0027)
	CMSG_COOLDOWN_CHEAT                          = 40,	//(0x0028)
	CMSG_USE_SKILL_CHEAT                         = 41,	//(0x0029)
	CMSG_FLAG_QUEST                              = 42,	//(0x002A)
	CMSG_FLAG_QUEST_FINISH                       = 43,	//(0x002B)
	CMSG_CLEAR_QUEST                             = 44,	//(0x002C)
	CMSG_SEND_EVENT                              = 45,	//(0x002D)
	CMSG_DEBUG_AISTATE                           = 46,	//(0x002E)
	SMSG_DEBUG_AISTATE                           = 47,	//(0x002F)
	CMSG_DISABLE_PVP_CHEAT                       = 48,	//(0x0030)
	CMSG_ADVANCE_SPAWN_TIME                      = 49,	//(0x0031)
	CMSG_PVP_PORT_OBSOLETE                       = 50,	//(0x0032)
	CMSG_AUTH_SRP6_BEGIN                         = 51,	//(0x0033)
	CMSG_AUTH_SRP6_PROOF                         = 52,	//(0x0034)
	CMSG_AUTH_SRP6_RECODE                        = 53,	//(0x0035)
	CMSG_CHAR_CREATE                             = 54,	//(0x0036)
	CMSG_CHAR_ENUM                               = 55,	//(0x0037)
	CMSG_CHAR_DELETE                             = 56,	//(0x0038)
	SMSG_AUTH_SRP6_RESPONSE                      = 57,	//(0x0039)
	SMSG_CHAR_CREATE                             = 58,	//(0x003A)
	SMSG_CHAR_ENUM                               = 59,	//(0x003B)
	SMSG_CHAR_DELETE                             = 60,	//(0x003C)
	CMSG_PLAYER_LOGIN                            = 61,	//(0x003D)
	SMSG_NEW_WORLD                               = 62,	//(0x003E)
	SMSG_TRANSFER_PENDING                        = 63,	//(0x003F)
	SMSG_TRANSFER_ABORTED                        = 64,	//(0x0040)
	SMSG_CHARACTER_LOGIN_FAILED                  = 65,	//(0x0041)
	SMSG_LOGIN_SETTIMESPEED                      = 66,	//(0x0042)
	SMSG_GAMETIME_UPDATE                         = 67,	//(0x0043)
	CMSG_GAMETIME_SET                            = 68,	//(0x0044)
	SMSG_GAMETIME_SET                            = 69,	//(0x0045)
	CMSG_GAMESPEED_SET                           = 70,	//(0x0046)
	SMSG_GAMESPEED_SET                           = 71,	//(0x0047)
	CMSG_SERVERTIME                              = 72,	//(0x0048)
	SMSG_SERVERTIME                              = 73,	//(0x0049)
	CMSG_PLAYER_LOGOUT                           = 74,	//(0x004A)
	CMSG_LOGOUT_REQUEST                          = 75,	//(0x004B)
	SMSG_LOGOUT_RESPONSE                         = 76,	//(0x004C)
	SMSG_LOGOUT_COMPLETE                         = 77,	//(0x004D)
	CMSG_LOGOUT_CANCEL                           = 78,	//(0x004E)
	SMSG_LOGOUT_CANCEL_ACK                       = 79,	//(0x004F)
	CMSG_NAME_QUERY                              = 80,	//(0x0050)
	SMSG_NAME_QUERY_RESPONSE                     = 81,	//(0x0051)
	CMSG_PET_NAME_QUERY                          = 82,	//(0x0052)
	SMSG_PET_NAME_QUERY_RESPONSE                 = 83,	//(0x0053)
	CMSG_GUILD_QUERY                             = 84,	//(0x0054)
	SMSG_GUILD_QUERY_RESPONSE                    = 85,	//(0x0055)
	CMSG_ITEM_QUERY_SINGLE                       = 86,	//(0x0056)
	CMSG_ITEM_QUERY_MULTIPLE                     = 87,	//(0x0057)
	SMSG_ITEM_QUERY_SINGLE_RESPONSE              = 88,	//(0x0058)
	SMSG_ITEM_QUERY_MULTIPLE_RESPONSE            = 89,	//(0x0059)
	CMSG_PAGE_TEXT_QUERY                         = 90,	//(0x005A)
	SMSG_PAGE_TEXT_QUERY_RESPONSE                = 91,	//(0x005B)
	CMSG_QUEST_QUERY                             = 92,	//(0x005C)
	SMSG_QUEST_QUERY_RESPONSE                    = 93,	//(0x005D)
	CMSG_GAMEOBJECT_QUERY                        = 94,	//(0x005E)
	SMSG_GAMEOBJECT_QUERY_RESPONSE               = 95,	//(0x005F)
	CMSG_CREATURE_QUERY                          = 96,	//(0x0060)
	SMSG_CREATURE_QUERY_RESPONSE                 = 97,	//(0x0061)
	CMSG_WHO                                     = 98,	//(0x0062)
	SMSG_WHO                                     = 99,	//(0x0063)
	CMSG_WHOIS                                   = 100,	//(0x0064)
	SMSG_WHOIS                                   = 101,	//(0x0065)
	CMSG_FRIEND_LIST                             = 102,	//(0x0066)
	SMSG_FRIEND_LIST                             = 103,	//(0x0067)
	SMSG_FRIEND_STATUS                           = 104,	//(0x0068)
	CMSG_ADD_FRIEND                              = 105,	//(0x0069)
	CMSG_DEL_FRIEND                              = 106,	//(0x006A)
	SMSG_IGNORE_LIST                             = 107,	//(0x006B)
	CMSG_ADD_IGNORE                              = 108,	//(0x006C)
	CMSG_DEL_IGNORE                              = 109,	//(0x006D)
	CMSG_GROUP_INVITE                            = 110,	//(0x006E)
	SMSG_GROUP_INVITE                            = 111,	//(0x006F)
	CMSG_GROUP_CANCEL                            = 112,	//(0x0070)
	SMSG_GROUP_CANCEL                            = 113,	//(0x0071)
	CMSG_GROUP_ACCEPT                            = 114,	//(0x0072)
	CMSG_GROUP_DECLINE                           = 115,	//(0x0073)
	SMSG_GROUP_DECLINE                           = 116,	//(0x0074)
	CMSG_GROUP_UNINVITE                          = 117,	//(0x0075)
	CMSG_GROUP_UNINVITE_GUID                     = 118,	//(0x0076)
	SMSG_GROUP_UNINVITE                          = 119,	//(0x0077)
	CMSG_GROUP_SET_LEADER                        = 120,	//(0x0078)
	SMSG_GROUP_SET_LEADER                        = 121,	//(0x0079)
	CMSG_LOOT_METHOD                             = 122,	//(0x007A)
	CMSG_GROUP_DISBAND                           = 123,	//(0x007B)
	SMSG_GROUP_DESTROYED                         = 124,	//(0x007C)
	SMSG_GROUP_LIST                              = 125,	//(0x007D)
	SMSG_PARTY_MEMBER_STATS                      = 126,	//(0x007E)
	SMSG_PARTY_COMMAND_RESULT                    = 127,	//(0x007F)
	UMSG_UPDATE_GROUP_MEMBERS                    = 128,	//(0x0080)
	CMSG_GUILD_CREATE                            = 129,	//(0x0081)
	CMSG_GUILD_INVITE                            = 130,	//(0x0082)
	SMSG_GUILD_INVITE                            = 131,	//(0x0083)
	CMSG_GUILD_ACCEPT                            = 132,	//(0x0084)
	CMSG_GUILD_DECLINE                           = 133,	//(0x0085)
	SMSG_GUILD_DECLINE                           = 134,	//(0x0086)
	CMSG_GUILD_INFO                              = 135,	//(0x0087)
	SMSG_GUILD_INFO                              = 136,	//(0x0088)
	CMSG_GUILD_ROSTER                            = 137,	//(0x0089)
	SMSG_GUILD_ROSTER                            = 138,	//(0x008A)
	CMSG_GUILD_PROMOTE                           = 139,	//(0x008B)
	CMSG_GUILD_DEMOTE                            = 140,	//(0x008C)
	CMSG_GUILD_LEAVE                             = 141,	//(0x008D)
	CMSG_GUILD_REMOVE                            = 142,	//(0x008E)
	CMSG_GUILD_DISBAND                           = 143,	//(0x008F)
	CMSG_GUILD_LEADER                            = 144,	//(0x0090)
	CMSG_GUILD_MOTD                              = 145,	//(0x0091)
	SMSG_GUILD_EVENT                             = 146,	//(0x0092)
	SMSG_GUILD_COMMAND_RESULT                    = 147,	//(0x0093)
	UMSG_UPDATE_GUILD                            = 148,	//(0x0094)
	CMSG_MESSAGECHAT                             = 149,	//(0x0095)
	SMSG_MESSAGECHAT                             = 150,	//(0x0096)
	CMSG_JOIN_CHANNEL                            = 151,	//(0x0097)
	CMSG_LEAVE_CHANNEL                           = 152,	//(0x0098)
	SMSG_CHANNEL_NOTIFY                          = 153,	//(0x0099)
	CMSG_CHANNEL_LIST                            = 154,	//(0x009A)
	SMSG_CHANNEL_LIST                            = 155,	//(0x009B)
	CMSG_CHANNEL_PASSWORD                        = 156,	//(0x009C)
	CMSG_CHANNEL_SET_OWNER                       = 157,	//(0x009D)
	CMSG_CHANNEL_OWNER                           = 158,	//(0x009E)
	CMSG_CHANNEL_MODERATOR                       = 159,	//(0x009F)
	CMSG_CHANNEL_UNMODERATOR                     = 160,	//(0x00A0)
	CMSG_CHANNEL_MUTE                            = 161,	//(0x00A1)
	CMSG_CHANNEL_UNMUTE                          = 162,	//(0x00A2)
	CMSG_CHANNEL_INVITE                          = 163,	//(0x00A3)
	CMSG_CHANNEL_KICK                            = 164,	//(0x00A4)
	CMSG_CHANNEL_BAN                             = 165,	//(0x00A5)
	CMSG_CHANNEL_UNBAN                           = 166,	//(0x00A6)
	CMSG_CHANNEL_ANNOUNCEMENTS                   = 167,	//(0x00A7)
	CMSG_CHANNEL_MODERATE                        = 168,	//(0x00A8)
	SMSG_UPDATE_OBJECT                           = 169,	//(0x00A9)
	SMSG_DESTROY_OBJECT                          = 170,	//(0x00AA)
	CMSG_USE_ITEM                                = 171,	//(0x00AB)
	CMSG_OPEN_ITEM                               = 172,	//(0x00AC)
	CMSG_READ_ITEM                               = 173,	//(0x00AD)
	SMSG_READ_ITEM_OK                            = 174,	//(0x00AE)
	SMSG_READ_ITEM_FAILED                        = 175,	//(0x00AF)
	SMSG_ITEM_COOLDOWN                           = 176,	//(0x00B0)
	CMSG_GAMEOBJ_USE                             = 177,	//(0x00B1)
	CMSG_GAMEOBJ_CHAIR_USE_OBSOLETE              = 178,	//(0x00B2)
	SMSG_GAMEOBJECT_CUSTOM_ANIM                  = 179,	//(0x00B3)
	CMSG_AREATRIGGER                             = 180,	//(0x00B4)
	MSG_MOVE_START_FORWARD                       = 181,	//(0x00B5)
	MSG_MOVE_START_BACKWARD                      = 182,	//(0x00B6)
	MSG_MOVE_STOP                                = 183,	//(0x00B7)
	MSG_MOVE_START_STRAFE_LEFT                   = 184,	//(0x00B8)
	MSG_MOVE_START_STRAFE_RIGHT                  = 185,	//(0x00B9)
	MSG_MOVE_STOP_STRAFE                         = 186,	//(0x00BA)
	MSG_MOVE_JUMP                                = 187,	//(0x00BB)
	MSG_MOVE_START_TURN_LEFT                     = 188,	//(0x00BC)
	MSG_MOVE_START_TURN_RIGHT                    = 189,	//(0x00BD)
	MSG_MOVE_STOP_TURN                           = 190,	//(0x00BE)
	MSG_MOVE_START_PITCH_UP                      = 191,	//(0x00BF)
	MSG_MOVE_START_PITCH_DOWN                    = 192,	//(0x00C0)
	MSG_MOVE_STOP_PITCH                          = 193,	//(0x00C1)
	MSG_MOVE_SET_RUN_MODE                        = 194,	//(0x00C2)
	MSG_MOVE_SET_WALK_MODE                       = 195,	//(0x00C3)
	MSG_MOVE_TOGGLE_LOGGING                      = 196,	//(0x00C4)
	MSG_MOVE_TELEPORT                            = 197,	//(0x00C5)
	MSG_MOVE_TELEPORT_CHEAT                      = 198,	//(0x00C6)
	MSG_MOVE_TELEPORT_ACK                        = 199,	//(0x00C7)
	MSG_MOVE_TOGGLE_FALL_LOGGING                 = 200,	//(0x00C8)
	MSG_MOVE_FALL_LAND                           = 201,	//(0x00C9)
	MSG_MOVE_START_SWIM                          = 202,	//(0x00CA)
	MSG_MOVE_STOP_SWIM                           = 203,	//(0x00CB)
	MSG_MOVE_SET_RUN_SPEED_CHEAT                 = 204,	//(0x00CC)
	MSG_MOVE_SET_RUN_SPEED                       = 205,	//(0x00CD)
	MSG_MOVE_SET_RUN_BACK_SPEED_CHEAT            = 206,	//(0x00CE)
	MSG_MOVE_SET_RUN_BACK_SPEED                  = 207,	//(0x00CF)
	MSG_MOVE_SET_WALK_SPEED_CHEAT                = 208,	//(0x00D0)
	MSG_MOVE_SET_WALK_SPEED                      = 209,	//(0x00D1)
	MSG_MOVE_SET_SWIM_SPEED_CHEAT                = 210,	//(0x00D2)
	MSG_MOVE_SET_SWIM_SPEED                      = 211,	//(0x00D3)
	MSG_MOVE_SET_SWIM_BACK_SPEED_CHEAT           = 212,	//(0x00D4)
	MSG_MOVE_SET_SWIM_BACK_SPEED                 = 213,	//(0x00D5)
	MSG_MOVE_SET_ALL_SPEED_CHEAT                 = 214,	//(0x00D6)
	MSG_MOVE_SET_TURN_RATE_CHEAT                 = 215,	//(0x00D7)
	MSG_MOVE_SET_TURN_RATE                       = 216,	//(0x00D8)
	MSG_MOVE_TOGGLE_COLLISION_CHEAT              = 217,	//(0x00D9)
	MSG_MOVE_SET_FACING                          = 218,	//(0x00DA)
	MSG_MOVE_SET_PITCH                           = 219,	//(0x00DB)
	MSG_MOVE_WORLDPORT_ACK                       = 220,	//(0x00DC)
	SMSG_MONSTER_MOVE                            = 221,	//(0x00DD)
	SMSG_MOVE_WATER_WALK                         = 222,	//(0x00DE)
	SMSG_MOVE_LAND_WALK                          = 223,	//(0x00DF)
	MSG_MOVE_SET_RAW_POSITION_ACK                = 224,	//(0x00E0)
	CMSG_MOVE_SET_RAW_POSITION                   = 225,	//(0x00E1)
	SMSG_FORCE_RUN_SPEED_CHANGE                  = 226,	//(0x00E2)
	CMSG_FORCE_RUN_SPEED_CHANGE_ACK              = 227,	//(0x00E3)
	SMSG_FORCE_RUN_BACK_SPEED_CHANGE             = 228,	//(0x00E4)
	CMSG_FORCE_RUN_BACK_SPEED_CHANGE_ACK         = 229,	//(0x00E5)
	SMSG_FORCE_SWIM_SPEED_CHANGE                 = 230,	//(0x00E6)
	CMSG_FORCE_SWIM_SPEED_CHANGE_ACK             = 231,	//(0x00E7)
	SMSG_FORCE_MOVE_ROOT                         = 232,	//(0x00E8)
	CMSG_FORCE_MOVE_ROOT_ACK                     = 233,	//(0x00E9)
	SMSG_FORCE_MOVE_UNROOT                       = 234,	//(0x00EA)
	CMSG_FORCE_MOVE_UNROOT_ACK                   = 235,	//(0x00EB)
	MSG_MOVE_ROOT                                = 236,	//(0x00EC)
	MSG_MOVE_UNROOT                              = 237,	//(0x00ED)
	MSG_MOVE_HEARTBEAT                           = 238,	//(0x00EE)
	SMSG_MOVE_KNOCK_BACK                         = 239,	//(0x00EF)
	CMSG_MOVE_KNOCK_BACK_ACK                     = 240,	//(0x00F0)
	MSG_MOVE_KNOCK_BACK                          = 241,	//(0x00F1)
	SMSG_MOVE_FEATHER_FALL                       = 242,	//(0x00F2)
	SMSG_MOVE_NORMAL_FALL                        = 243,	//(0x00F3)
	SMSG_MOVE_SET_HOVER                          = 244,	//(0x00F4)
	SMSG_MOVE_UNSET_HOVER                        = 245,	//(0x00F5)
	CMSG_MOVE_HOVER_ACK                          = 246,	//(0x00F6)
	MSG_MOVE_HOVER                               = 247,	//(0x00F7)
	CMSG_TRIGGER_CINEMATIC_CHEAT                 = 248,	//(0x00F8)
	CMSG_OPENING_CINEMATIC                       = 249,	//(0x00F9)
	SMSG_TRIGGER_CINEMATIC                       = 250,	//(0x00FA)
	CMSG_NEXT_CINEMATIC_CAMERA                   = 251,	//(0x00FB)
	CMSG_COMPLETE_CINEMATIC                      = 252,	//(0x00FC)
	SMSG_TUTORIAL_FLAGS                          = 253,	//(0x00FD)
	CMSG_TUTORIAL_FLAG                           = 254,	//(0x00FE)
	CMSG_TUTORIAL_CLEAR                          = 255,	//(0x00FF)
	CMSG_TUTORIAL_RESET                          = 256,	//(0x0100)
	CMSG_STANDSTATECHANGE                        = 257,	//(0x0101)
	CMSG_EMOTE                                   = 258,	//(0x0102)
	SMSG_EMOTE                                   = 259,	//(0x0103)
	CMSG_TEXT_EMOTE                              = 260,	//(0x0104)
	SMSG_TEXT_EMOTE                              = 261,	//(0x0105)
	CMSG_AUTOEQUIP_GROUND_ITEM                   = 262,	//(0x0106)
	CMSG_AUTOSTORE_GROUND_ITEM                   = 263,	//(0x0107)
	CMSG_AUTOSTORE_LOOT_ITEM                     = 264,	//(0x0108)
	CMSG_STORE_LOOT_IN_SLOT                      = 265,	//(0x0109)
	CMSG_AUTOEQUIP_ITEM                          = 266,	//(0x010A)
	CMSG_AUTOSTORE_BAG_ITEM                      = 267,	//(0x010B)
	CMSG_SWAP_ITEM                               = 268,	//(0x010C)
	CMSG_SWAP_INV_ITEM                           = 269,	//(0x010D)
	CMSG_SPLIT_ITEM                              = 270,	//(0x010E)
	CMSG_PICKUP_ITEM                             = 271,	//(0x010F)
	CMSG_DROP_ITEM                               = 272,	//(0x0110)
	CMSG_DESTROYITEM                             = 273,	//(0x0111)
	SMSG_INVENTORY_CHANGE_FAILURE                = 274,	//(0x0112)
	SMSG_OPEN_CONTAINER                          = 275,	//(0x0113)
	CMSG_INSPECT                                 = 276,	//(0x0114)
	SMSG_INSPECT                                 = 277,	//(0x0115)
	CMSG_INITIATE_TRADE                          = 278,	//(0x0116)
	CMSG_BEGIN_TRADE                             = 279,	//(0x0117)
	CMSG_BUSY_TRADE                              = 280,	//(0x0118)
	CMSG_IGNORE_TRADE                            = 281,	//(0x0119)
	CMSG_ACCEPT_TRADE                            = 282,	//(0x011A)
	CMSG_UNACCEPT_TRADE                          = 283,	//(0x011B)
	CMSG_CANCEL_TRADE                            = 284,	//(0x011C)
	CMSG_SET_TRADE_ITEM                          = 285,	//(0x011D)
	CMSG_CLEAR_TRADE_ITEM                        = 286,	//(0x011E)
	CMSG_SET_TRADE_GOLD                          = 287,	//(0x011F)
	SMSG_TRADE_STATUS                            = 288,	//(0x0120)
	SMSG_TRADE_STATUS_EXTENDED                   = 289,	//(0x0121)
	SMSG_INITIALIZE_FACTIONS                     = 290,	//(0x0122)
	SMSG_SET_FACTION_VISIBLE                     = 291,	//(0x0123)
	SMSG_SET_FACTION_STANDING                    = 292,	//(0x0124)
	CMSG_SET_FACTION_ATWAR                       = 293,	//(0x0125)
	CMSG_SET_FACTION_CHEAT                       = 294,	//(0x0126)
	SMSG_SET_PROFICIENCY                         = 295,	//(0x0127)
	CMSG_SET_ACTION_BUTTON                       = 296,	//(0x0128)
	SMSG_ACTION_BUTTONS                          = 297,	//(0x0129)
	SMSG_INITIAL_SPELLS                          = 298,	//(0x012A)
	SMSG_LEARNED_SPELL                           = 299,	//(0x012B)
	SMSG_SUPERCEDED_SPELL                        = 300,	//(0x012C)
	CMSG_NEW_SPELL_SLOT                          = 301,	//(0x012D)
	CMSG_CAST_SPELL                              = 302,	//(0x012E)
	CMSG_CANCEL_CAST                             = 303,	//(0x012F)
	SMSG_CAST_RESULT                             = 304,	//(0x0130)
	SMSG_SPELL_START                             = 305,	//(0x0131)
	SMSG_SPELL_GO                                = 306,	//(0x0132)
	SMSG_SPELL_FAILURE                           = 307,	//(0x0133)
	SMSG_SPELL_COOLDOWN                          = 308,	//(0x0134)
	SMSG_COOLDOWN_EVENT                          = 309,	//(0x0135)
	CMSG_CANCEL_AURA                             = 310,	//(0x0136)
	SMSG_UPDATE_AURA_DURATION                    = 311,	//(0x0137)
	SMSG_PET_CAST_FAILED                         = 312,	//(0x0138)
	MSG_CHANNEL_START                            = 313,	//(0x0139)
	MSG_CHANNEL_UPDATE                           = 314,	//(0x013A)
	CMSG_CANCEL_CHANNELLING                      = 315,	//(0x013B)
	SMSG_AI_REACTION                             = 316,	//(0x013C)
	CMSG_SET_SELECTION                           = 317,	//(0x013D)
	CMSG_SET_TARGET_OBSOLETE                     = 318,	//(0x013E)
	CMSG_UNUSED                                  = 319,	//(0x013F)
	CMSG_UNUSED2                                 = 320,	//(0x0140)
	CMSG_ATTACKSWING                             = 321,	//(0x0141)
	CMSG_ATTACKSTOP                              = 322,	//(0x0142)
	SMSG_ATTACKSTART                             = 323,	//(0x0143)
	SMSG_ATTACKSTOP                              = 324,	//(0x0144)
	SMSG_ATTACKSWING_NOTINRANGE                  = 325,	//(0x0145)
	SMSG_ATTACKSWING_BADFACING                   = 326,	//(0x0146)
	SMSG_ATTACKSWING_NOTSTANDING                 = 327,	//(0x0147)
	SMSG_ATTACKSWING_DEADTARGET                  = 328,	//(0x0148)
	SMSG_ATTACKSWING_CANT_ATTACK                 = 329,	//(0x0149)
	SMSG_ATTACKERSTATEUPDATE                     = 330,	//(0x014A)
	SMSG_VICTIMSTATEUPDATE_OBSOLETE              = 331,	//(0x014B)
	SMSG_DAMAGE_DONE_OBSOLETE                    = 332,	//(0x014C)
	SMSG_DAMAGE_TAKEN_OBSOLETE                   = 333,	//(0x014D)
	SMSG_CANCEL_COMBAT                           = 334,	//(0x014E)
	SMSG_PLAYER_COMBAT_XP_GAIN_OBSOLETE          = 335,	//(0x014F)
	SMSG_HEALSPELL_ON_PLAYER			         = 336,	//(0x0150)
	SMSG_HEALMANASPELL_ON_PLAYER			     = 337,	//(0x0151)
	CMSG_SHEATHE_OBSOLETE                        = 338,	//(0x0152)
	CMSG_SAVE_PLAYER                             = 339,	//(0x0153)
	CMSG_SETDEATHBINDPOINT                       = 340,	//(0x0154)
	SMSG_BINDPOINTUPDATE                         = 341,	//(0x0155)
	CMSG_GETDEATHBINDZONE                        = 342,	//(0x0156)
	SMSG_BINDZONEREPLY                           = 343,	//(0x0157)
	SMSG_PLAYERBOUND                             = 344,	//(0x0158)
	SMSG_DEATH_NOTIFY_OBSOLETE                   = 345,	//(0x0159)
	CMSG_REPOP_REQUEST                           = 346,	//(0x015A)
	SMSG_RESURRECT_REQUEST                       = 347,	//(0x015B)
	CMSG_RESURRECT_RESPONSE                      = 348,	//(0x015C)
	CMSG_LOOT                                    = 349,	//(0x015D)
	CMSG_LOOT_MONEY                              = 350,	//(0x015E)
	CMSG_LOOT_RELEASE                            = 351,	//(0x015F)
	SMSG_LOOT_RESPONSE                           = 352,	//(0x0160)
	SMSG_LOOT_RELEASE_RESPONSE                   = 353,	//(0x0161)
	SMSG_LOOT_REMOVED                            = 354,	//(0x0162)
	SMSG_LOOT_MONEY_NOTIFY                       = 355,	//(0x0163)
	SMSG_LOOT_ITEM_NOTIFY                        = 356,	//(0x0164)
	SMSG_LOOT_CLEAR_MONEY                        = 357,	//(0x0165)
	SMSG_ITEM_PUSH_RESULT                        = 358,	//(0x0166)
	SMSG_DUEL_REQUESTED                          = 359,	//(0x0167)
	SMSG_DUEL_OUTOFBOUNDS                        = 360,	//(0x0168)
	SMSG_DUEL_INBOUNDS                           = 361,	//(0x0169)
	SMSG_DUEL_COMPLETE                           = 362,	//(0x016A)
	SMSG_DUEL_WINNER                             = 363,	//(0x016B)
	CMSG_DUEL_ACCEPTED                           = 364,	//(0x016C)
	CMSG_DUEL_CANCELLED                          = 365,	//(0x016D)
	SMSG_MOUNTRESULT                             = 366,	//(0x016E)
	SMSG_DISMOUNTRESULT                          = 367,	//(0x016F)
	SMSG_PUREMOUNT_CANCELLED_OBSOLETE            = 368,	//(0x0170)
	CMSG_MOUNTSPECIAL_ANIM                       = 369,	//(0x0171)
	SMSG_MOUNTSPECIAL_ANIM                       = 370,	//(0x0172)
	SMSG_PET_TAME_FAILURE                        = 371,	//(0x0173)
	CMSG_PET_SET_ACTION                          = 372,	//(0x0174)
	CMSG_PET_ACTION                              = 373,	//(0x0175)
	CMSG_PET_ABANDON                             = 374,	//(0x0176)
	CMSG_PET_RENAME                              = 375,	//(0x0177)
	SMSG_PET_NAME_INVALID                        = 376,	//(0x0178)
	SMSG_PET_SPELLS                              = 377,	//(0x0179)
	SMSG_PET_MODE                                = 378,	//(0x017A)
	CMSG_GOSSIP_HELLO                            = 379,	//(0x017B)
	CMSG_GOSSIP_SELECT_OPTION                    = 380,	//(0x017C)
	SMSG_GOSSIP_MESSAGE                          = 381,	//(0x017D)
	SMSG_GOSSIP_COMPLETE                         = 382,	//(0x017E)
	CMSG_NPC_TEXT_QUERY                          = 383,	//(0x017F)
	SMSG_NPC_TEXT_UPDATE                         = 384,	//(0x0180)
	SMSG_NPC_WONT_TALK                           = 385,	//(0x0181)
	CMSG_QUESTGIVER_STATUS_QUERY                 = 386,	//(0x0182)
	SMSG_QUESTGIVER_STATUS                       = 387,	//(0x0183)
	CMSG_QUESTGIVER_HELLO                        = 388,	//(0x0184)
	SMSG_QUESTGIVER_QUEST_LIST                   = 389,	//(0x0185)
	CMSG_QUESTGIVER_QUERY_QUEST                  = 390,	//(0x0186)
	CMSG_QUESTGIVER_QUEST_AUTOLAUNCH             = 391,	//(0x0187)
	SMSG_QUESTGIVER_QUEST_DETAILS                = 392,	//(0x0188)
	CMSG_QUESTGIVER_ACCEPT_QUEST                 = 393,	//(0x0189)
	CMSG_QUESTGIVER_COMPLETE_QUEST               = 394,	//(0x018A)
	SMSG_QUESTGIVER_REQUEST_ITEMS                = 395,	//(0x018B)
	CMSG_QUESTGIVER_REQUEST_REWARD               = 396,	//(0x018C)
	SMSG_QUESTGIVER_OFFER_REWARD                 = 397,	//(0x018D)
	CMSG_QUESTGIVER_CHOOSE_REWARD                = 398,	//(0x018E)
	SMSG_QUESTGIVER_QUEST_INVALID                = 399,	//(0x018F)
	CMSG_QUESTGIVER_CANCEL                       = 400,	//(0x0190)
	SMSG_QUESTGIVER_QUEST_COMPLETE               = 401,	//(0x0191)
	SMSG_QUESTGIVER_QUEST_FAILED                 = 402,	//(0x0192)
	CMSG_QUESTLOG_SWAP_QUEST                     = 403,	//(0x0193)
	CMSG_QUESTLOG_REMOVE_QUEST                   = 404,	//(0x0194)
	SMSG_QUESTLOG_FULL                           = 405,	//(0x0195)
	SMSG_QUESTUPDATE_FAILED                      = 406,	//(0x0196)
	SMSG_QUESTUPDATE_FAILEDTIMER                 = 407,	//(0x0197)
	SMSG_QUESTUPDATE_COMPLETE                    = 408,	//(0x0198)
	SMSG_QUESTUPDATE_ADD_KILL                    = 409,	//(0x0199)
	SMSG_QUESTUPDATE_ADD_ITEM                    = 410,	//(0x019A)
	CMSG_QUEST_CONFIRM_ACCEPT                    = 411,	//(0x019B)
	SMSG_QUEST_CONFIRM_ACCEPT                    = 412,	//(0x019C)
	CMSG_PUSHQUESTTOPARTY                        = 413,	//(0x019D)
	CMSG_LIST_INVENTORY                          = 414,	//(0x019E)
	SMSG_LIST_INVENTORY                          = 415,	//(0x019F)
	CMSG_SELL_ITEM                               = 416,	//(0x01A0)
	SMSG_SELL_ITEM                               = 417,	//(0x01A1)
	CMSG_BUY_ITEM                                = 418,	//(0x01A2)
	CMSG_BUY_ITEM_IN_SLOT                        = 419,	//(0x01A3)
	SMSG_BUY_ITEM                                = 420,	//(0x01A4)
	SMSG_BUY_FAILED                              = 421,	//(0x01A5)
	CMSG_TAXICLEARALLNODES                       = 422,	//(0x01A6)
	CMSG_TAXIENABLEALLNODES                      = 423,	//(0x01A7)
	CMSG_TAXISHOWNODES                           = 424,	//(0x01A8)
	SMSG_SHOWTAXINODES                           = 425,	//(0x01A9)
	CMSG_TAXINODE_STATUS_QUERY                   = 426,	//(0x01AA)
	SMSG_TAXINODE_STATUS                         = 427,	//(0x01AB)
	CMSG_TAXIQUERYAVAILABLENODES                 = 428,	//(0x01AC)
	CMSG_ACTIVATETAXI                            = 429,	//(0x01AD)
	SMSG_ACTIVATETAXIREPLY                       = 430,	//(0x01AE)
	SMSG_NEW_TAXI_PATH                           = 431,	//(0x01AF)
	CMSG_TRAINER_LIST                            = 432,	//(0x01B0)
	SMSG_TRAINER_LIST                            = 433,	//(0x01B1)
	CMSG_TRAINER_BUY_SPELL                       = 434,	//(0x01B2)
	SMSG_TRAINER_BUY_SUCCEEDED                   = 435,	//(0x01B3)
	SMSG_TRAINER_BUY_FAILED                      = 436,	//(0x01B4)
	CMSG_BINDER_ACTIVATE                         = 437,	//(0x01B5)
	SMSG_PLAYERBINDERROR                         = 438,	//(0x01B6)
	CMSG_BANKER_ACTIVATE                         = 439,	//(0x01B7)
	SMSG_SHOW_BANK                               = 440,	//(0x01B8)
	CMSG_BUY_BANK_SLOT                           = 441,	//(0x01B9)
	SMSG_BUY_BANK_SLOT_RESULT                    = 442,	//(0x01BA)
	CMSG_PETITION_SHOWLIST                       = 443,	//(0x01BB)
	SMSG_PETITION_SHOWLIST                       = 444,	//(0x01BC)
	CMSG_PETITION_BUY                            = 445,	//(0x01BD)
	CMSG_PETITION_SHOW_SIGNATURES                = 446,	//(0x01BE)
	SMSG_PETITION_SHOW_SIGNATURES                = 447,	//(0x01BF)
	CMSG_PETITION_SIGN                           = 448,	//(0x01C0)
	SMSG_PETITION_SIGN_RESULTS                   = 449,	//(0x01C1)
	MSG_PETITION_DECLINE                         = 450,	//(0x01C2)
	CMSG_OFFER_PETITION                          = 451,	//(0x01C3)
	CMSG_TURN_IN_PETITION                        = 452,	//(0x01C4)
	SMSG_TURN_IN_PETITION_RESULTS                = 453,	//(0x01C5)
	CMSG_PETITION_QUERY                          = 454,	//(0x01C6)
	SMSG_PETITION_QUERY_RESPONSE                 = 455,	//(0x01C7)
	SMSG_FISH_NOT_HOOKED                         = 456,	//(0x01C8)
	SMSG_FISH_ESCAPED                            = 457,	//(0x01C9)
	CMSG_BUG                                     = 458,	//(0x01CA)
	SMSG_NOTIFICATION                            = 459,	//(0x01CB)
	CMSG_PLAYED_TIME                             = 460,	//(0x01CC)
	SMSG_PLAYED_TIME                             = 461,	//(0x01CD)
	CMSG_QUERY_TIME                              = 462,	//(0x01CE)
	SMSG_QUERY_TIME_RESPONSE                     = 463,	//(0x01CF)
	SMSG_LOG_XPGAIN                              = 464,	//(0x01D0)
	MSG_SPLIT_MONEY                              = 465,	//(0x01D1)
	CMSG_RECLAIM_CORPSE                          = 466,	//(0x01D2)
	CMSG_WRAP_ITEM                               = 467,	//(0x01D3)
	SMSG_LEVELUP_INFO                            = 468,	//(0x01D4)
	MSG_MINIMAP_PING                             = 469,	//(0x01D5)
	SMSG_RESISTLOG                               = 470,	//(0x01D6)
	SMSG_ENCHANTMENTLOG                          = 471,	//(0x01D7)
	CMSG_SET_SKILL_CHEAT                         = 472,	//(0x01D8)
	SMSG_START_MIRROR_TIMER                      = 473,	//(0x01D9)
	SMSG_PAUSE_MIRROR_TIMER                      = 474,	//(0x01DA)
	SMSG_STOP_MIRROR_TIMER                       = 475,	//(0x01DB)
	CMSG_PING                                    = 476,	//(0x01DC)
	SMSG_PONG                                    = 477,	//(0x01DD)
	SMSG_CLEAR_COOLDOWN                          = 478,	//(0x01DE)
	SMSG_GAMEOBJECT_PAGETEXT                     = 479,	//(0x01DF)
	CMSG_SETSHEATHED                             = 480,	//(0x01E0)
	SMSG_COOLDOWN_CHEAT                          = 481,	//(0x01E1)
	SMSG_SPELL_DELAYED                           = 482,	//(0x01E2)
	CMSG_PLAYER_MACRO_OBSOLETE                   = 483,	//(0x01E3)
	SMSG_PLAYER_MACRO_OBSOLETE                   = 484,	//(0x01E4)
	CMSG_GHOST                                   = 485,	//(0x01E5)
	CMSG_GM_INVIS                                = 486,	//(0x01E6)
	SMSG_INVALID_PROMOTION_CODE                  = 487,	//(0x01E7)
	MSG_GM_BIND_OTHER                            = 488,	//(0x01E8)
	MSG_GM_SUMMON                                = 489,	//(0x01E9)
	SMSG_ITEM_TIME_UPDATE                        = 490,	//(0x01EA)
	SMSG_ITEM_ENCHANT_TIME_UPDATE                = 491,	//(0x01EB)
	SMSG_AUTH_CHALLENGE                          = 492,	//(0x01EC)
	CMSG_AUTH_SESSION                            = 493,	//(0x01ED)
	SMSG_AUTH_RESPONSE                           = 494,	//(0x01EE)
	MSG_GM_SHOWLABEL                             = 495,	//(0x01EF)
	MSG_ADD_DYNAMIC_TARGET_OBSOLETE              = 496,	//(0x01F0)
	MSG_SAVE_GUILD_EMBLEM                        = 497,	//(0x01F1)
	MSG_TABARDVENDOR_ACTIVATE                    = 498,	//(0x01F2)
	SMSG_PLAY_SPELL_VISUAL                       = 499,	//(0x01F3)
	CMSG_ZONEUPDATE                              = 500,	//(0x01F4)
	SMSG_PARTYKILLLOG                            = 501,	//(0x01F5)
	SMSG_COMPRESSED_UPDATE_OBJECT                = 502,	//(0x01F6)
	SMSG_OBSOLETE                                = 503,	//(0x01F7)
	SMSG_EXPLORATION_EXPERIENCE                  = 504,	//(0x01F8)
	CMSG_GM_SET_SECURITY_GROUP                   = 505,	//(0x01F9)
	CMSG_GM_NUKE                                 = 506,	//(0x01FA)
	MSG_RANDOM_ROLL                              = 507,	//(0x01FB)
	SMSG_ENVIRONMENTALDAMAGELOG                  = 508,	//(0x01FC)
	CMSG_RWHOIS                                  = 509,	//(0x01FD)
	SMSG_RWHOIS                                  = 510,	//(0x01FE)
	MSG_LOOKING_FOR_GROUP                        = 511,	//(0x01FF)
	CMSG_SET_LOOKING_FOR_GROUP                   = 512,	//(0x0200)
	CMSG_UNLEARN_SPELL                           = 513,	//(0x0201)
	CMSG_UNLEARN_SKILL                           = 514,	//(0x0202)
	SMSG_REMOVED_SPELL                           = 515,	//(0x0203)
	CMSG_DECHARGE                                = 516,	//(0x0204)
	CMSG_GMTICKET_CREATE                         = 517,	//(0x0205)
	SMSG_GMTICKET_CREATE                         = 518,	//(0x0206)
	CMSG_GMTICKET_UPDATETEXT                     = 519,	//(0x0207)
	SMSG_GMTICKET_UPDATETEXT                     = 520,	//(0x0208)
	SMSG_ACCOUNT_DATA_MD5                        = 521,	//(0x0209)
	CMSG_REQUEST_ACCOUNT_DATA                    = 522,	//(0x020A)
	CMSG_UPDATE_ACCOUNT_DATA                     = 523,	//(0x020B)
	SMSG_UPDATE_ACCOUNT_DATA                     = 524,	//(0x020C)
	SMSG_CLEAR_FAR_SIGHT_IMMEDIATE               = 525,	//(0x020D)
	SMSG_POWERGAINLOG_OBSOLETE                   = 526,	//(0x020E)
	CMSG_GM_TEACH                                = 527,	//(0x020F)
	CMSG_GM_CREATE_ITEM_TARGET                   = 528,	//(0x0210)
	CMSG_GMTICKET_GETTICKET                      = 529,	//(0x0211)
	SMSG_GMTICKET_GETTICKET                      = 530,	//(0x0212)
	CMSG_UNLEARN_TALENTS                         = 531,	//(0x0213)
	SMSG_GAMEOBJECT_SPAWN_ANIM                   = 532,	//(0x0214)
	SMSG_GAMEOBJECT_DESPAWN_ANIM                 = 533,	//(0x0215)
	MSG_CORPSE_QUERY                             = 534,	//(0x0216)
	CMSG_GMTICKET_DELETETICKET                   = 535,	//(0x0217)
	SMSG_GMTICKET_DELETETICKET                   = 536,	//(0x0218)
	SMSG_CHAT_WRONG_FACTION                      = 537,	//(0x0219)
	CMSG_GMTICKET_SYSTEMSTATUS                   = 538,	//(0x021A)
	SMSG_GMTICKET_SYSTEMSTATUS                   = 539,	//(0x021B)
	CMSG_SPIRIT_HEALER_ACTIVATE                  = 540,	//(0x021C)
	CMSG_SET_STAT_CHEAT                          = 541,	//(0x021D)
	SMSG_SET_REST_START                          = 542,	//(0x021E)
	CMSG_SKILL_BUY_STEP                          = 543,	//(0x021F)
	CMSG_SKILL_BUY_RANK                          = 544,	//(0x0220)
	CMSG_XP_CHEAT                                = 545,	//(0x0221)
	SMSG_SPIRIT_HEALER_CONFIRM                   = 546,	//(0x0222)
	CMSG_CHARACTER_POINT_CHEAT                   = 547,	//(0x0223)
	SMSG_GOSSIP_POI                              = 548,	//(0x0224)
	CMSG_CHAT_IGNORED                            = 549,	//(0x0225)
	CMSG_GM_VISION                               = 550,	//(0x0226)
	CMSG_SERVER_COMMAND                          = 551,	//(0x0227)
	CMSG_GM_SILENCE                              = 552,	//(0x0228)
	CMSG_GM_REVEALTO                             = 553,	//(0x0229)
	CMSG_GM_RESURRECT                            = 554,	//(0x022A)
	CMSG_GM_SUMMONMOB                            = 555,	//(0x022B)
	CMSG_GM_MOVECORPSE                           = 556,	//(0x022C)
	CMSG_GM_FREEZE                               = 557,	//(0x022D)
	CMSG_GM_UBERINVIS                            = 558,	//(0x022E)
	CMSG_GM_REQUEST_PLAYER_INFO                  = 559,	//(0x022F)
	SMSG_GM_PLAYER_INFO                          = 560,	//(0x0230)
	CMSG_GUILD_RANK                              = 561,	//(0x0231)
	CMSG_GUILD_ADD_RANK                          = 562,	//(0x0232)
	CMSG_GUILD_DEL_RANK                          = 563,	//(0x0233)
	CMSG_GUILD_SET_PUBLIC_NOTE                   = 564,	//(0x0234)
	CMSG_GUILD_SET_OFFICER_NOTE                  = 565,	//(0x0235)
	SMSG_LOGIN_VERIFY_WORLD                      = 566,	//(0x0236)
	CMSG_CLEAR_EXPLORATION                       = 567,	//(0x0237)
	CMSG_SEND_MAIL                               = 568,	//(0x0238)
	SMSG_SEND_MAIL_RESULT                        = 569,	//(0x0239)
	CMSG_GET_MAIL_LIST                           = 570,	//(0x023A)
	SMSG_MAIL_LIST_RESULT                        = 571,	//(0x023B)
	CMSG_BATTLEFIELD_LIST                        = 572,	//(0x023C)
	SMSG_BATTLEFIELD_LIST                        = 573,	//(0x023D)
	CMSG_BATTLEFIELD_JOIN                        = 574,	//(0x023E)
	SMSG_BATTLEFIELD_WIN                         = 575,	//(0x023F)
	SMSG_BATTLEFIELD_LOSE                        = 576,	//(0x0240)
	CMSG_TAXICLEARNODE                           = 577,	//(0x0241)
	CMSG_TAXIENABLENODE                          = 578,	//(0x0242)
	CMSG_ITEM_TEXT_QUERY                         = 579,	//(0x0243)
	SMSG_ITEM_TEXT_QUERY_RESPONSE                = 580,	//(0x0244)
	CMSG_MAIL_TAKE_MONEY                         = 581,	//(0x0245)
	CMSG_MAIL_TAKE_ITEM                          = 582,	//(0x0246)
	CMSG_MAIL_MARK_AS_READ                       = 583,	//(0x0247)
	CMSG_MAIL_RETURN_TO_SENDER                   = 584,	//(0x0248)
	CMSG_MAIL_DELETE                             = 585,	//(0x0249)
	CMSG_MAIL_CREATE_TEXT_ITEM                   = 586,	//(0x024A)
	SMSG_SPELLLOGMISS                            = 587,	//(0x024B)
	SMSG_SPELLLOGEXECUTE                         = 588,	//(0x024C)
	SMSG_DEBUGAURAPROC                           = 589,	//(0x024D)
	SMSG_PERIODICAURALOG                         = 590,	//(0x024E)
	SMSG_SPELLDAMAGESHIELD                       = 591,	//(0x024F)
	SMSG_SPELLNONMELEEDAMAGELOG                  = 592,	//(0x0250)
	CMSG_LEARN_TALENT                            = 593,	//(0x0251)
	SMSG_RESURRECT_FAILED                        = 594,	//(0x0252)
	CMSG_TOGGLE_PVP                              = 595,	//(0x0253)
	SMSG_ZONE_UNDER_ATTACK                       = 596,	//(0x0254)
	MSG_AUCTION_HELLO                            = 597,	//(0x0255)
	CMSG_AUCTION_SELL_ITEM                       = 598,	//(0x0256)
	CMSG_AUCTION_REMOVE_ITEM                     = 599,	//(0x0257)
	CMSG_AUCTION_LIST_ITEMS                      = 600,	//(0x0258)
	CMSG_AUCTION_LIST_OWNER_ITEMS                = 601,	//(0x0259)
	CMSG_AUCTION_PLACE_BID                       = 602,	//(0x025A)
	SMSG_AUCTION_COMMAND_RESULT                  = 603,	//(0x025B)
	SMSG_AUCTION_LIST_RESULT                     = 604,	//(0x025C)
	SMSG_AUCTION_OWNER_LIST_RESULT               = 605,	//(0x025D)
	SMSG_AUCTION_BIDDER_NOTIFICATION             = 606,	//(0x025E)
	SMSG_AUCTION_OWNER_NOTIFICATION              = 607,	//(0x025F)
	SMSG_PROCRESIST                              = 608,	//(0x0260)
	SMSG_STANDSTATE_CHANGE_FAILURE               = 609,	//(0x0261)
	SMSG_DISPEL_FAILED                           = 610,	//(0x0262)
	SMSG_SPELLORDAMAGE_IMMUNE                    = 611,	//(0x0263)
	CMSG_AUCTION_LIST_BIDDER_ITEMS               = 612,	//(0x0264)
	SMSG_AUCTION_BIDDER_LIST_RESULT              = 613,	//(0x0265)
	SMSG_SET_FLAT_SPELL_MODIFIER                 = 614,	//(0x0266)
	SMSG_SET_PCT_SPELL_MODIFIER                  = 615,	//(0x0267)
	CMSG_SET_AMMO                                = 616,	//(0x0268)
	SMSG_CORPSE_RECLAIM_DELAY                    = 617,	//(0x0269)
	CMSG_SET_ACTIVE_MOVER                        = 618,	//(0x026A)
	CMSG_PET_CANCEL_AURA                         = 619,	//(0x026B)
	CMSG_PLAYER_AI_CHEAT                         = 620,	//(0x026C)
	CMSG_CANCEL_AUTO_REPEAT_SPELL                = 621,	//(0x026D)
	MSG_GM_ACCOUNT_ONLINE                        = 622,	//(0x026E)
	MSG_LIST_STABLED_PETS                        = 623,	//(0x026F)
	CMSG_STABLE_PET                              = 624,	//(0x0270)
	CMSG_UNSTABLE_PET                            = 625,	//(0x0271)
	CMSG_BUY_STABLE_SLOT                         = 626,	//(0x0272)
	SMSG_STABLE_RESULT                           = 627,	//(0x0273)
	CMSG_STABLE_REVIVE_PET                       = 628,	//(0x0274)
	CMSG_STABLE_SWAP_PET                         = 629,	//(0x0275)
	MSG_QUEST_PUSH_RESULT                        = 630,	//(0x0276)
	SMSG_PLAY_MUSIC                              = 631,	//(0x0277)
	SMSG_PLAY_OBJECT_SOUND                       = 632,	//(0x0278)
	CMSG_REQUEST_PET_INFO                        = 633,	//(0x0279)
	CMSG_FAR_SIGHT                               = 634,	//(0x027A)
	SMSG_SPELLDISPELLOG                          = 635,	//(0x027B)
	SMSG_DAMAGE_CALC_LOG                         = 636,	//(0x027C)
	CMSG_ENABLE_DAMAGE_LOG                       = 637,	//(0x027D)
	CMSG_GROUP_CHANGE_SUB_GROUP                  = 638,	//(0x027E)
	CMSG_REQUEST_PARTY_MEMBER_STATS              = 639,	//(0x027F)
	CMSG_GROUP_SWAP_SUB_GROUP                    = 640,	//(0x0280)
	CMSG_RESET_FACTION_CHEAT                     = 641,	//(0x0281)
	CMSG_AUTOSTORE_BANK_ITEM                     = 642,	//(0x0282)
	CMSG_AUTOBANK_ITEM                           = 643,	//(0x0283)
	MSG_QUERY_NEXT_MAIL_TIME                     = 644,	//(0x0284)
	SMSG_RECEIVED_MAIL                           = 645,	//(0x0285)
	SMSG_RAID_GROUP_ONLY                         = 646,	//(0x0286)
	CMSG_SET_DURABILITY_CHEAT                    = 647,	//(0x0287)
	CMSG_SET_PVP_RANK_CHEAT                      = 648,	//(0x0288)
	CMSG_ADD_PVP_MEDAL_CHEAT                     = 649,	//(0x0289)
	CMSG_DEL_PVP_MEDAL_CHEAT                     = 650,	//(0x028A)
	CMSG_SET_PVP_TITLE                           = 651,	//(0x028B)
	SMSG_PVP_CREDIT                              = 652,	//(0x028C)
	SMSG_AUCTION_REMOVED_NOTIFICATION            = 653,	//(0x028D)
	CMSG_GROUP_RAID_CONVERT                      = 654,	//(0x028E)
	CMSG_GROUP_ASSISTANT_LEADER                  = 655,	//(0x028F)
	CMSG_BUYBACK_ITEM                            = 656,	//(0x0290)
	SMSG_SERVER_MESSAGE                          = 657,	//(0x0291)
	CMSG_MEETINGSTONE_JOIN                       = 658,	//(0x0292)
	CMSG_MEETINGSTONE_LEAVE                      = 659,	//(0x0293)
	CMSG_MEETINGSTONE_CHEAT                      = 660,	//(0x0294)
	SMSG_MEETINGSTONE_SETQUEUE                   = 661,	//(0x0295)
	CMSG_MEETINGSTONE_INFO                       = 662,	//(0x0296)
	SMSG_MEETINGSTONE_COMPLETE                   = 663,	//(0x0297)
	SMSG_MEETINGSTONE_IN_PROGRESS                = 664,	//(0x0298)
	SMSG_MEETINGSTONE_MEMBER_ADDED               = 665,	//(0x0299)
	CMSG_GMTICKETSYSTEM_TOGGLE                   = 666,	//(0x029A)
	CMSG_CANCEL_GROWTH_AURA                      = 667,	//(0x029B)
	SMSG_CANCEL_AUTO_REPEAT                      = 668,	//(0x029C)
	SMSG_STANDSTATE_CHANGE_ACK                   = 669,	//(0x029D)
	SMSG_LOOT_ALL_PASSED                         = 670,	//(0x029E)
	SMSG_LOOT_ROLL_WON                           = 671,	//(0x029F)
	CMSG_LOOT_ROLL                               = 672,	//(0x02A0)
	SMSG_LOOT_START_ROLL                         = 673,	//(0x02A1)
	SMSG_LOOT_ROLL                               = 674,	//(0x02A2)
	CMSG_LOOT_MASTER_GIVE                        = 675,	//(0x02A3)
	SMSG_LOOT_MASTER_LIST                        = 676,	//(0x02A4)
	SMSG_SET_FORCED_REACTIONS                    = 677,	//(0x02A5)
	SMSG_SPELL_FAILED_OTHER                      = 678,	//(0x02A6)
	SMSG_GAMEOBJECT_RESET_STATE                  = 679,	//(0x02A7)
	CMSG_REPAIR_ITEM                             = 680,	//(0x02A8)
	SMSG_CHAT_PLAYER_NOT_FOUND                   = 681,	//(0x02A9)
	MSG_TALENT_WIPE_CONFIRM                      = 682,	//(0x02AA)
	SMSG_SUMMON_REQUEST                          = 683,	//(0x02AB)
	CMSG_SUMMON_RESPONSE                         = 684,	//(0x02AC)
	MSG_MOVE_TOGGLE_GRAVITY_CHEAT                = 685,	//(0x02AD)
	SMSG_MONSTER_MOVE_TRANSPORT                  = 686,	//(0x02AE)
	SMSG_PET_BROKEN                              = 687,	//(0x02AF)
	MSG_MOVE_FEATHER_FALL                        = 688,	//(0x02B0)
	MSG_MOVE_WATER_WALK                          = 689,	//(0x02B1)
	CMSG_SERVER_BROADCAST                        = 690,	//(0x02B2)
	CMSG_SELF_RES                                = 691,	//(0x02B3)
	SMSG_FEIGN_DEATH_RESISTED                    = 692,	//(0x02B4)
	CMSG_RUN_SCRIPT                              = 693,	//(0x02B5)
	SMSG_SCRIPT_MESSAGE                          = 694,	//(0x02B6)
	SMSG_DUEL_COUNTDOWN                          = 695,	//(0x02B7)
	SMSG_AREA_TRIGGER_MESSAGE                    = 696,	//(0x02B8)
	CMSG_TOGGLE_HELM                             = 697,	//(0x02B9)
	CMSG_TOGGLE_CLOAK                            = 698,	//(0x02BA)
	SMSG_MEETINGSTONE_JOINFAILED                 = 699,	//(0x02BB)
	SMSG_PLAYER_SKINNED                          = 700,	//(0x02BC)
	SMSG_DURABILITY_DAMAGE_DEATH                 = 701,	//(0x02BD)
	CMSG_SET_EXPLORATION                         = 702,	//(0x02BE)
	CMSG_SET_ACTIONBAR_TOGGLES                   = 703,	//(0x02BF)
	UMSG_DELETE_GUILD_CHARTER                    = 704,	//(0x02C0)
	MSG_PETITION_RENAME                          = 705,	//(0x02C1)
	SMSG_INIT_WORLD_STATES                       = 706,	//(0x02C2)
	SMSG_UPDATE_WORLD_STATE                      = 707,	//(0x02C3)
	CMSG_ITEM_NAME_QUERY                         = 708,	//(0x02C4)
	SMSG_ITEM_NAME_QUERY_RESPONSE                = 709,	//(0x02C5)
	SMSG_PET_ACTION_FEEDBACK                     = 710,	//(0x02C6)
	CMSG_CHAR_RENAME                             = 711,	//(0x02C7)
	SMSG_CHAR_RENAME                             = 712,	//(0x02C8)
	CMSG_MOVE_SPLINE_DONE                        = 713,	//(0x02C9)
	CMSG_MOVE_FALL_RESET                         = 714,	//(0x02CA)
	SMSG_INSTANCE_SAVE_CREATED                   = 715,	//(0x02CB)
	SMSG_RAID_INSTANCE_INFO                      = 716,	//(0x02CC)
	CMSG_REQUEST_RAID_INFO                       = 717,	//(0x02CD)
	CMSG_MOVE_TIME_SKIPPED                       = 718,	//(0x02CE)
	CMSG_MOVE_FEATHER_FALL_ACK                   = 719,	//(0x02CF)
	CMSG_MOVE_WATER_WALK_ACK                     = 720,	//(0x02D0)
	CMSG_MOVE_NOT_ACTIVE_MOVER                   = 721,	//(0x02D1)
	SMSG_PLAY_SOUND                              = 722,	//(0x02D2)
	CMSG_BATTLEFIELD_STATUS                      = 723,	//(0x02D3)
	SMSG_BATTLEFIELD_STATUS                      = 724,	//(0x02D4)
	CMSG_BATTLEFIELD_PORT                        = 725,	//(0x02D5)
	MSG_INSPECT_HONOR_STATS                      = 726,	//(0x02D6)
	CMSG_BATTLEMASTER_HELLO                      = 727,	//(0x02D7)
	CMSG_MOVE_START_SWIM_CHEAT                   = 728,	//(0x02D8)
	CMSG_MOVE_STOP_SWIM_CHEAT                    = 729,	//(0x02D9)
	SMSG_FORCE_WALK_SPEED_CHANGE                 = 730,	//(0x02DA)
	CMSG_FORCE_WALK_SPEED_CHANGE_ACK             = 731,	//(0x02DB)
	SMSG_FORCE_SWIM_BACK_SPEED_CHANGE            = 732,	//(0x02DC)
	CMSG_FORCE_SWIM_BACK_SPEED_CHANGE_ACK        = 733,	//(0x02DD)
	SMSG_FORCE_TURN_RATE_CHANGE                  = 734,	//(0x02DE)
	CMSG_FORCE_TURN_RATE_CHANGE_ACK              = 735,	//(0x02DF)
	MSG_PVP_LOG_DATA                             = 736,	//(0x02E0)
	CMSG_LEAVE_BATTLEFIELD                       = 737,	//(0x02E1)
	CMSG_AREA_SPIRIT_HEALER_QUERY                = 738,	//(0x02E2)
	CMSG_AREA_SPIRIT_HEALER_QUEUE                = 739,	//(0x02E3)
	SMSG_AREA_SPIRIT_HEALER_TIME                 = 740,	//(0x02E4)
	CMSG_GM_UNTEACH                              = 741,	//(0x02E5)
	SMSG_WARDEN_DATA                             = 742,	//(0x02E6)
	CMSG_WARDEN_DATA                             = 743,	//(0x02E7)
	SMSG_GROUP_JOINED_BATTLEGROUND               = 744,	//(0x02E8)
	MSG_BATTLEGROUND_PLAYER_POSITIONS            = 745,	//(0x02E9)
	CMSG_PET_STOP_ATTACK                         = 746,	//(0x02EA)
	SMSG_BINDER_CONFIRM                          = 747,	//(0x02EB)
	SMSG_BATTLEGROUND_PLAYER_JOINED              = 748,	//(0x02EC)
	SMSG_BATTLEGROUND_PLAYER_LEFT                = 749,	//(0x02ED)
	CMSG_BATTLEMASTER_JOIN                       = 750,	//(0x02EE)
	SMSG_ADDON_INFO                              = 751,	//(0x02EF)
	CMSG_PET_UNLEARN                             = 754,	//(0x02F2)
	SMSG_PET_UNLEARN_CONFIRM                     = 755,	//(0x02F3)
	SMSG_WEATHER                                 = 756,	//(0x02F4)
	CMSG_PET_SPELL_AUTOCAST                      = 757,	//(0x02F5)
	SMSG_PARTY_MEMBER_STATS_FULL                 = 758,	//(0x02F6)
	SMSG_PLAY_TIME_WARNING                       = 759,	//(0x02F7)
	SMSG_MINIGAME_SETUP                          = 758,	//(0x02F6)
	SMSG_MINIGAME_STATE                          = 759,	//(0x02F7)
	CMSG_MINIGAME_MOVE                           = 760,	//(0x02F8)
	SMSG_MINIGAME_MOVE_FAILED                    = 761,	//(0x02F9)
	SMSG_PET_TAME_UNK                            = 763,	//(0x02FB)
	CMSG_SET_GUILD_INFORMATION                   = 764,	//(0x02FC)
	SMSG_SET_WALK_SPEED                          = 766,	//(0x02FE)
	SMSG_SET_RUN_BACK_SPEED                      = 767,	//(0x02FF)
	SMSG_SET_SWIM_SPEED                          = 768,	//(0x0300)
	SMSG_SET_SWIM_BACK_SPEED                     = 770,	//(0x0302)
	SMSG_SET_TURN_RATE                           = 771,	//(0x0303)
	SMSG_UNKNOWN_PET                             = 772,	//(0x0304)
	SMSG_MOVE_SET_WATER_WALK                     = 777,	//(0x0309)
	SMSG_MOVE_SET_LAND_WALK                      = 778,	//(0x030A)
	SMSG_MOVE_STOP_WALK                          = 781,	//(0x030D)
	SMSG_MOVE_START_WALK                         = 782,	//(0x030E)
	CMSG_ACTIVATE_MULTIPLE_TAXI                  = 786,	//(0x0312)
	CMSG_SET_FACTION_INACTIVE                    = 791,	//(0x0317)
	CMSG_SET_WATCHED_FACTION_INDEX               = 792,	//(0x0318)
	CMSG_UNKNOWN_1                               = 793,	//(0x0319)
	SMSG_UNKNOWN_DEMON                           = 794,	//(0x031A)
	CMSG_RESET_INSTANCE                          = 797,	//(0x031D)
	SMSG_RESET_INSTANCE                          = 798,	//(0x031E)
	SMSG_INSTANCE_SAVE                           = 800,	//(0x0320)
	MSG_GROUP_SET_PLAYER_ICON                    = 801,	//(0x0321)
	CMSG_RAID_READYCHECK                         = 802,	//(0x0322)
	SMSG_PET_ACTION_SOUND                        = 804,	//(0x0324)
	SMSG_PET_DISMISS_SOUND                       = 805,	//(0x0325)
	CMSG_DUNGEON_DIFFICULTY                      = 809,	//(0x0329)
	SMSG_SET_ANTISPAM_REGEX                      = 818,	//(0x0332)
	SMSG_INSTANCE_RESET_ACTIVATE                 = 811,	//(0x032B)
	SMSG_PVP_CAPTURE_STATE_MSG                   = 826,	//(0x033A)
	SMSG_PVP_NOTIFY                              = 827,	//(0x033B)
	SMSG_BROADCAST_MSG                           = 829,	//(0x033D)
	SMSG_MOVE_SET_FLY                            = 835,	//(0x0343)
	SMSG_MOVE_SET_UNFLY                          = 836,	//(0x0344)
	CMSG_MOVE_SET_FLY_ACK                        = 837,	//(0x0345)
	CMSG_MOVE_FLY_START_AND_END                  = 838,	//(0x0346)
	CMSG_SOCKET_GEMS                             = 839,	//(0x0347)
	SMSG_ARENA_TEAM_COMMAND_RESULT               = 841,	//(0x0349)
	SMSG_ARENA_TEAM_QUERY                        = 843,	//(0x034B)
	SMSG_ARENA_TEAM_QUERY_RESPONSE               = 844,	//(0x034C)
	CMSG_ARENA_TEAM_ROSTER                       = 845,	//(0x034D)
	SMSG_ARENA_TEAM_ROSTER                       = 846,	//(0x034E)
	CMSG_ARENA_TEAM_ADD_MEMBER                   = 847,	//(0x034F)
	SMSG_ARENA_TEAM_INVITE                       = 848,	//(0x0350)
	SMSG_ARENA_TEAM_INVITE_ACCEPT                = 849,	//(0x0351)
	SMSG_ARENA_TEAM_INVITE_DECLINE               = 850,	//(0x0352)
	CMSG_ARENA_TEAM_LEAVE                        = 851,	//(0x0353)
	CMSG_ARENA_TEAM_REMOVE_PLAYER                = 852,	//(0x0354)
	CMSG_ARENA_TEAM_DISBAND                      = 853,	//(0x0355)
	CMSG_ARENA_TEAM_PROMOTE                      = 854,	//(0x0356)
	CMSG_ARENA_JOIN                              = 856,	//(0x0358)
	CMSG_FLY_PITCH_UP_Z                          = 857,	//(0x0359)
	CMSG_FLY_PITCH_DOWN_AFTER_UP                 = 858,	//(0x035A)
	SMSG_ARENA_TEAM_STATS                        = 859,	//(0x035B)
	CMSG_ENABLE_AUTOJOIN                         = 860,	//(0x035C)
	CMSG_DISABLE_AUTOJOIN                        = 861,	//(0x035D)
	CMSG_ENABLE_AUTOADD_MEMBERS                  = 862,	//(0x035E)
	CMSG_DISABLE_AUTOADD_MEMBERS                 = 863,	//(0x035F)
	CMSG_LFG_INVITE_ACCEPT                       = 864,	//(0x0360)
	CMSG_LFG_INVITE_CANCEL                       = 865,	//(0x0361)
	CMSG_CLEAR_LOOKING_FOR_GROUP_STATE           = 867,	//(0x0363)
	CMSG_SET_LOOKING_FOR_NONE                    = 868,	//(0x0364)
	CMSG_SET_LOOKING_FOR_MORE                    = 869,	//(0x0365)
	CMSG_SET_LOOKING_FOR_GROUP_COMMENT           = 870,	//(0x0366)
	SMSG_LFG_INVITE                              = 880,	//(0x0370)
	SMSG_SET_VISIBLE_RANK                        = 883,	//(0x0373)
	CMSG_SET_VISIBLE_RANK                        = 884,	//(0x0374)
	CMSG_DISMOUNT                                = 885,	//(0x0375)
	SMSG_ARENA_NO_TEAM                           = 886,	//(0x0376)
	MSG_INSPECT_ARENA_STATS                      = 887,	//(0x0377)
	SMSG_SPIRIT_HEALER_POS                       = 888,	//(0x0378)
	CMSG_CANCEL_TEMPORARY_ENCHANTMENT            = 889,	//(0x0379)
	SMSG_MOVE_SET_FLY_SPEED                      = 894,	//(0x037E)
	CMSG_MOVE_SET_FLY_SPEED_ACK                  = 895,	//(0x037F)
	SMSG_MOVE_SET_FLY_BACK_SPEED                 = 896,	//(0x0380)
	SMSG_FORCE_MOVE_SET_FLY_SPEED                = 897,	//(0x0381)
	CMSG_FORCE_MOVE_SET_FLY_SPEED_ACK            = 898,	//(0x0382)
	SMSG_FORCE_FLY_BACK_SPEED_CHANGE             = 899,	//(0x0383)
	CMSG_FORCE_FLY_BACK_SPEED_CHANGE_ACK         = 900,	//(0x0384)
	SMSG_FLIGHT_SPLINE_SYNC                      = 904,	//(0x0388)
	SMSG_REALM_SPLIT_STATE_RESPONSE              = 907,	//(0x038B)
	CMSG_REALM_SPLIT_STATE_REQUEST               = 908,	//(0x038C)
    CMSG_TRANSPORT_STEP_IN_OUT                   = 909, //(0x038D)
	CMSG_GROUP_PROMOTE                           = 910,	//(0x038E)
	SMSG_TICKCOUNT_QUERY                         = 912,	//(0x0390)
	CMSG_TICKCOUNT_QUERY_RESPONSE                = 913,	//(0x0391)
	SMSG_MOVE_UNLOCK_MOVEMENT                    = 912,	//(0x0390)
	CMSG_MOVE_UNLOCK_MOVEMENT_ACK                = 913,	//(0x0391)
	SMSG_SET_COMBO_POINTS                        = 925,	//(0x039D)
	SMSG_PET_LEARNT_SPELL                        = 932,	//(0x03A4)
	SMSG_TARGET_CAST_RESULT                      = 934,	//(0x03A6)
	MSG_MOVE_FLY_DOWN_UNK						 = 935, //(0x03A7)
	CMSG_REPORT_SPAM                             = 953,	//(0x03B9)
	SMSG_REPORT_SPAM_RESPONSE                    = 954,	//(0x03BA)
	SMSG_ACTIVATE_SPAM_REPORTING                 = 955,	//(0x03BB)
	NUM_MSG_TYPES                                = 956,	//(0x03BC)
};

enum FriendsResult {
	FRIEND_DB_ERROR		 = 0x00,
	FRIEND_LIST_FULL		= 0x01,
	FRIEND_ONLINE		   = 0x02,
	FRIEND_OFFLINE		  = 0x03,
	FRIEND_NOT_FOUND		= 0x04,
	FRIEND_REMOVED		  = 0x05,
	FRIEND_ADDED_ONLINE	 = 0x06,
	FRIEND_ADDED_OFFLINE	= 0x07,
	FRIEND_ALREADY		  = 0x08,
	FRIEND_SELF			 = 0x09,
	FRIEND_ENEMY			= 0x0A,
	FRIEND_IGNORE_FULL	  = 0x0B,
	FRIEND_IGNORE_SELF	  = 0x0C,
	FRIEND_IGNORE_NOT_FOUND = 0x0D,
	FRIEND_IGNORE_ALREADY   = 0x0E,
	FRIEND_IGNORE_ADDED	 = 0x0F,
	FRIEND_IGNORE_REMOVED   = 0x10
};


/*
0 = Universal
1 = ?Orcish?
2 = Darnassian
3 = Taurahe
4 = ?
5 = ?
6 = Dwarvish
7 = Common
8 = Demonic
9 = Titan
10 = Thelassian
11 = Draconic
12 = Kalimag
13 = Gnomish
14 = Troll
*/


enum NPCFlags {
	UNIT_NPC_FLAG_NONE			  = 0,	// None
	UNIT_NPC_FLAG_GOSSIP			= 1,	// Gossip/Talk (CMSG_GOSSIP_HELLO, ?)
	UNIT_NPC_FLAG_QUESTGIVER		= 2,	// Questgiver
	UNIT_NPC_FLAG_VENDOR			= 4,	// Vendor (CMSG_LIST_INVENTORY, SMSG_LIST_INVENTORY)
	UNIT_NPC_FLAG_TAXIVENDOR		= 8,	// Taxi Vendor (CMSG_TAXIQUERYAVAILABLENODES, SMSG_SHOWTAXINODES)
	UNIT_NPC_FLAG_TRAINER		   = 16,   // Trainer (CMSG_TRAINER_LIST, SMSG_TRAINER_LIST)
	UNIT_NPC_FLAG_SPIRITHEALER	  = 32,   // Spirithealer (CMSG_BINDER_ACTIVATE, ?)
	UNIT_NPC_FLAG_INNKEEPER		 = 128,  // Innkeeper Asking for Bind Point
	UNIT_NPC_FLAG_BANKER			= 256,  // Banker
	UNIT_NPC_FLAG_ARENACHARTER	  = 512,  // Purchase an arena charter.. huh?
	UNIT_NPC_FLAG_TABARDCHANGER	 = 1024, // Tabard Design Changer Flag
	UNIT_NPC_FLAG_PETITIONER		= 1536, // Guild Master
	UNIT_NPC_FLAG_TABARDVENDOR	  = 1540,
	UNIT_NPC_FLAG_BATTLEFIELDPERSON = 2048, // BattleMaster (CMSG_BATTLEMASTER_HELLO (0x02D7))
	UNIT_NPC_FLAG_AUCTIONEER		= 4096, // Auctioneer (MSG_AUCTION_HELLO)
	UNIT_NPC_FLAG_STABLEMASTER	  = 8192, // (MSG_LIST_STABLED_PETS (0x026F))
	UNIT_NPC_FLAG_ARMORER		   = 16384,// not sure
};

//enum FieldFlags {
//	0x00000008 == can't climb slopes too steep
//	0x40000000 == sheathed
//};

#endif
