/*
 * Ascent MMORPG Server
 * Copyright (C) 2005-2007 Ascent Team <http://www.ascentemu.com/>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef __ASCENT_UPDATEFIELDS_H
#define __ASCENT_UPDATEFIELDS_H

// Object Fields
#define OBJECT_FIELD_GUID										  0x000
#define OBJECT_FIELD_GUID_01									   0x001
#define OBJECT_FIELD_TYPE										  0x002
#define OBJECT_FIELD_ENTRY										 0x003
#define OBJECT_FIELD_SCALE_X									   0x004
#define OBJECT_FIELD_PADDING									   0x005
#define OBJECT_END												0x006

// Item Fields
#define ITEM_FIELD_OWNER										   OBJECT_END + 0x000
#define ITEM_FIELD_OWNER_01										OBJECT_END + 0x001
#define ITEM_FIELD_CONTAINED									   OBJECT_END + 0x002
#define ITEM_FIELD_CONTAINED_01									OBJECT_END + 0x003
#define ITEM_FIELD_CREATOR										 OBJECT_END + 0x004
#define ITEM_FIELD_CREATOR_01									  OBJECT_END + 0x005
#define ITEM_FIELD_GIFTCREATOR									 OBJECT_END + 0x006
#define ITEM_FIELD_GIFTCREATOR_01								  OBJECT_END + 0x007
#define ITEM_FIELD_STACK_COUNT									 OBJECT_END + 0x008
#define ITEM_FIELD_DURATION										OBJECT_END + 0x009
#define ITEM_FIELD_SPELL_CHARGES								   OBJECT_END + 0x00A
#define ITEM_FIELD_SPELL_CHARGES_01								OBJECT_END + 0x00B
#define ITEM_FIELD_SPELL_CHARGES_02								OBJECT_END + 0x00C
#define ITEM_FIELD_SPELL_CHARGES_03								OBJECT_END + 0x00D
#define ITEM_FIELD_SPELL_CHARGES_04								OBJECT_END + 0x00E
#define ITEM_FIELD_FLAGS										   OBJECT_END + 0x00F
#define ITEM_FIELD_ENCHANTMENT									 OBJECT_END + 0x010
#define ITEM_FIELD_ENCHANTMENT_01								  OBJECT_END + 0x011
#define ITEM_FIELD_ENCHANTMENT_02								  OBJECT_END + 0x012
#define ITEM_FIELD_ENCHANTMENT_03								  OBJECT_END + 0x013
#define ITEM_FIELD_ENCHANTMENT_04								  OBJECT_END + 0x014
#define ITEM_FIELD_ENCHANTMENT_05								  OBJECT_END + 0x015
#define ITEM_FIELD_ENCHANTMENT_06								  OBJECT_END + 0x016
#define ITEM_FIELD_ENCHANTMENT_07								  OBJECT_END + 0x017
#define ITEM_FIELD_ENCHANTMENT_08								  OBJECT_END + 0x018
#define ITEM_FIELD_ENCHANTMENT_09								  OBJECT_END + 0x019
#define ITEM_FIELD_ENCHANTMENT_10								  OBJECT_END + 0x01A
#define ITEM_FIELD_ENCHANTMENT_11								  OBJECT_END + 0x01B
#define ITEM_FIELD_ENCHANTMENT_12								  OBJECT_END + 0x01C
#define ITEM_FIELD_ENCHANTMENT_13								  OBJECT_END + 0x01D
#define ITEM_FIELD_ENCHANTMENT_14								  OBJECT_END + 0x01E
#define ITEM_FIELD_ENCHANTMENT_15								  OBJECT_END + 0x01F
#define ITEM_FIELD_ENCHANTMENT_16								  OBJECT_END + 0x020
#define ITEM_FIELD_ENCHANTMENT_17								  OBJECT_END + 0x021
#define ITEM_FIELD_ENCHANTMENT_18								  OBJECT_END + 0x022
#define ITEM_FIELD_ENCHANTMENT_19								  OBJECT_END + 0x023
#define ITEM_FIELD_ENCHANTMENT_20								  OBJECT_END + 0x024
#define ITEM_FIELD_ENCHANTMENT_21								  OBJECT_END + 0x025
#define ITEM_FIELD_ENCHANTMENT_22								  OBJECT_END + 0x026
#define ITEM_FIELD_ENCHANTMENT_23								  OBJECT_END + 0x027
#define ITEM_FIELD_ENCHANTMENT_24								  OBJECT_END + 0x028
#define ITEM_FIELD_ENCHANTMENT_25								  OBJECT_END + 0x029
#define ITEM_FIELD_ENCHANTMENT_26								  OBJECT_END + 0x02A
#define ITEM_FIELD_ENCHANTMENT_27								  OBJECT_END + 0x02B
#define ITEM_FIELD_ENCHANTMENT_28								  OBJECT_END + 0x02C
#define ITEM_FIELD_ENCHANTMENT_29								  OBJECT_END + 0x02D
#define ITEM_FIELD_ENCHANTMENT_30								  OBJECT_END + 0x02E
#define ITEM_FIELD_ENCHANTMENT_31								  OBJECT_END + 0x02F
#define ITEM_FIELD_ENCHANTMENT_32								  OBJECT_END + 0x030
#define ITEM_FIELD_PROPERTY_SEED								   OBJECT_END + 0x031
#define ITEM_FIELD_RANDOM_PROPERTIES_ID							OBJECT_END + 0x032
#define ITEM_FIELD_ITEM_TEXT_ID									OBJECT_END + 0x033
#define ITEM_FIELD_DURABILITY									  OBJECT_END + 0x034
#define ITEM_FIELD_MAXDURABILITY								   OBJECT_END + 0x035
#define ITEM_END												OBJECT_END + 0x036

// Container Fields
#define CONTAINER_FIELD_NUM_SLOTS								  ITEM_END + 0x000
#define CONTAINER_ALIGN_PAD										ITEM_END + 0x001
#define CONTAINER_FIELD_SLOT_1									 ITEM_END + 0x002
#define CONTAINER_FIELD_SLOT_01									ITEM_END + 0x003
#define CONTAINER_FIELD_SLOT_02									ITEM_END + 0x004
#define CONTAINER_FIELD_SLOT_03									ITEM_END + 0x005
#define CONTAINER_FIELD_SLOT_04									ITEM_END + 0x006
#define CONTAINER_FIELD_SLOT_05									ITEM_END + 0x007
#define CONTAINER_FIELD_SLOT_06									ITEM_END + 0x008
#define CONTAINER_FIELD_SLOT_07									ITEM_END + 0x009
#define CONTAINER_FIELD_SLOT_08									ITEM_END + 0x00A
#define CONTAINER_FIELD_SLOT_09									ITEM_END + 0x00B
#define CONTAINER_FIELD_SLOT_10									ITEM_END + 0x00C
#define CONTAINER_FIELD_SLOT_11									ITEM_END + 0x00D
#define CONTAINER_FIELD_SLOT_12									ITEM_END + 0x00E
#define CONTAINER_FIELD_SLOT_13									ITEM_END + 0x00F
#define CONTAINER_FIELD_SLOT_14									ITEM_END + 0x010
#define CONTAINER_FIELD_SLOT_15									ITEM_END + 0x011
#define CONTAINER_FIELD_SLOT_16									ITEM_END + 0x012
#define CONTAINER_FIELD_SLOT_17									ITEM_END + 0x013
#define CONTAINER_FIELD_SLOT_18									ITEM_END + 0x014
#define CONTAINER_FIELD_SLOT_19									ITEM_END + 0x015
#define CONTAINER_FIELD_SLOT_20									ITEM_END + 0x016
#define CONTAINER_FIELD_SLOT_21									ITEM_END + 0x017
#define CONTAINER_FIELD_SLOT_22									ITEM_END + 0x018
#define CONTAINER_FIELD_SLOT_23									ITEM_END + 0x019
#define CONTAINER_FIELD_SLOT_24									ITEM_END + 0x01A
#define CONTAINER_FIELD_SLOT_25									ITEM_END + 0x01B
#define CONTAINER_FIELD_SLOT_26									ITEM_END + 0x01C
#define CONTAINER_FIELD_SLOT_27									ITEM_END + 0x01D
#define CONTAINER_FIELD_SLOT_28									ITEM_END + 0x01E
#define CONTAINER_FIELD_SLOT_29									ITEM_END + 0x01F
#define CONTAINER_FIELD_SLOT_30									ITEM_END + 0x020
#define CONTAINER_FIELD_SLOT_31									ITEM_END + 0x021
#define CONTAINER_FIELD_SLOT_32									ITEM_END + 0x022
#define CONTAINER_FIELD_SLOT_33									ITEM_END + 0x023
#define CONTAINER_FIELD_SLOT_34									ITEM_END + 0x024
#define CONTAINER_FIELD_SLOT_35									ITEM_END + 0x025
#define CONTAINER_FIELD_SLOT_36									ITEM_END + 0x026
#define CONTAINER_FIELD_SLOT_37									ITEM_END + 0x027
#define CONTAINER_FIELD_SLOT_38									ITEM_END + 0x028
#define CONTAINER_FIELD_SLOT_39									ITEM_END + 0x029
#define CONTAINER_FIELD_SLOT_40									ITEM_END + 0x02A
#define CONTAINER_FIELD_SLOT_41									ITEM_END + 0x02B
#define CONTAINER_FIELD_SLOT_42									ITEM_END + 0x02C
#define CONTAINER_FIELD_SLOT_43									ITEM_END + 0x02D
#define CONTAINER_FIELD_SLOT_44									ITEM_END + 0x02E
#define CONTAINER_FIELD_SLOT_45									ITEM_END + 0x02F
#define CONTAINER_FIELD_SLOT_46									ITEM_END + 0x030
#define CONTAINER_FIELD_SLOT_47									ITEM_END + 0x031
#define CONTAINER_FIELD_SLOT_48									ITEM_END + 0x032
#define CONTAINER_FIELD_SLOT_49									ITEM_END + 0x033
#define CONTAINER_FIELD_SLOT_50									ITEM_END + 0x034
#define CONTAINER_FIELD_SLOT_51									ITEM_END + 0x035
#define CONTAINER_FIELD_SLOT_52									ITEM_END + 0x036
#define CONTAINER_FIELD_SLOT_53									ITEM_END + 0x037
#define CONTAINER_FIELD_SLOT_54									ITEM_END + 0x038
#define CONTAINER_FIELD_SLOT_55									ITEM_END + 0x039
#define CONTAINER_FIELD_SLOT_56									ITEM_END + 0x03A
#define CONTAINER_FIELD_SLOT_57									ITEM_END + 0x03B
#define CONTAINER_FIELD_SLOT_58									ITEM_END + 0x03C
#define CONTAINER_FIELD_SLOT_59									ITEM_END + 0x03D
#define CONTAINER_FIELD_SLOT_60									ITEM_END + 0x03E
#define CONTAINER_FIELD_SLOT_61									ITEM_END + 0x03F
#define CONTAINER_FIELD_SLOT_62									ITEM_END + 0x040
#define CONTAINER_FIELD_SLOT_63									ITEM_END + 0x041
#define CONTAINER_FIELD_SLOT_64									ITEM_END + 0x042
#define CONTAINER_FIELD_SLOT_65									ITEM_END + 0x043
#define CONTAINER_FIELD_SLOT_66									ITEM_END + 0x044
#define CONTAINER_FIELD_SLOT_67									ITEM_END + 0x045
#define CONTAINER_FIELD_SLOT_68									ITEM_END + 0x046
#define CONTAINER_FIELD_SLOT_69									ITEM_END + 0x047
#define CONTAINER_FIELD_SLOT_70									ITEM_END + 0x048
#define CONTAINER_FIELD_SLOT_71									ITEM_END + 0x049
#define CONTAINER_END											ITEM_END + 0x04A

// Unit Fields
#define UNIT_FIELD_CHARM										   OBJECT_END + 0x000
#define UNIT_FIELD_CHARM_01										OBJECT_END + 0x001
#define UNIT_FIELD_SUMMON										  OBJECT_END + 0x002
#define UNIT_FIELD_SUMMON_01									   OBJECT_END + 0x003
#define UNIT_FIELD_CHARMEDBY									   OBJECT_END + 0x004
#define UNIT_FIELD_CHARMEDBY_01									OBJECT_END + 0x005
#define UNIT_FIELD_SUMMONEDBY									  OBJECT_END + 0x006
#define UNIT_FIELD_SUMMONEDBY_01								   OBJECT_END + 0x007
#define UNIT_FIELD_CREATEDBY									   OBJECT_END + 0x008
#define UNIT_FIELD_CREATEDBY_01									OBJECT_END + 0x009
#define UNIT_FIELD_TARGET										  OBJECT_END + 0x00A
#define UNIT_FIELD_TARGET_01									   OBJECT_END + 0x00B
#define UNIT_FIELD_PERSUADED									   OBJECT_END + 0x00C
#define UNIT_FIELD_PERSUADED_01									OBJECT_END + 0x00D
#define UNIT_FIELD_CHANNEL_OBJECT								  OBJECT_END + 0x00E
#define UNIT_FIELD_CHANNEL_OBJECT_01							   OBJECT_END + 0x00F
#define UNIT_FIELD_HEALTH										  OBJECT_END + 0x010
#define UNIT_FIELD_POWER1										  OBJECT_END + 0x011
#define UNIT_FIELD_POWER2										  OBJECT_END + 0x012
#define UNIT_FIELD_POWER3										  OBJECT_END + 0x013
#define UNIT_FIELD_POWER4										  OBJECT_END + 0x014
#define UNIT_FIELD_POWER5										  OBJECT_END + 0x015
#define UNIT_FIELD_MAXHEALTH									   OBJECT_END + 0x016
#define UNIT_FIELD_MAXPOWER1									   OBJECT_END + 0x017
#define UNIT_FIELD_MAXPOWER2									   OBJECT_END + 0x018
#define UNIT_FIELD_MAXPOWER3									   OBJECT_END + 0x019
#define UNIT_FIELD_MAXPOWER4									   OBJECT_END + 0x01A
#define UNIT_FIELD_MAXPOWER5									   OBJECT_END + 0x01B
#define UNIT_FIELD_LEVEL										   OBJECT_END + 0x01C
#define UNIT_FIELD_FACTIONTEMPLATE								 OBJECT_END + 0x01D
#define UNIT_FIELD_BYTES_0										 OBJECT_END + 0x01E
#define UNIT_VIRTUAL_ITEM_SLOT_DISPLAY							 OBJECT_END + 0x01F
#define UNIT_VIRTUAL_ITEM_SLOT_DISPLAY_01						  OBJECT_END + 0x020
#define UNIT_VIRTUAL_ITEM_SLOT_DISPLAY_02						  OBJECT_END + 0x021
#define UNIT_VIRTUAL_ITEM_INFO									 OBJECT_END + 0x022
#define UNIT_VIRTUAL_ITEM_INFO_01								  OBJECT_END + 0x023
#define UNIT_VIRTUAL_ITEM_INFO_02								  OBJECT_END + 0x024
#define UNIT_VIRTUAL_ITEM_INFO_03								  OBJECT_END + 0x025
#define UNIT_VIRTUAL_ITEM_INFO_04								  OBJECT_END + 0x026
#define UNIT_VIRTUAL_ITEM_INFO_05								  OBJECT_END + 0x027
#define UNIT_FIELD_FLAGS										   OBJECT_END + 0x028
#define UNIT_FIELD_FLAGS_2										 OBJECT_END + 0x029
#define UNIT_FIELD_AURA											OBJECT_END + 0x02A
#define UNIT_FIELD_AURA_01										 OBJECT_END + 0x02B
#define UNIT_FIELD_AURA_02										 OBJECT_END + 0x02C
#define UNIT_FIELD_AURA_03										 OBJECT_END + 0x02D
#define UNIT_FIELD_AURA_04										 OBJECT_END + 0x02E
#define UNIT_FIELD_AURA_05										 OBJECT_END + 0x02F
#define UNIT_FIELD_AURA_06										 OBJECT_END + 0x030
#define UNIT_FIELD_AURA_07										 OBJECT_END + 0x031
#define UNIT_FIELD_AURA_08										 OBJECT_END + 0x032
#define UNIT_FIELD_AURA_09										 OBJECT_END + 0x033
#define UNIT_FIELD_AURA_10										 OBJECT_END + 0x034
#define UNIT_FIELD_AURA_11										 OBJECT_END + 0x035
#define UNIT_FIELD_AURA_12										 OBJECT_END + 0x036
#define UNIT_FIELD_AURA_13										 OBJECT_END + 0x037
#define UNIT_FIELD_AURA_14										 OBJECT_END + 0x038
#define UNIT_FIELD_AURA_15										 OBJECT_END + 0x039
#define UNIT_FIELD_AURA_16										 OBJECT_END + 0x03A
#define UNIT_FIELD_AURA_17										 OBJECT_END + 0x03B
#define UNIT_FIELD_AURA_18										 OBJECT_END + 0x03C
#define UNIT_FIELD_AURA_19										 OBJECT_END + 0x03D
#define UNIT_FIELD_AURA_20										 OBJECT_END + 0x03E
#define UNIT_FIELD_AURA_21										 OBJECT_END + 0x03F
#define UNIT_FIELD_AURA_22										 OBJECT_END + 0x040
#define UNIT_FIELD_AURA_23										 OBJECT_END + 0x041
#define UNIT_FIELD_AURA_24										 OBJECT_END + 0x042
#define UNIT_FIELD_AURA_25										 OBJECT_END + 0x043
#define UNIT_FIELD_AURA_26										 OBJECT_END + 0x044
#define UNIT_FIELD_AURA_27										 OBJECT_END + 0x045
#define UNIT_FIELD_AURA_28										 OBJECT_END + 0x046
#define UNIT_FIELD_AURA_29										 OBJECT_END + 0x047
#define UNIT_FIELD_AURA_30										 OBJECT_END + 0x048
#define UNIT_FIELD_AURA_31										 OBJECT_END + 0x049
#define UNIT_FIELD_AURA_32										 OBJECT_END + 0x04A
#define UNIT_FIELD_AURA_33										 OBJECT_END + 0x04B
#define UNIT_FIELD_AURA_34										 OBJECT_END + 0x04C
#define UNIT_FIELD_AURA_35										 OBJECT_END + 0x04D
#define UNIT_FIELD_AURA_36										 OBJECT_END + 0x04E
#define UNIT_FIELD_AURA_37										 OBJECT_END + 0x04F
#define UNIT_FIELD_AURA_38										 OBJECT_END + 0x050
#define UNIT_FIELD_AURA_39										 OBJECT_END + 0x051
#define UNIT_FIELD_AURA_40										 OBJECT_END + 0x052
#define UNIT_FIELD_AURA_41										 OBJECT_END + 0x053
#define UNIT_FIELD_AURA_42										 OBJECT_END + 0x054
#define UNIT_FIELD_AURA_43										 OBJECT_END + 0x055
#define UNIT_FIELD_AURA_44										 OBJECT_END + 0x056
#define UNIT_FIELD_AURA_45										 OBJECT_END + 0x057
#define UNIT_FIELD_AURA_46										 OBJECT_END + 0x058
#define UNIT_FIELD_AURA_47										 OBJECT_END + 0x059
#define UNIT_FIELD_AURA_48										 OBJECT_END + 0x05A
#define UNIT_FIELD_AURA_49										 OBJECT_END + 0x05B
#define UNIT_FIELD_AURA_50										 OBJECT_END + 0x05C
#define UNIT_FIELD_AURA_51										 OBJECT_END + 0x05D
#define UNIT_FIELD_AURA_52										 OBJECT_END + 0x05E
#define UNIT_FIELD_AURA_53										 OBJECT_END + 0x05F
#define UNIT_FIELD_AURA_54										 OBJECT_END + 0x060
#define UNIT_FIELD_AURA_55										 OBJECT_END + 0x061
#define UNIT_FIELD_AURAFLAGS									   OBJECT_END + 0x062
#define UNIT_FIELD_AURAFLAGS_01									OBJECT_END + 0x063
#define UNIT_FIELD_AURAFLAGS_02									OBJECT_END + 0x064
#define UNIT_FIELD_AURAFLAGS_03									OBJECT_END + 0x065
#define UNIT_FIELD_AURAFLAGS_04									OBJECT_END + 0x066
#define UNIT_FIELD_AURAFLAGS_05									OBJECT_END + 0x067
#define UNIT_FIELD_AURAFLAGS_06									OBJECT_END + 0x068
#define UNIT_FIELD_AURALEVELS									  OBJECT_END + 0x069
#define UNIT_FIELD_AURALEVELS_01								   OBJECT_END + 0x06A
#define UNIT_FIELD_AURALEVELS_02								   OBJECT_END + 0x06B
#define UNIT_FIELD_AURALEVELS_03								   OBJECT_END + 0x06C
#define UNIT_FIELD_AURALEVELS_04								   OBJECT_END + 0x06D
#define UNIT_FIELD_AURALEVELS_05								   OBJECT_END + 0x06E
#define UNIT_FIELD_AURALEVELS_06								   OBJECT_END + 0x06F
#define UNIT_FIELD_AURALEVELS_07								   OBJECT_END + 0x070
#define UNIT_FIELD_AURALEVELS_08								   OBJECT_END + 0x071
#define UNIT_FIELD_AURALEVELS_09								   OBJECT_END + 0x072
#define UNIT_FIELD_AURALEVELS_10								   OBJECT_END + 0x073
#define UNIT_FIELD_AURALEVELS_11								   OBJECT_END + 0x074
#define UNIT_FIELD_AURALEVELS_12								   OBJECT_END + 0x075
#define UNIT_FIELD_AURALEVELS_13								   OBJECT_END + 0x076
#define UNIT_FIELD_AURAAPPLICATIONS								OBJECT_END + 0x077
#define UNIT_FIELD_AURAAPPLICATIONS_01							 OBJECT_END + 0x078
#define UNIT_FIELD_AURAAPPLICATIONS_02							 OBJECT_END + 0x079
#define UNIT_FIELD_AURAAPPLICATIONS_03							 OBJECT_END + 0x07A
#define UNIT_FIELD_AURAAPPLICATIONS_04							 OBJECT_END + 0x07B
#define UNIT_FIELD_AURAAPPLICATIONS_05							 OBJECT_END + 0x07C
#define UNIT_FIELD_AURAAPPLICATIONS_06							 OBJECT_END + 0x07D
#define UNIT_FIELD_AURAAPPLICATIONS_07							 OBJECT_END + 0x07E
#define UNIT_FIELD_AURAAPPLICATIONS_08							 OBJECT_END + 0x07F
#define UNIT_FIELD_AURAAPPLICATIONS_09							 OBJECT_END + 0x080
#define UNIT_FIELD_AURAAPPLICATIONS_10							 OBJECT_END + 0x081
#define UNIT_FIELD_AURAAPPLICATIONS_11							 OBJECT_END + 0x082
#define UNIT_FIELD_AURAAPPLICATIONS_12							 OBJECT_END + 0x083
#define UNIT_FIELD_AURAAPPLICATIONS_13							 OBJECT_END + 0x084
#define UNIT_FIELD_AURASTATE									   OBJECT_END + 0x085
#define UNIT_FIELD_BASEATTACKTIME								  OBJECT_END + 0x086
#define UNIT_FIELD_BASEATTACKTIME_01							   OBJECT_END + 0x087
#define UNIT_FIELD_RANGEDATTACKTIME								OBJECT_END + 0x088
#define UNIT_FIELD_BOUNDINGRADIUS								  OBJECT_END + 0x089
#define UNIT_FIELD_COMBATREACH									 OBJECT_END + 0x08A
#define UNIT_FIELD_DISPLAYID									   OBJECT_END + 0x08B
#define UNIT_FIELD_NATIVEDISPLAYID								 OBJECT_END + 0x08C
#define UNIT_FIELD_MOUNTDISPLAYID								  OBJECT_END + 0x08D
#define UNIT_FIELD_MINDAMAGE									   OBJECT_END + 0x08E
#define UNIT_FIELD_MAXDAMAGE									   OBJECT_END + 0x08F
#define UNIT_FIELD_MINOFFHANDDAMAGE								OBJECT_END + 0x090
#define UNIT_FIELD_MAXOFFHANDDAMAGE								OBJECT_END + 0x091
#define UNIT_FIELD_BYTES_1										 OBJECT_END + 0x092
#define UNIT_FIELD_PETNUMBER									   OBJECT_END + 0x093
#define UNIT_FIELD_PET_NAME_TIMESTAMP							  OBJECT_END + 0x094
#define UNIT_FIELD_PETEXPERIENCE								   OBJECT_END + 0x095
#define UNIT_FIELD_PETNEXTLEVELEXP								 OBJECT_END + 0x096
#define UNIT_DYNAMIC_FLAGS										 OBJECT_END + 0x097
#define UNIT_CHANNEL_SPELL										 OBJECT_END + 0x098
#define UNIT_MOD_CAST_SPEED										OBJECT_END + 0x099
#define UNIT_CREATED_BY_SPELL									  OBJECT_END + 0x09A
#define UNIT_NPC_FLAGS											 OBJECT_END + 0x09B
#define UNIT_NPC_EMOTESTATE										OBJECT_END + 0x09C
#define UNIT_TRAINING_POINTS									   OBJECT_END + 0x09D
#define UNIT_FIELD_STAT0										   OBJECT_END + 0x09E
#define UNIT_FIELD_STAT1										   OBJECT_END + 0x09F
#define UNIT_FIELD_STAT2										   OBJECT_END + 0x0A0
#define UNIT_FIELD_STAT3										   OBJECT_END + 0x0A1
#define UNIT_FIELD_STAT4										   OBJECT_END + 0x0A2
#define UNIT_FIELD_POSSTAT0										OBJECT_END + 0x0A3
#define UNIT_FIELD_POSSTAT1										OBJECT_END + 0x0A4
#define UNIT_FIELD_POSSTAT2										OBJECT_END + 0x0A5
#define UNIT_FIELD_POSSTAT3										OBJECT_END + 0x0A6
#define UNIT_FIELD_POSSTAT4										OBJECT_END + 0x0A7
#define UNIT_FIELD_NEGSTAT0										OBJECT_END + 0x0A8
#define UNIT_FIELD_NEGSTAT1										OBJECT_END + 0x0A9
#define UNIT_FIELD_NEGSTAT2										OBJECT_END + 0x0AA
#define UNIT_FIELD_NEGSTAT3										OBJECT_END + 0x0AB
#define UNIT_FIELD_NEGSTAT4										OBJECT_END + 0x0AC
#define UNIT_FIELD_RESISTANCES									 OBJECT_END + 0x0AD
#define UNIT_FIELD_RESISTANCES_01								  OBJECT_END + 0x0AE
#define UNIT_FIELD_RESISTANCES_02								  OBJECT_END + 0x0AF
#define UNIT_FIELD_RESISTANCES_03								  OBJECT_END + 0x0B0
#define UNIT_FIELD_RESISTANCES_04								  OBJECT_END + 0x0B1
#define UNIT_FIELD_RESISTANCES_05								  OBJECT_END + 0x0B2
#define UNIT_FIELD_RESISTANCES_06								  OBJECT_END + 0x0B3
#define UNIT_FIELD_RESISTANCEBUFFMODSPOSITIVE					  OBJECT_END + 0x0B4
#define UNIT_FIELD_RESISTANCEBUFFMODSPOSITIVE_01				   OBJECT_END + 0x0B5
#define UNIT_FIELD_RESISTANCEBUFFMODSPOSITIVE_02				   OBJECT_END + 0x0B6
#define UNIT_FIELD_RESISTANCEBUFFMODSPOSITIVE_03				   OBJECT_END + 0x0B7
#define UNIT_FIELD_RESISTANCEBUFFMODSPOSITIVE_04				   OBJECT_END + 0x0B8
#define UNIT_FIELD_RESISTANCEBUFFMODSPOSITIVE_05				   OBJECT_END + 0x0B9
#define UNIT_FIELD_RESISTANCEBUFFMODSPOSITIVE_06				   OBJECT_END + 0x0BA
#define UNIT_FIELD_RESISTANCEBUFFMODSNEGATIVE					  OBJECT_END + 0x0BB
#define UNIT_FIELD_RESISTANCEBUFFMODSNEGATIVE_01				   OBJECT_END + 0x0BC
#define UNIT_FIELD_RESISTANCEBUFFMODSNEGATIVE_02				   OBJECT_END + 0x0BD
#define UNIT_FIELD_RESISTANCEBUFFMODSNEGATIVE_03				   OBJECT_END + 0x0BE
#define UNIT_FIELD_RESISTANCEBUFFMODSNEGATIVE_04				   OBJECT_END + 0x0BF
#define UNIT_FIELD_RESISTANCEBUFFMODSNEGATIVE_05				   OBJECT_END + 0x0C0
#define UNIT_FIELD_RESISTANCEBUFFMODSNEGATIVE_06				   OBJECT_END + 0x0C1
#define UNIT_FIELD_BASE_MANA									   OBJECT_END + 0x0C2
#define UNIT_FIELD_BASE_HEALTH									 OBJECT_END + 0x0C3
#define UNIT_FIELD_BYTES_2										 OBJECT_END + 0x0C4
#define UNIT_FIELD_ATTACK_POWER									OBJECT_END + 0x0C5
#define UNIT_FIELD_ATTACK_POWER_MODS							   OBJECT_END + 0x0C6
#define UNIT_FIELD_ATTACK_POWER_MULTIPLIER						 OBJECT_END + 0x0C7
#define UNIT_FIELD_RANGED_ATTACK_POWER							 OBJECT_END + 0x0C8
#define UNIT_FIELD_RANGED_ATTACK_POWER_MODS						OBJECT_END + 0x0C9
#define UNIT_FIELD_RANGED_ATTACK_POWER_MULTIPLIER				  OBJECT_END + 0x0CA
#define UNIT_FIELD_MINRANGEDDAMAGE								 OBJECT_END + 0x0CB
#define UNIT_FIELD_MAXRANGEDDAMAGE								 OBJECT_END + 0x0CC
#define UNIT_FIELD_POWER_COST_MODIFIER							 OBJECT_END + 0x0CD
#define UNIT_FIELD_POWER_COST_MODIFIER_01						  OBJECT_END + 0x0CE
#define UNIT_FIELD_POWER_COST_MODIFIER_02						  OBJECT_END + 0x0CF
#define UNIT_FIELD_POWER_COST_MODIFIER_03						  OBJECT_END + 0x0D0
#define UNIT_FIELD_POWER_COST_MODIFIER_04						  OBJECT_END + 0x0D1
#define UNIT_FIELD_POWER_COST_MODIFIER_05						  OBJECT_END + 0x0D2
#define UNIT_FIELD_POWER_COST_MODIFIER_06						  OBJECT_END + 0x0D3
#define UNIT_FIELD_POWER_COST_MULTIPLIER						   OBJECT_END + 0x0D4
#define UNIT_FIELD_POWER_COST_MULTIPLIER_01						OBJECT_END + 0x0D5
#define UNIT_FIELD_POWER_COST_MULTIPLIER_02						OBJECT_END + 0x0D6
#define UNIT_FIELD_POWER_COST_MULTIPLIER_03						OBJECT_END + 0x0D7
#define UNIT_FIELD_POWER_COST_MULTIPLIER_04						OBJECT_END + 0x0D8
#define UNIT_FIELD_POWER_COST_MULTIPLIER_05						OBJECT_END + 0x0D9
#define UNIT_FIELD_POWER_COST_MULTIPLIER_06						OBJECT_END + 0x0DA
#define UNIT_FIELD_PADDING										 OBJECT_END + 0x0DB
#define UNIT_END												OBJECT_END + 0x0DC

// Player Fields
#define PLAYER_DUEL_ARBITER										UNIT_END + 0x000
#define PLAYER_DUEL_ARBITER_01									 UNIT_END + 0x001
#define PLAYER_FLAGS											   UNIT_END + 0x002
#define PLAYER_GUILDID											 UNIT_END + 0x003
#define PLAYER_GUILDRANK										   UNIT_END + 0x004
#define PLAYER_BYTES											   UNIT_END + 0x005
#define PLAYER_BYTES_2											 UNIT_END + 0x006
#define PLAYER_BYTES_3											 UNIT_END + 0x007
#define PLAYER_DUEL_TEAM										   UNIT_END + 0x008
#define PLAYER_GUILD_TIMESTAMP									 UNIT_END + 0x009
#define PLAYER_QUEST_LOG_1_1									   UNIT_END + 0x00A
#define PLAYER_QUEST_LOG_1_2									   UNIT_END + 0x00B
#define PLAYER_QUEST_LOG_1_01									  UNIT_END + 0x00C
#define PLAYER_QUEST_LOG_2_1									   UNIT_END + 0x00D
#define PLAYER_QUEST_LOG_2_2									   UNIT_END + 0x00E
#define PLAYER_QUEST_LOG_2_01									  UNIT_END + 0x00F
#define PLAYER_QUEST_LOG_3_1									   UNIT_END + 0x010
#define PLAYER_QUEST_LOG_3_2									   UNIT_END + 0x011
#define PLAYER_QUEST_LOG_3_01									  UNIT_END + 0x012
#define PLAYER_QUEST_LOG_4_1									   UNIT_END + 0x013
#define PLAYER_QUEST_LOG_4_2									   UNIT_END + 0x014
#define PLAYER_QUEST_LOG_4_01									  UNIT_END + 0x015
#define PLAYER_QUEST_LOG_5_1									   UNIT_END + 0x016
#define PLAYER_QUEST_LOG_5_2									   UNIT_END + 0x017
#define PLAYER_QUEST_LOG_5_01									  UNIT_END + 0x018
#define PLAYER_QUEST_LOG_6_1									   UNIT_END + 0x019
#define PLAYER_QUEST_LOG_6_2									   UNIT_END + 0x01A
#define PLAYER_QUEST_LOG_6_01									  UNIT_END + 0x01B
#define PLAYER_QUEST_LOG_7_1									   UNIT_END + 0x01C
#define PLAYER_QUEST_LOG_7_2									   UNIT_END + 0x01D
#define PLAYER_QUEST_LOG_7_01									  UNIT_END + 0x01E
#define PLAYER_QUEST_LOG_8_1									   UNIT_END + 0x01F
#define PLAYER_QUEST_LOG_8_2									   UNIT_END + 0x020
#define PLAYER_QUEST_LOG_8_01									  UNIT_END + 0x021
#define PLAYER_QUEST_LOG_9_1									   UNIT_END + 0x022
#define PLAYER_QUEST_LOG_9_2									   UNIT_END + 0x023
#define PLAYER_QUEST_LOG_9_01									  UNIT_END + 0x024
#define PLAYER_QUEST_LOG_10_1									  UNIT_END + 0x025
#define PLAYER_QUEST_LOG_10_2									  UNIT_END + 0x026
#define PLAYER_QUEST_LOG_10_01									 UNIT_END + 0x027
#define PLAYER_QUEST_LOG_11_1									  UNIT_END + 0x028
#define PLAYER_QUEST_LOG_11_2									  UNIT_END + 0x029
#define PLAYER_QUEST_LOG_11_01									 UNIT_END + 0x02A
#define PLAYER_QUEST_LOG_12_1									  UNIT_END + 0x02B
#define PLAYER_QUEST_LOG_12_2									  UNIT_END + 0x02C
#define PLAYER_QUEST_LOG_12_01									 UNIT_END + 0x02D
#define PLAYER_QUEST_LOG_13_1									  UNIT_END + 0x02E
#define PLAYER_QUEST_LOG_13_2									  UNIT_END + 0x02F
#define PLAYER_QUEST_LOG_13_01									 UNIT_END + 0x030
#define PLAYER_QUEST_LOG_14_1									  UNIT_END + 0x031
#define PLAYER_QUEST_LOG_14_2									  UNIT_END + 0x032
#define PLAYER_QUEST_LOG_14_01									 UNIT_END + 0x033
#define PLAYER_QUEST_LOG_15_1									  UNIT_END + 0x034
#define PLAYER_QUEST_LOG_15_2									  UNIT_END + 0x035
#define PLAYER_QUEST_LOG_15_01									 UNIT_END + 0x036
#define PLAYER_QUEST_LOG_16_1									  UNIT_END + 0x037
#define PLAYER_QUEST_LOG_16_2									  UNIT_END + 0x038
#define PLAYER_QUEST_LOG_16_01									 UNIT_END + 0x039
#define PLAYER_QUEST_LOG_17_1									  UNIT_END + 0x03A
#define PLAYER_QUEST_LOG_17_2									  UNIT_END + 0x03B
#define PLAYER_QUEST_LOG_17_01									 UNIT_END + 0x03C
#define PLAYER_QUEST_LOG_18_1									  UNIT_END + 0x03D
#define PLAYER_QUEST_LOG_18_2									  UNIT_END + 0x03E
#define PLAYER_QUEST_LOG_18_01									 UNIT_END + 0x03F
#define PLAYER_QUEST_LOG_19_1									  UNIT_END + 0x040
#define PLAYER_QUEST_LOG_19_2									  UNIT_END + 0x041
#define PLAYER_QUEST_LOG_19_01									 UNIT_END + 0x042
#define PLAYER_QUEST_LOG_20_1									  UNIT_END + 0x043
#define PLAYER_QUEST_LOG_20_2									  UNIT_END + 0x044
#define PLAYER_QUEST_LOG_20_01									 UNIT_END + 0x045
#define PLAYER_QUEST_LOG_21_1									  UNIT_END + 0x046
#define PLAYER_QUEST_LOG_21_2									  UNIT_END + 0x047
#define PLAYER_QUEST_LOG_21_01									 UNIT_END + 0x048
#define PLAYER_QUEST_LOG_22_1									  UNIT_END + 0x049
#define PLAYER_QUEST_LOG_22_2									  UNIT_END + 0x04A
#define PLAYER_QUEST_LOG_22_01									 UNIT_END + 0x04B
#define PLAYER_QUEST_LOG_23_1									  UNIT_END + 0x04C
#define PLAYER_QUEST_LOG_23_2									  UNIT_END + 0x04D
#define PLAYER_QUEST_LOG_23_01									 UNIT_END + 0x04E
#define PLAYER_QUEST_LOG_24_1									  UNIT_END + 0x04F
#define PLAYER_QUEST_LOG_24_2									  UNIT_END + 0x050
#define PLAYER_QUEST_LOG_24_01									 UNIT_END + 0x051
#define PLAYER_QUEST_LOG_25_1									  UNIT_END + 0x052
#define PLAYER_QUEST_LOG_25_2									  UNIT_END + 0x053
#define PLAYER_QUEST_LOG_25_01									 UNIT_END + 0x054
#define PLAYER_VISIBLE_ITEM_1_CREATOR							  UNIT_END + 0x055
#define PLAYER_VISIBLE_ITEM_1_CREATOR_01						   UNIT_END + 0x056
#define PLAYER_VISIBLE_ITEM_1_0									UNIT_END + 0x057
#define PLAYER_VISIBLE_ITEM_1_01								   UNIT_END + 0x058
#define PLAYER_VISIBLE_ITEM_1_02								   UNIT_END + 0x059
#define PLAYER_VISIBLE_ITEM_1_03								   UNIT_END + 0x05A
#define PLAYER_VISIBLE_ITEM_1_04								   UNIT_END + 0x05B
#define PLAYER_VISIBLE_ITEM_1_05								   UNIT_END + 0x05C
#define PLAYER_VISIBLE_ITEM_1_06								   UNIT_END + 0x05D
#define PLAYER_VISIBLE_ITEM_1_07								   UNIT_END + 0x05E
#define PLAYER_VISIBLE_ITEM_1_08								   UNIT_END + 0x05F
#define PLAYER_VISIBLE_ITEM_1_09								   UNIT_END + 0x060
#define PLAYER_VISIBLE_ITEM_1_10								   UNIT_END + 0x061
#define PLAYER_VISIBLE_ITEM_1_11								   UNIT_END + 0x062
#define PLAYER_VISIBLE_ITEM_1_PROPERTIES						   UNIT_END + 0x063
#define PLAYER_VISIBLE_ITEM_1_PAD								  UNIT_END + 0x064
#define PLAYER_VISIBLE_ITEM_2_CREATOR							  UNIT_END + 0x065
#define PLAYER_VISIBLE_ITEM_2_CREATOR_01						   UNIT_END + 0x066
#define PLAYER_VISIBLE_ITEM_2_0									UNIT_END + 0x067
#define PLAYER_VISIBLE_ITEM_2_01								   UNIT_END + 0x068
#define PLAYER_VISIBLE_ITEM_2_02								   UNIT_END + 0x069
#define PLAYER_VISIBLE_ITEM_2_03								   UNIT_END + 0x06A
#define PLAYER_VISIBLE_ITEM_2_04								   UNIT_END + 0x06B
#define PLAYER_VISIBLE_ITEM_2_05								   UNIT_END + 0x06C
#define PLAYER_VISIBLE_ITEM_2_06								   UNIT_END + 0x06D
#define PLAYER_VISIBLE_ITEM_2_07								   UNIT_END + 0x06E
#define PLAYER_VISIBLE_ITEM_2_08								   UNIT_END + 0x06F
#define PLAYER_VISIBLE_ITEM_2_09								   UNIT_END + 0x070
#define PLAYER_VISIBLE_ITEM_2_10								   UNIT_END + 0x071
#define PLAYER_VISIBLE_ITEM_2_11								   UNIT_END + 0x072
#define PLAYER_VISIBLE_ITEM_2_PROPERTIES						   UNIT_END + 0x073
#define PLAYER_VISIBLE_ITEM_2_PAD								  UNIT_END + 0x074
#define PLAYER_VISIBLE_ITEM_3_CREATOR							  UNIT_END + 0x075
#define PLAYER_VISIBLE_ITEM_3_CREATOR_01						   UNIT_END + 0x076
#define PLAYER_VISIBLE_ITEM_3_0									UNIT_END + 0x077
#define PLAYER_VISIBLE_ITEM_3_01								   UNIT_END + 0x078
#define PLAYER_VISIBLE_ITEM_3_02								   UNIT_END + 0x079
#define PLAYER_VISIBLE_ITEM_3_03								   UNIT_END + 0x07A
#define PLAYER_VISIBLE_ITEM_3_04								   UNIT_END + 0x07B
#define PLAYER_VISIBLE_ITEM_3_05								   UNIT_END + 0x07C
#define PLAYER_VISIBLE_ITEM_3_06								   UNIT_END + 0x07D
#define PLAYER_VISIBLE_ITEM_3_07								   UNIT_END + 0x07E
#define PLAYER_VISIBLE_ITEM_3_08								   UNIT_END + 0x07F
#define PLAYER_VISIBLE_ITEM_3_09								   UNIT_END + 0x080
#define PLAYER_VISIBLE_ITEM_3_10								   UNIT_END + 0x081
#define PLAYER_VISIBLE_ITEM_3_11								   UNIT_END + 0x082
#define PLAYER_VISIBLE_ITEM_3_PROPERTIES						   UNIT_END + 0x083
#define PLAYER_VISIBLE_ITEM_3_PAD								  UNIT_END + 0x084
#define PLAYER_VISIBLE_ITEM_4_CREATOR							  UNIT_END + 0x085
#define PLAYER_VISIBLE_ITEM_4_CREATOR_01						   UNIT_END + 0x086
#define PLAYER_VISIBLE_ITEM_4_0									UNIT_END + 0x087
#define PLAYER_VISIBLE_ITEM_4_01								   UNIT_END + 0x088
#define PLAYER_VISIBLE_ITEM_4_02								   UNIT_END + 0x089
#define PLAYER_VISIBLE_ITEM_4_03								   UNIT_END + 0x08A
#define PLAYER_VISIBLE_ITEM_4_04								   UNIT_END + 0x08B
#define PLAYER_VISIBLE_ITEM_4_05								   UNIT_END + 0x08C
#define PLAYER_VISIBLE_ITEM_4_06								   UNIT_END + 0x08D
#define PLAYER_VISIBLE_ITEM_4_07								   UNIT_END + 0x08E
#define PLAYER_VISIBLE_ITEM_4_08								   UNIT_END + 0x08F
#define PLAYER_VISIBLE_ITEM_4_09								   UNIT_END + 0x090
#define PLAYER_VISIBLE_ITEM_4_10								   UNIT_END + 0x091
#define PLAYER_VISIBLE_ITEM_4_11								   UNIT_END + 0x092
#define PLAYER_VISIBLE_ITEM_4_PROPERTIES						   UNIT_END + 0x093
#define PLAYER_VISIBLE_ITEM_4_PAD								  UNIT_END + 0x094
#define PLAYER_VISIBLE_ITEM_5_CREATOR							  UNIT_END + 0x095
#define PLAYER_VISIBLE_ITEM_5_CREATOR_01						   UNIT_END + 0x096
#define PLAYER_VISIBLE_ITEM_5_0									UNIT_END + 0x097
#define PLAYER_VISIBLE_ITEM_5_01								   UNIT_END + 0x098
#define PLAYER_VISIBLE_ITEM_5_02								   UNIT_END + 0x099
#define PLAYER_VISIBLE_ITEM_5_03								   UNIT_END + 0x09A
#define PLAYER_VISIBLE_ITEM_5_04								   UNIT_END + 0x09B
#define PLAYER_VISIBLE_ITEM_5_05								   UNIT_END + 0x09C
#define PLAYER_VISIBLE_ITEM_5_06								   UNIT_END + 0x09D
#define PLAYER_VISIBLE_ITEM_5_07								   UNIT_END + 0x09E
#define PLAYER_VISIBLE_ITEM_5_08								   UNIT_END + 0x09F
#define PLAYER_VISIBLE_ITEM_5_09								   UNIT_END + 0x0A0
#define PLAYER_VISIBLE_ITEM_5_10								   UNIT_END + 0x0A1
#define PLAYER_VISIBLE_ITEM_5_11								   UNIT_END + 0x0A2
#define PLAYER_VISIBLE_ITEM_5_PROPERTIES						   UNIT_END + 0x0A3
#define PLAYER_VISIBLE_ITEM_5_PAD								  UNIT_END + 0x0A4
#define PLAYER_VISIBLE_ITEM_6_CREATOR							  UNIT_END + 0x0A5
#define PLAYER_VISIBLE_ITEM_6_CREATOR_01						   UNIT_END + 0x0A6
#define PLAYER_VISIBLE_ITEM_6_0									UNIT_END + 0x0A7
#define PLAYER_VISIBLE_ITEM_6_01								   UNIT_END + 0x0A8
#define PLAYER_VISIBLE_ITEM_6_02								   UNIT_END + 0x0A9
#define PLAYER_VISIBLE_ITEM_6_03								   UNIT_END + 0x0AA
#define PLAYER_VISIBLE_ITEM_6_04								   UNIT_END + 0x0AB
#define PLAYER_VISIBLE_ITEM_6_05								   UNIT_END + 0x0AC
#define PLAYER_VISIBLE_ITEM_6_06								   UNIT_END + 0x0AD
#define PLAYER_VISIBLE_ITEM_6_07								   UNIT_END + 0x0AE
#define PLAYER_VISIBLE_ITEM_6_08								   UNIT_END + 0x0AF
#define PLAYER_VISIBLE_ITEM_6_09								   UNIT_END + 0x0B0
#define PLAYER_VISIBLE_ITEM_6_10								   UNIT_END + 0x0B1
#define PLAYER_VISIBLE_ITEM_6_11								   UNIT_END + 0x0B2
#define PLAYER_VISIBLE_ITEM_6_PROPERTIES						   UNIT_END + 0x0B3
#define PLAYER_VISIBLE_ITEM_6_PAD								  UNIT_END + 0x0B4
#define PLAYER_VISIBLE_ITEM_7_CREATOR							  UNIT_END + 0x0B5
#define PLAYER_VISIBLE_ITEM_7_CREATOR_01						   UNIT_END + 0x0B6
#define PLAYER_VISIBLE_ITEM_7_0									UNIT_END + 0x0B7
#define PLAYER_VISIBLE_ITEM_7_01								   UNIT_END + 0x0B8
#define PLAYER_VISIBLE_ITEM_7_02								   UNIT_END + 0x0B9
#define PLAYER_VISIBLE_ITEM_7_03								   UNIT_END + 0x0BA
#define PLAYER_VISIBLE_ITEM_7_04								   UNIT_END + 0x0BB
#define PLAYER_VISIBLE_ITEM_7_05								   UNIT_END + 0x0BC
#define PLAYER_VISIBLE_ITEM_7_06								   UNIT_END + 0x0BD
#define PLAYER_VISIBLE_ITEM_7_07								   UNIT_END + 0x0BE
#define PLAYER_VISIBLE_ITEM_7_08								   UNIT_END + 0x0BF
#define PLAYER_VISIBLE_ITEM_7_09								   UNIT_END + 0x0C0
#define PLAYER_VISIBLE_ITEM_7_10								   UNIT_END + 0x0C1
#define PLAYER_VISIBLE_ITEM_7_11								   UNIT_END + 0x0C2
#define PLAYER_VISIBLE_ITEM_7_PROPERTIES						   UNIT_END + 0x0C3
#define PLAYER_VISIBLE_ITEM_7_PAD								  UNIT_END + 0x0C4
#define PLAYER_VISIBLE_ITEM_8_CREATOR							  UNIT_END + 0x0C5
#define PLAYER_VISIBLE_ITEM_8_CREATOR_01						   UNIT_END + 0x0C6
#define PLAYER_VISIBLE_ITEM_8_0									UNIT_END + 0x0C7
#define PLAYER_VISIBLE_ITEM_8_01								   UNIT_END + 0x0C8
#define PLAYER_VISIBLE_ITEM_8_02								   UNIT_END + 0x0C9
#define PLAYER_VISIBLE_ITEM_8_03								   UNIT_END + 0x0CA
#define PLAYER_VISIBLE_ITEM_8_04								   UNIT_END + 0x0CB
#define PLAYER_VISIBLE_ITEM_8_05								   UNIT_END + 0x0CC
#define PLAYER_VISIBLE_ITEM_8_06								   UNIT_END + 0x0CD
#define PLAYER_VISIBLE_ITEM_8_07								   UNIT_END + 0x0CE
#define PLAYER_VISIBLE_ITEM_8_08								   UNIT_END + 0x0CF
#define PLAYER_VISIBLE_ITEM_8_09								   UNIT_END + 0x0D0
#define PLAYER_VISIBLE_ITEM_8_10								   UNIT_END + 0x0D1
#define PLAYER_VISIBLE_ITEM_8_11								   UNIT_END + 0x0D2
#define PLAYER_VISIBLE_ITEM_8_PROPERTIES						   UNIT_END + 0x0D3
#define PLAYER_VISIBLE_ITEM_8_PAD								  UNIT_END + 0x0D4
#define PLAYER_VISIBLE_ITEM_9_CREATOR							  UNIT_END + 0x0D5
#define PLAYER_VISIBLE_ITEM_9_CREATOR_01						   UNIT_END + 0x0D6
#define PLAYER_VISIBLE_ITEM_9_0									UNIT_END + 0x0D7
#define PLAYER_VISIBLE_ITEM_9_01								   UNIT_END + 0x0D8
#define PLAYER_VISIBLE_ITEM_9_02								   UNIT_END + 0x0D9
#define PLAYER_VISIBLE_ITEM_9_03								   UNIT_END + 0x0DA
#define PLAYER_VISIBLE_ITEM_9_04								   UNIT_END + 0x0DB
#define PLAYER_VISIBLE_ITEM_9_05								   UNIT_END + 0x0DC
#define PLAYER_VISIBLE_ITEM_9_06								   UNIT_END + 0x0DD
#define PLAYER_VISIBLE_ITEM_9_07								   UNIT_END + 0x0DE
#define PLAYER_VISIBLE_ITEM_9_08								   UNIT_END + 0x0DF
#define PLAYER_VISIBLE_ITEM_9_09								   UNIT_END + 0x0E0
#define PLAYER_VISIBLE_ITEM_9_10								   UNIT_END + 0x0E1
#define PLAYER_VISIBLE_ITEM_9_11								   UNIT_END + 0x0E2
#define PLAYER_VISIBLE_ITEM_9_PROPERTIES						   UNIT_END + 0x0E3
#define PLAYER_VISIBLE_ITEM_9_PAD								  UNIT_END + 0x0E4
#define PLAYER_VISIBLE_ITEM_10_CREATOR							 UNIT_END + 0x0E5
#define PLAYER_VISIBLE_ITEM_10_CREATOR_01						  UNIT_END + 0x0E6
#define PLAYER_VISIBLE_ITEM_10_0								   UNIT_END + 0x0E7
#define PLAYER_VISIBLE_ITEM_10_01								  UNIT_END + 0x0E8
#define PLAYER_VISIBLE_ITEM_10_02								  UNIT_END + 0x0E9
#define PLAYER_VISIBLE_ITEM_10_03								  UNIT_END + 0x0EA
#define PLAYER_VISIBLE_ITEM_10_04								  UNIT_END + 0x0EB
#define PLAYER_VISIBLE_ITEM_10_05								  UNIT_END + 0x0EC
#define PLAYER_VISIBLE_ITEM_10_06								  UNIT_END + 0x0ED
#define PLAYER_VISIBLE_ITEM_10_07								  UNIT_END + 0x0EE
#define PLAYER_VISIBLE_ITEM_10_08								  UNIT_END + 0x0EF
#define PLAYER_VISIBLE_ITEM_10_09								  UNIT_END + 0x0F0
#define PLAYER_VISIBLE_ITEM_10_10								  UNIT_END + 0x0F1
#define PLAYER_VISIBLE_ITEM_10_11								  UNIT_END + 0x0F2
#define PLAYER_VISIBLE_ITEM_10_PROPERTIES						  UNIT_END + 0x0F3
#define PLAYER_VISIBLE_ITEM_10_PAD								 UNIT_END + 0x0F4
#define PLAYER_VISIBLE_ITEM_11_CREATOR							 UNIT_END + 0x0F5
#define PLAYER_VISIBLE_ITEM_11_CREATOR_01						  UNIT_END + 0x0F6
#define PLAYER_VISIBLE_ITEM_11_0								   UNIT_END + 0x0F7
#define PLAYER_VISIBLE_ITEM_11_01								  UNIT_END + 0x0F8
#define PLAYER_VISIBLE_ITEM_11_02								  UNIT_END + 0x0F9
#define PLAYER_VISIBLE_ITEM_11_03								  UNIT_END + 0x0FA
#define PLAYER_VISIBLE_ITEM_11_04								  UNIT_END + 0x0FB
#define PLAYER_VISIBLE_ITEM_11_05								  UNIT_END + 0x0FC
#define PLAYER_VISIBLE_ITEM_11_06								  UNIT_END + 0x0FD
#define PLAYER_VISIBLE_ITEM_11_07								  UNIT_END + 0x0FE
#define PLAYER_VISIBLE_ITEM_11_08								  UNIT_END + 0x0FF
#define PLAYER_VISIBLE_ITEM_11_09								  UNIT_END + 0x100
#define PLAYER_VISIBLE_ITEM_11_10								  UNIT_END + 0x101
#define PLAYER_VISIBLE_ITEM_11_11								  UNIT_END + 0x102
#define PLAYER_VISIBLE_ITEM_11_PROPERTIES						  UNIT_END + 0x103
#define PLAYER_VISIBLE_ITEM_11_PAD								 UNIT_END + 0x104
#define PLAYER_VISIBLE_ITEM_12_CREATOR							 UNIT_END + 0x105
#define PLAYER_VISIBLE_ITEM_12_CREATOR_01						  UNIT_END + 0x106
#define PLAYER_VISIBLE_ITEM_12_0								   UNIT_END + 0x107
#define PLAYER_VISIBLE_ITEM_12_01								  UNIT_END + 0x108
#define PLAYER_VISIBLE_ITEM_12_02								  UNIT_END + 0x109
#define PLAYER_VISIBLE_ITEM_12_03								  UNIT_END + 0x10A
#define PLAYER_VISIBLE_ITEM_12_04								  UNIT_END + 0x10B
#define PLAYER_VISIBLE_ITEM_12_05								  UNIT_END + 0x10C
#define PLAYER_VISIBLE_ITEM_12_06								  UNIT_END + 0x10D
#define PLAYER_VISIBLE_ITEM_12_07								  UNIT_END + 0x10E
#define PLAYER_VISIBLE_ITEM_12_08								  UNIT_END + 0x10F
#define PLAYER_VISIBLE_ITEM_12_09								  UNIT_END + 0x110
#define PLAYER_VISIBLE_ITEM_12_10								  UNIT_END + 0x111
#define PLAYER_VISIBLE_ITEM_12_11								  UNIT_END + 0x112
#define PLAYER_VISIBLE_ITEM_12_PROPERTIES						  UNIT_END + 0x113
#define PLAYER_VISIBLE_ITEM_12_PAD								 UNIT_END + 0x114
#define PLAYER_VISIBLE_ITEM_13_CREATOR							 UNIT_END + 0x115
#define PLAYER_VISIBLE_ITEM_13_CREATOR_01						  UNIT_END + 0x116
#define PLAYER_VISIBLE_ITEM_13_0								   UNIT_END + 0x117
#define PLAYER_VISIBLE_ITEM_13_01								  UNIT_END + 0x118
#define PLAYER_VISIBLE_ITEM_13_02								  UNIT_END + 0x119
#define PLAYER_VISIBLE_ITEM_13_03								  UNIT_END + 0x11A
#define PLAYER_VISIBLE_ITEM_13_04								  UNIT_END + 0x11B
#define PLAYER_VISIBLE_ITEM_13_05								  UNIT_END + 0x11C
#define PLAYER_VISIBLE_ITEM_13_06								  UNIT_END + 0x11D
#define PLAYER_VISIBLE_ITEM_13_07								  UNIT_END + 0x11E
#define PLAYER_VISIBLE_ITEM_13_08								  UNIT_END + 0x11F
#define PLAYER_VISIBLE_ITEM_13_09								  UNIT_END + 0x120
#define PLAYER_VISIBLE_ITEM_13_10								  UNIT_END + 0x121
#define PLAYER_VISIBLE_ITEM_13_11								  UNIT_END + 0x122
#define PLAYER_VISIBLE_ITEM_13_PROPERTIES						  UNIT_END + 0x123
#define PLAYER_VISIBLE_ITEM_13_PAD								 UNIT_END + 0x124
#define PLAYER_VISIBLE_ITEM_14_CREATOR							 UNIT_END + 0x125
#define PLAYER_VISIBLE_ITEM_14_CREATOR_01						  UNIT_END + 0x126
#define PLAYER_VISIBLE_ITEM_14_0								   UNIT_END + 0x127
#define PLAYER_VISIBLE_ITEM_14_01								  UNIT_END + 0x128
#define PLAYER_VISIBLE_ITEM_14_02								  UNIT_END + 0x129
#define PLAYER_VISIBLE_ITEM_14_03								  UNIT_END + 0x12A
#define PLAYER_VISIBLE_ITEM_14_04								  UNIT_END + 0x12B
#define PLAYER_VISIBLE_ITEM_14_05								  UNIT_END + 0x12C
#define PLAYER_VISIBLE_ITEM_14_06								  UNIT_END + 0x12D
#define PLAYER_VISIBLE_ITEM_14_07								  UNIT_END + 0x12E
#define PLAYER_VISIBLE_ITEM_14_08								  UNIT_END + 0x12F
#define PLAYER_VISIBLE_ITEM_14_09								  UNIT_END + 0x130
#define PLAYER_VISIBLE_ITEM_14_10								  UNIT_END + 0x131
#define PLAYER_VISIBLE_ITEM_14_11								  UNIT_END + 0x132
#define PLAYER_VISIBLE_ITEM_14_PROPERTIES						  UNIT_END + 0x133
#define PLAYER_VISIBLE_ITEM_14_PAD								 UNIT_END + 0x134
#define PLAYER_VISIBLE_ITEM_15_CREATOR							 UNIT_END + 0x135
#define PLAYER_VISIBLE_ITEM_15_CREATOR_01						  UNIT_END + 0x136
#define PLAYER_VISIBLE_ITEM_15_0								   UNIT_END + 0x137
#define PLAYER_VISIBLE_ITEM_15_01								  UNIT_END + 0x138
#define PLAYER_VISIBLE_ITEM_15_02								  UNIT_END + 0x139
#define PLAYER_VISIBLE_ITEM_15_03								  UNIT_END + 0x13A
#define PLAYER_VISIBLE_ITEM_15_04								  UNIT_END + 0x13B
#define PLAYER_VISIBLE_ITEM_15_05								  UNIT_END + 0x13C
#define PLAYER_VISIBLE_ITEM_15_06								  UNIT_END + 0x13D
#define PLAYER_VISIBLE_ITEM_15_07								  UNIT_END + 0x13E
#define PLAYER_VISIBLE_ITEM_15_08								  UNIT_END + 0x13F
#define PLAYER_VISIBLE_ITEM_15_09								  UNIT_END + 0x140
#define PLAYER_VISIBLE_ITEM_15_10								  UNIT_END + 0x141
#define PLAYER_VISIBLE_ITEM_15_11								  UNIT_END + 0x142
#define PLAYER_VISIBLE_ITEM_15_PROPERTIES						  UNIT_END + 0x143
#define PLAYER_VISIBLE_ITEM_15_PAD								 UNIT_END + 0x144
#define PLAYER_VISIBLE_ITEM_16_CREATOR							 UNIT_END + 0x145
#define PLAYER_VISIBLE_ITEM_16_CREATOR_01						  UNIT_END + 0x146
#define PLAYER_VISIBLE_ITEM_16_0								   UNIT_END + 0x147
#define PLAYER_VISIBLE_ITEM_16_01								  UNIT_END + 0x148
#define PLAYER_VISIBLE_ITEM_16_02								  UNIT_END + 0x149
#define PLAYER_VISIBLE_ITEM_16_03								  UNIT_END + 0x14A
#define PLAYER_VISIBLE_ITEM_16_04								  UNIT_END + 0x14B
#define PLAYER_VISIBLE_ITEM_16_05								  UNIT_END + 0x14C
#define PLAYER_VISIBLE_ITEM_16_06								  UNIT_END + 0x14D
#define PLAYER_VISIBLE_ITEM_16_07								  UNIT_END + 0x14E
#define PLAYER_VISIBLE_ITEM_16_08								  UNIT_END + 0x14F
#define PLAYER_VISIBLE_ITEM_16_09								  UNIT_END + 0x150
#define PLAYER_VISIBLE_ITEM_16_10								  UNIT_END + 0x151
#define PLAYER_VISIBLE_ITEM_16_11								  UNIT_END + 0x152
#define PLAYER_VISIBLE_ITEM_16_PROPERTIES						  UNIT_END + 0x153
#define PLAYER_VISIBLE_ITEM_16_PAD								 UNIT_END + 0x154
#define PLAYER_VISIBLE_ITEM_17_CREATOR							 UNIT_END + 0x155
#define PLAYER_VISIBLE_ITEM_17_CREATOR_01						  UNIT_END + 0x156
#define PLAYER_VISIBLE_ITEM_17_0								   UNIT_END + 0x157
#define PLAYER_VISIBLE_ITEM_17_01								  UNIT_END + 0x158
#define PLAYER_VISIBLE_ITEM_17_02								  UNIT_END + 0x159
#define PLAYER_VISIBLE_ITEM_17_03								  UNIT_END + 0x15A
#define PLAYER_VISIBLE_ITEM_17_04								  UNIT_END + 0x15B
#define PLAYER_VISIBLE_ITEM_17_05								  UNIT_END + 0x15C
#define PLAYER_VISIBLE_ITEM_17_06								  UNIT_END + 0x15D
#define PLAYER_VISIBLE_ITEM_17_07								  UNIT_END + 0x15E
#define PLAYER_VISIBLE_ITEM_17_08								  UNIT_END + 0x15F
#define PLAYER_VISIBLE_ITEM_17_09								  UNIT_END + 0x160
#define PLAYER_VISIBLE_ITEM_17_10								  UNIT_END + 0x161
#define PLAYER_VISIBLE_ITEM_17_11								  UNIT_END + 0x162
#define PLAYER_VISIBLE_ITEM_17_PROPERTIES						  UNIT_END + 0x163
#define PLAYER_VISIBLE_ITEM_17_PAD								 UNIT_END + 0x164
#define PLAYER_VISIBLE_ITEM_18_CREATOR							 UNIT_END + 0x165
#define PLAYER_VISIBLE_ITEM_18_CREATOR_01						  UNIT_END + 0x166
#define PLAYER_VISIBLE_ITEM_18_0								   UNIT_END + 0x167
#define PLAYER_VISIBLE_ITEM_18_01								  UNIT_END + 0x168
#define PLAYER_VISIBLE_ITEM_18_02								  UNIT_END + 0x169
#define PLAYER_VISIBLE_ITEM_18_03								  UNIT_END + 0x16A
#define PLAYER_VISIBLE_ITEM_18_04								  UNIT_END + 0x16B
#define PLAYER_VISIBLE_ITEM_18_05								  UNIT_END + 0x16C
#define PLAYER_VISIBLE_ITEM_18_06								  UNIT_END + 0x16D
#define PLAYER_VISIBLE_ITEM_18_07								  UNIT_END + 0x16E
#define PLAYER_VISIBLE_ITEM_18_08								  UNIT_END + 0x16F
#define PLAYER_VISIBLE_ITEM_18_09								  UNIT_END + 0x170
#define PLAYER_VISIBLE_ITEM_18_10								  UNIT_END + 0x171
#define PLAYER_VISIBLE_ITEM_18_11								  UNIT_END + 0x172
#define PLAYER_VISIBLE_ITEM_18_PROPERTIES						  UNIT_END + 0x173
#define PLAYER_VISIBLE_ITEM_18_PAD								 UNIT_END + 0x174
#define PLAYER_VISIBLE_ITEM_19_CREATOR							 UNIT_END + 0x175
#define PLAYER_VISIBLE_ITEM_19_CREATOR_01						  UNIT_END + 0x176
#define PLAYER_VISIBLE_ITEM_19_0								   UNIT_END + 0x177
#define PLAYER_VISIBLE_ITEM_19_01								  UNIT_END + 0x178
#define PLAYER_VISIBLE_ITEM_19_02								  UNIT_END + 0x179
#define PLAYER_VISIBLE_ITEM_19_03								  UNIT_END + 0x17A
#define PLAYER_VISIBLE_ITEM_19_04								  UNIT_END + 0x17B
#define PLAYER_VISIBLE_ITEM_19_05								  UNIT_END + 0x17C
#define PLAYER_VISIBLE_ITEM_19_06								  UNIT_END + 0x17D
#define PLAYER_VISIBLE_ITEM_19_07								  UNIT_END + 0x17E
#define PLAYER_VISIBLE_ITEM_19_08								  UNIT_END + 0x17F
#define PLAYER_VISIBLE_ITEM_19_09								  UNIT_END + 0x180
#define PLAYER_VISIBLE_ITEM_19_10								  UNIT_END + 0x181
#define PLAYER_VISIBLE_ITEM_19_11								  UNIT_END + 0x182
#define PLAYER_VISIBLE_ITEM_19_PROPERTIES						  UNIT_END + 0x183
#define PLAYER_VISIBLE_ITEM_19_PAD								 UNIT_END + 0x184
#define PLAYER_CHOSEN_TITLE										UNIT_END + 0x185
#define PLAYER_FIELD_INV_SLOT_HEAD								 UNIT_END + 0x186
#define PLAYER_FIELD_INV_SLOT_HEAD_01							  UNIT_END + 0x187
#define PLAYER_FIELD_INV_SLOT_HEAD_02							  UNIT_END + 0x188
#define PLAYER_FIELD_INV_SLOT_HEAD_03							  UNIT_END + 0x189
#define PLAYER_FIELD_INV_SLOT_HEAD_04							  UNIT_END + 0x18A
#define PLAYER_FIELD_INV_SLOT_HEAD_05							  UNIT_END + 0x18B
#define PLAYER_FIELD_INV_SLOT_HEAD_06							  UNIT_END + 0x18C
#define PLAYER_FIELD_INV_SLOT_HEAD_07							  UNIT_END + 0x18D
#define PLAYER_FIELD_INV_SLOT_HEAD_08							  UNIT_END + 0x18E
#define PLAYER_FIELD_INV_SLOT_HEAD_09							  UNIT_END + 0x18F
#define PLAYER_FIELD_INV_SLOT_HEAD_10							  UNIT_END + 0x190
#define PLAYER_FIELD_INV_SLOT_HEAD_11							  UNIT_END + 0x191
#define PLAYER_FIELD_INV_SLOT_HEAD_12							  UNIT_END + 0x192
#define PLAYER_FIELD_INV_SLOT_HEAD_13							  UNIT_END + 0x193
#define PLAYER_FIELD_INV_SLOT_HEAD_14							  UNIT_END + 0x194
#define PLAYER_FIELD_INV_SLOT_HEAD_15							  UNIT_END + 0x195
#define PLAYER_FIELD_INV_SLOT_HEAD_16							  UNIT_END + 0x196
#define PLAYER_FIELD_INV_SLOT_HEAD_17							  UNIT_END + 0x197
#define PLAYER_FIELD_INV_SLOT_HEAD_18							  UNIT_END + 0x198
#define PLAYER_FIELD_INV_SLOT_HEAD_19							  UNIT_END + 0x199
#define PLAYER_FIELD_INV_SLOT_HEAD_20							  UNIT_END + 0x19A
#define PLAYER_FIELD_INV_SLOT_HEAD_21							  UNIT_END + 0x19B
#define PLAYER_FIELD_INV_SLOT_HEAD_22							  UNIT_END + 0x19C
#define PLAYER_FIELD_INV_SLOT_HEAD_23							  UNIT_END + 0x19D
#define PLAYER_FIELD_INV_SLOT_HEAD_24							  UNIT_END + 0x19E
#define PLAYER_FIELD_INV_SLOT_HEAD_25							  UNIT_END + 0x19F
#define PLAYER_FIELD_INV_SLOT_HEAD_26							  UNIT_END + 0x1A0
#define PLAYER_FIELD_INV_SLOT_HEAD_27							  UNIT_END + 0x1A1
#define PLAYER_FIELD_INV_SLOT_HEAD_28							  UNIT_END + 0x1A2
#define PLAYER_FIELD_INV_SLOT_HEAD_29							  UNIT_END + 0x1A3
#define PLAYER_FIELD_INV_SLOT_HEAD_30							  UNIT_END + 0x1A4
#define PLAYER_FIELD_INV_SLOT_HEAD_31							  UNIT_END + 0x1A5
#define PLAYER_FIELD_INV_SLOT_HEAD_32							  UNIT_END + 0x1A6
#define PLAYER_FIELD_INV_SLOT_HEAD_33							  UNIT_END + 0x1A7
#define PLAYER_FIELD_INV_SLOT_HEAD_34							  UNIT_END + 0x1A8
#define PLAYER_FIELD_INV_SLOT_HEAD_35							  UNIT_END + 0x1A9
#define PLAYER_FIELD_INV_SLOT_HEAD_36							  UNIT_END + 0x1AA
#define PLAYER_FIELD_INV_SLOT_HEAD_37							  UNIT_END + 0x1AB
#define PLAYER_FIELD_INV_SLOT_HEAD_38							  UNIT_END + 0x1AC
#define PLAYER_FIELD_INV_SLOT_HEAD_39							  UNIT_END + 0x1AD
#define PLAYER_FIELD_INV_SLOT_HEAD_40							  UNIT_END + 0x1AE
#define PLAYER_FIELD_INV_SLOT_HEAD_41							  UNIT_END + 0x1AF
#define PLAYER_FIELD_INV_SLOT_HEAD_42							  UNIT_END + 0x1B0
#define PLAYER_FIELD_INV_SLOT_HEAD_43							  UNIT_END + 0x1B1
#define PLAYER_FIELD_INV_SLOT_HEAD_44							  UNIT_END + 0x1B2
#define PLAYER_FIELD_INV_SLOT_HEAD_45							  UNIT_END + 0x1B3
#define PLAYER_FIELD_PACK_SLOT_1								   UNIT_END + 0x1B4
#define PLAYER_FIELD_PACK_SLOT_01								  UNIT_END + 0x1B5
#define PLAYER_FIELD_PACK_SLOT_02								  UNIT_END + 0x1B6
#define PLAYER_FIELD_PACK_SLOT_03								  UNIT_END + 0x1B7
#define PLAYER_FIELD_PACK_SLOT_04								  UNIT_END + 0x1B8
#define PLAYER_FIELD_PACK_SLOT_05								  UNIT_END + 0x1B9
#define PLAYER_FIELD_PACK_SLOT_06								  UNIT_END + 0x1BA
#define PLAYER_FIELD_PACK_SLOT_07								  UNIT_END + 0x1BB
#define PLAYER_FIELD_PACK_SLOT_08								  UNIT_END + 0x1BC
#define PLAYER_FIELD_PACK_SLOT_09								  UNIT_END + 0x1BD
#define PLAYER_FIELD_PACK_SLOT_10								  UNIT_END + 0x1BE
#define PLAYER_FIELD_PACK_SLOT_11								  UNIT_END + 0x1BF
#define PLAYER_FIELD_PACK_SLOT_12								  UNIT_END + 0x1C0
#define PLAYER_FIELD_PACK_SLOT_13								  UNIT_END + 0x1C1
#define PLAYER_FIELD_PACK_SLOT_14								  UNIT_END + 0x1C2
#define PLAYER_FIELD_PACK_SLOT_15								  UNIT_END + 0x1C3
#define PLAYER_FIELD_PACK_SLOT_16								  UNIT_END + 0x1C4
#define PLAYER_FIELD_PACK_SLOT_17								  UNIT_END + 0x1C5
#define PLAYER_FIELD_PACK_SLOT_18								  UNIT_END + 0x1C6
#define PLAYER_FIELD_PACK_SLOT_19								  UNIT_END + 0x1C7
#define PLAYER_FIELD_PACK_SLOT_20								  UNIT_END + 0x1C8
#define PLAYER_FIELD_PACK_SLOT_21								  UNIT_END + 0x1C9
#define PLAYER_FIELD_PACK_SLOT_22								  UNIT_END + 0x1CA
#define PLAYER_FIELD_PACK_SLOT_23								  UNIT_END + 0x1CB
#define PLAYER_FIELD_PACK_SLOT_24								  UNIT_END + 0x1CC
#define PLAYER_FIELD_PACK_SLOT_25								  UNIT_END + 0x1CD
#define PLAYER_FIELD_PACK_SLOT_26								  UNIT_END + 0x1CE
#define PLAYER_FIELD_PACK_SLOT_27								  UNIT_END + 0x1CF
#define PLAYER_FIELD_PACK_SLOT_28								  UNIT_END + 0x1D0
#define PLAYER_FIELD_PACK_SLOT_29								  UNIT_END + 0x1D1
#define PLAYER_FIELD_PACK_SLOT_30								  UNIT_END + 0x1D2
#define PLAYER_FIELD_PACK_SLOT_31								  UNIT_END + 0x1D3
#define PLAYER_FIELD_BANK_SLOT_1								   UNIT_END + 0x1D4
#define PLAYER_FIELD_BANK_SLOT_01								  UNIT_END + 0x1D5
#define PLAYER_FIELD_BANK_SLOT_02								  UNIT_END + 0x1D6
#define PLAYER_FIELD_BANK_SLOT_03								  UNIT_END + 0x1D7
#define PLAYER_FIELD_BANK_SLOT_04								  UNIT_END + 0x1D8
#define PLAYER_FIELD_BANK_SLOT_05								  UNIT_END + 0x1D9
#define PLAYER_FIELD_BANK_SLOT_06								  UNIT_END + 0x1DA
#define PLAYER_FIELD_BANK_SLOT_07								  UNIT_END + 0x1DB
#define PLAYER_FIELD_BANK_SLOT_08								  UNIT_END + 0x1DC
#define PLAYER_FIELD_BANK_SLOT_09								  UNIT_END + 0x1DD
#define PLAYER_FIELD_BANK_SLOT_10								  UNIT_END + 0x1DE
#define PLAYER_FIELD_BANK_SLOT_11								  UNIT_END + 0x1DF
#define PLAYER_FIELD_BANK_SLOT_12								  UNIT_END + 0x1E0
#define PLAYER_FIELD_BANK_SLOT_13								  UNIT_END + 0x1E1
#define PLAYER_FIELD_BANK_SLOT_14								  UNIT_END + 0x1E2
#define PLAYER_FIELD_BANK_SLOT_15								  UNIT_END + 0x1E3
#define PLAYER_FIELD_BANK_SLOT_16								  UNIT_END + 0x1E4
#define PLAYER_FIELD_BANK_SLOT_17								  UNIT_END + 0x1E5
#define PLAYER_FIELD_BANK_SLOT_18								  UNIT_END + 0x1E6
#define PLAYER_FIELD_BANK_SLOT_19								  UNIT_END + 0x1E7
#define PLAYER_FIELD_BANK_SLOT_20								  UNIT_END + 0x1E8
#define PLAYER_FIELD_BANK_SLOT_21								  UNIT_END + 0x1E9
#define PLAYER_FIELD_BANK_SLOT_22								  UNIT_END + 0x1EA
#define PLAYER_FIELD_BANK_SLOT_23								  UNIT_END + 0x1EB
#define PLAYER_FIELD_BANK_SLOT_24								  UNIT_END + 0x1EC
#define PLAYER_FIELD_BANK_SLOT_25								  UNIT_END + 0x1ED
#define PLAYER_FIELD_BANK_SLOT_26								  UNIT_END + 0x1EE
#define PLAYER_FIELD_BANK_SLOT_27								  UNIT_END + 0x1EF
#define PLAYER_FIELD_BANK_SLOT_28								  UNIT_END + 0x1F0
#define PLAYER_FIELD_BANK_SLOT_29								  UNIT_END + 0x1F1
#define PLAYER_FIELD_BANK_SLOT_30								  UNIT_END + 0x1F2
#define PLAYER_FIELD_BANK_SLOT_31								  UNIT_END + 0x1F3
#define PLAYER_FIELD_BANK_SLOT_32								  UNIT_END + 0x1F4
#define PLAYER_FIELD_BANK_SLOT_33								  UNIT_END + 0x1F5
#define PLAYER_FIELD_BANK_SLOT_34								  UNIT_END + 0x1F6
#define PLAYER_FIELD_BANK_SLOT_35								  UNIT_END + 0x1F7
#define PLAYER_FIELD_BANK_SLOT_36								  UNIT_END + 0x1F8
#define PLAYER_FIELD_BANK_SLOT_37								  UNIT_END + 0x1F9
#define PLAYER_FIELD_BANK_SLOT_38								  UNIT_END + 0x1FA
#define PLAYER_FIELD_BANK_SLOT_39								  UNIT_END + 0x1FB
#define PLAYER_FIELD_BANK_SLOT_40								  UNIT_END + 0x1FC
#define PLAYER_FIELD_BANK_SLOT_41								  UNIT_END + 0x1FD
#define PLAYER_FIELD_BANK_SLOT_42								  UNIT_END + 0x1FE
#define PLAYER_FIELD_BANK_SLOT_43								  UNIT_END + 0x1FF
#define PLAYER_FIELD_BANK_SLOT_44								  UNIT_END + 0x200
#define PLAYER_FIELD_BANK_SLOT_45								  UNIT_END + 0x201
#define PLAYER_FIELD_BANK_SLOT_46								  UNIT_END + 0x202
#define PLAYER_FIELD_BANK_SLOT_47								  UNIT_END + 0x203
#define PLAYER_FIELD_BANK_SLOT_48								  UNIT_END + 0x204
#define PLAYER_FIELD_BANK_SLOT_49								  UNIT_END + 0x205
#define PLAYER_FIELD_BANK_SLOT_50								  UNIT_END + 0x206
#define PLAYER_FIELD_BANK_SLOT_51								  UNIT_END + 0x207
#define PLAYER_FIELD_BANK_SLOT_52								  UNIT_END + 0x208
#define PLAYER_FIELD_BANK_SLOT_53								  UNIT_END + 0x209
#define PLAYER_FIELD_BANK_SLOT_54								  UNIT_END + 0x20A
#define PLAYER_FIELD_BANK_SLOT_55								  UNIT_END + 0x20B
#define PLAYER_FIELD_BANKBAG_SLOT_1								UNIT_END + 0x20C
#define PLAYER_FIELD_BANKBAG_SLOT_01							   UNIT_END + 0x20D
#define PLAYER_FIELD_BANKBAG_SLOT_02							   UNIT_END + 0x20E
#define PLAYER_FIELD_BANKBAG_SLOT_03							   UNIT_END + 0x20F
#define PLAYER_FIELD_BANKBAG_SLOT_04							   UNIT_END + 0x210
#define PLAYER_FIELD_BANKBAG_SLOT_05							   UNIT_END + 0x211
#define PLAYER_FIELD_BANKBAG_SLOT_06							   UNIT_END + 0x212
#define PLAYER_FIELD_BANKBAG_SLOT_07							   UNIT_END + 0x213
#define PLAYER_FIELD_BANKBAG_SLOT_08							   UNIT_END + 0x214
#define PLAYER_FIELD_BANKBAG_SLOT_09							   UNIT_END + 0x215
#define PLAYER_FIELD_BANKBAG_SLOT_10							   UNIT_END + 0x216
#define PLAYER_FIELD_BANKBAG_SLOT_11							   UNIT_END + 0x217
#define PLAYER_FIELD_BANKBAG_SLOT_12							   UNIT_END + 0x218
#define PLAYER_FIELD_BANKBAG_SLOT_13							   UNIT_END + 0x219
#define PLAYER_FIELD_VENDORBUYBACK_SLOT_1						  UNIT_END + 0x21A
#define PLAYER_FIELD_VENDORBUYBACK_SLOT_01						 UNIT_END + 0x21B
#define PLAYER_FIELD_VENDORBUYBACK_SLOT_02						 UNIT_END + 0x21C
#define PLAYER_FIELD_VENDORBUYBACK_SLOT_03						 UNIT_END + 0x21D
#define PLAYER_FIELD_VENDORBUYBACK_SLOT_04						 UNIT_END + 0x21E
#define PLAYER_FIELD_VENDORBUYBACK_SLOT_05						 UNIT_END + 0x21F
#define PLAYER_FIELD_VENDORBUYBACK_SLOT_06						 UNIT_END + 0x220
#define PLAYER_FIELD_VENDORBUYBACK_SLOT_07						 UNIT_END + 0x221
#define PLAYER_FIELD_VENDORBUYBACK_SLOT_08						 UNIT_END + 0x222
#define PLAYER_FIELD_VENDORBUYBACK_SLOT_09						 UNIT_END + 0x223
#define PLAYER_FIELD_VENDORBUYBACK_SLOT_10						 UNIT_END + 0x224
#define PLAYER_FIELD_VENDORBUYBACK_SLOT_11						 UNIT_END + 0x225
#define PLAYER_FIELD_VENDORBUYBACK_SLOT_12						 UNIT_END + 0x226
#define PLAYER_FIELD_VENDORBUYBACK_SLOT_13						 UNIT_END + 0x227
#define PLAYER_FIELD_VENDORBUYBACK_SLOT_14						 UNIT_END + 0x228
#define PLAYER_FIELD_VENDORBUYBACK_SLOT_15						 UNIT_END + 0x229
#define PLAYER_FIELD_VENDORBUYBACK_SLOT_16						 UNIT_END + 0x22A
#define PLAYER_FIELD_VENDORBUYBACK_SLOT_17						 UNIT_END + 0x22B
#define PLAYER_FIELD_VENDORBUYBACK_SLOT_18						 UNIT_END + 0x22C
#define PLAYER_FIELD_VENDORBUYBACK_SLOT_19						 UNIT_END + 0x22D
#define PLAYER_FIELD_VENDORBUYBACK_SLOT_20						 UNIT_END + 0x22E
#define PLAYER_FIELD_VENDORBUYBACK_SLOT_21						 UNIT_END + 0x22F
#define PLAYER_FIELD_VENDORBUYBACK_SLOT_22						 UNIT_END + 0x230
#define PLAYER_FIELD_VENDORBUYBACK_SLOT_23						 UNIT_END + 0x231
#define PLAYER_FIELD_KEYRING_SLOT_1								UNIT_END + 0x232
#define PLAYER_FIELD_KEYRING_SLOT_01							   UNIT_END + 0x233
#define PLAYER_FIELD_KEYRING_SLOT_02							   UNIT_END + 0x234
#define PLAYER_FIELD_KEYRING_SLOT_03							   UNIT_END + 0x235
#define PLAYER_FIELD_KEYRING_SLOT_04							   UNIT_END + 0x236
#define PLAYER_FIELD_KEYRING_SLOT_05							   UNIT_END + 0x237
#define PLAYER_FIELD_KEYRING_SLOT_06							   UNIT_END + 0x238
#define PLAYER_FIELD_KEYRING_SLOT_07							   UNIT_END + 0x239
#define PLAYER_FIELD_KEYRING_SLOT_08							   UNIT_END + 0x23A
#define PLAYER_FIELD_KEYRING_SLOT_09							   UNIT_END + 0x23B
#define PLAYER_FIELD_KEYRING_SLOT_10							   UNIT_END + 0x23C
#define PLAYER_FIELD_KEYRING_SLOT_11							   UNIT_END + 0x23D
#define PLAYER_FIELD_KEYRING_SLOT_12							   UNIT_END + 0x23E
#define PLAYER_FIELD_KEYRING_SLOT_13							   UNIT_END + 0x23F
#define PLAYER_FIELD_KEYRING_SLOT_14							   UNIT_END + 0x240
#define PLAYER_FIELD_KEYRING_SLOT_15							   UNIT_END + 0x241
#define PLAYER_FIELD_KEYRING_SLOT_16							   UNIT_END + 0x242
#define PLAYER_FIELD_KEYRING_SLOT_17							   UNIT_END + 0x243
#define PLAYER_FIELD_KEYRING_SLOT_18							   UNIT_END + 0x244
#define PLAYER_FIELD_KEYRING_SLOT_19							   UNIT_END + 0x245
#define PLAYER_FIELD_KEYRING_SLOT_20							   UNIT_END + 0x246
#define PLAYER_FIELD_KEYRING_SLOT_21							   UNIT_END + 0x247
#define PLAYER_FIELD_KEYRING_SLOT_22							   UNIT_END + 0x248
#define PLAYER_FIELD_KEYRING_SLOT_23							   UNIT_END + 0x249
#define PLAYER_FIELD_KEYRING_SLOT_24							   UNIT_END + 0x24A
#define PLAYER_FIELD_KEYRING_SLOT_25							   UNIT_END + 0x24B
#define PLAYER_FIELD_KEYRING_SLOT_26							   UNIT_END + 0x24C
#define PLAYER_FIELD_KEYRING_SLOT_27							   UNIT_END + 0x24D
#define PLAYER_FIELD_KEYRING_SLOT_28							   UNIT_END + 0x24E
#define PLAYER_FIELD_KEYRING_SLOT_29							   UNIT_END + 0x24F
#define PLAYER_FIELD_KEYRING_SLOT_30							   UNIT_END + 0x250
#define PLAYER_FIELD_KEYRING_SLOT_31							   UNIT_END + 0x251
#define PLAYER_FIELD_KEYRING_SLOT_32							   UNIT_END + 0x252
#define PLAYER_FIELD_KEYRING_SLOT_33							   UNIT_END + 0x253
#define PLAYER_FIELD_KEYRING_SLOT_34							   UNIT_END + 0x254
#define PLAYER_FIELD_KEYRING_SLOT_35							   UNIT_END + 0x255
#define PLAYER_FIELD_KEYRING_SLOT_36							   UNIT_END + 0x256
#define PLAYER_FIELD_KEYRING_SLOT_37							   UNIT_END + 0x257
#define PLAYER_FIELD_KEYRING_SLOT_38							   UNIT_END + 0x258
#define PLAYER_FIELD_KEYRING_SLOT_39							   UNIT_END + 0x259
#define PLAYER_FIELD_KEYRING_SLOT_40							   UNIT_END + 0x25A
#define PLAYER_FIELD_KEYRING_SLOT_41							   UNIT_END + 0x25B
#define PLAYER_FIELD_KEYRING_SLOT_42							   UNIT_END + 0x25C
#define PLAYER_FIELD_KEYRING_SLOT_43							   UNIT_END + 0x25D
#define PLAYER_FIELD_KEYRING_SLOT_44							   UNIT_END + 0x25E
#define PLAYER_FIELD_KEYRING_SLOT_45							   UNIT_END + 0x25F
#define PLAYER_FIELD_KEYRING_SLOT_46							   UNIT_END + 0x260
#define PLAYER_FIELD_KEYRING_SLOT_47							   UNIT_END + 0x261
#define PLAYER_FIELD_KEYRING_SLOT_48							   UNIT_END + 0x262
#define PLAYER_FIELD_KEYRING_SLOT_49							   UNIT_END + 0x263
#define PLAYER_FIELD_KEYRING_SLOT_50							   UNIT_END + 0x264
#define PLAYER_FIELD_KEYRING_SLOT_51							   UNIT_END + 0x265
#define PLAYER_FIELD_KEYRING_SLOT_52							   UNIT_END + 0x266
#define PLAYER_FIELD_KEYRING_SLOT_53							   UNIT_END + 0x267
#define PLAYER_FIELD_KEYRING_SLOT_54							   UNIT_END + 0x268
#define PLAYER_FIELD_KEYRING_SLOT_55							   UNIT_END + 0x269
#define PLAYER_FIELD_KEYRING_SLOT_56							   UNIT_END + 0x26A
#define PLAYER_FIELD_KEYRING_SLOT_57							   UNIT_END + 0x26B
#define PLAYER_FIELD_KEYRING_SLOT_58							   UNIT_END + 0x26C
#define PLAYER_FIELD_KEYRING_SLOT_59							   UNIT_END + 0x26D
#define PLAYER_FIELD_KEYRING_SLOT_60							   UNIT_END + 0x26E
#define PLAYER_FIELD_KEYRING_SLOT_61							   UNIT_END + 0x26F
#define PLAYER_FIELD_KEYRING_SLOT_62							   UNIT_END + 0x270
#define PLAYER_FIELD_KEYRING_SLOT_63							   UNIT_END + 0x271
#define PLAYER_FARSIGHT											UNIT_END + 0x272
#define PLAYER_FARSIGHT_01										 UNIT_END + 0x273
#define PLAYER__FIELD_KNOWN_TITLES								 UNIT_END + 0x274
#define PLAYER__FIELD_KNOWN_TITLES_01							  UNIT_END + 0x275
#define PLAYER_XP												  UNIT_END + 0x276
#define PLAYER_NEXT_LEVEL_XP									   UNIT_END + 0x277
#define PLAYER_SKILL_INFO_1_1									  UNIT_END + 0x278
#define PLAYER_SKILL_INFO_1_01									 UNIT_END + 0x279
#define PLAYER_SKILL_INFO_1_02									 UNIT_END + 0x27A
#define PLAYER_SKILL_INFO_1_03									 UNIT_END + 0x27B
#define PLAYER_SKILL_INFO_1_04									 UNIT_END + 0x27C
#define PLAYER_SKILL_INFO_1_05									 UNIT_END + 0x27D
#define PLAYER_SKILL_INFO_1_06									 UNIT_END + 0x27E
#define PLAYER_SKILL_INFO_1_07									 UNIT_END + 0x27F
#define PLAYER_SKILL_INFO_1_08									 UNIT_END + 0x280
#define PLAYER_SKILL_INFO_1_09									 UNIT_END + 0x281
#define PLAYER_SKILL_INFO_1_10									 UNIT_END + 0x282
#define PLAYER_SKILL_INFO_1_11									 UNIT_END + 0x283
#define PLAYER_SKILL_INFO_1_12									 UNIT_END + 0x284
#define PLAYER_SKILL_INFO_1_13									 UNIT_END + 0x285
#define PLAYER_SKILL_INFO_1_14									 UNIT_END + 0x286
#define PLAYER_SKILL_INFO_1_15									 UNIT_END + 0x287
#define PLAYER_SKILL_INFO_1_16									 UNIT_END + 0x288
#define PLAYER_SKILL_INFO_1_17									 UNIT_END + 0x289
#define PLAYER_SKILL_INFO_1_18									 UNIT_END + 0x28A
#define PLAYER_SKILL_INFO_1_19									 UNIT_END + 0x28B
#define PLAYER_SKILL_INFO_1_20									 UNIT_END + 0x28C
#define PLAYER_SKILL_INFO_1_21									 UNIT_END + 0x28D
#define PLAYER_SKILL_INFO_1_22									 UNIT_END + 0x28E
#define PLAYER_SKILL_INFO_1_23									 UNIT_END + 0x28F
#define PLAYER_SKILL_INFO_1_24									 UNIT_END + 0x290
#define PLAYER_SKILL_INFO_1_25									 UNIT_END + 0x291
#define PLAYER_SKILL_INFO_1_26									 UNIT_END + 0x292
#define PLAYER_SKILL_INFO_1_27									 UNIT_END + 0x293
#define PLAYER_SKILL_INFO_1_28									 UNIT_END + 0x294
#define PLAYER_SKILL_INFO_1_29									 UNIT_END + 0x295
#define PLAYER_SKILL_INFO_1_30									 UNIT_END + 0x296
#define PLAYER_SKILL_INFO_1_31									 UNIT_END + 0x297
#define PLAYER_SKILL_INFO_1_32									 UNIT_END + 0x298
#define PLAYER_SKILL_INFO_1_33									 UNIT_END + 0x299
#define PLAYER_SKILL_INFO_1_34									 UNIT_END + 0x29A
#define PLAYER_SKILL_INFO_1_35									 UNIT_END + 0x29B
#define PLAYER_SKILL_INFO_1_36									 UNIT_END + 0x29C
#define PLAYER_SKILL_INFO_1_37									 UNIT_END + 0x29D
#define PLAYER_SKILL_INFO_1_38									 UNIT_END + 0x29E
#define PLAYER_SKILL_INFO_1_39									 UNIT_END + 0x29F
#define PLAYER_SKILL_INFO_1_40									 UNIT_END + 0x2A0
#define PLAYER_SKILL_INFO_1_41									 UNIT_END + 0x2A1
#define PLAYER_SKILL_INFO_1_42									 UNIT_END + 0x2A2
#define PLAYER_SKILL_INFO_1_43									 UNIT_END + 0x2A3
#define PLAYER_SKILL_INFO_1_44									 UNIT_END + 0x2A4
#define PLAYER_SKILL_INFO_1_45									 UNIT_END + 0x2A5
#define PLAYER_SKILL_INFO_1_46									 UNIT_END + 0x2A6
#define PLAYER_SKILL_INFO_1_47									 UNIT_END + 0x2A7
#define PLAYER_SKILL_INFO_1_48									 UNIT_END + 0x2A8
#define PLAYER_SKILL_INFO_1_49									 UNIT_END + 0x2A9
#define PLAYER_SKILL_INFO_1_50									 UNIT_END + 0x2AA
#define PLAYER_SKILL_INFO_1_51									 UNIT_END + 0x2AB
#define PLAYER_SKILL_INFO_1_52									 UNIT_END + 0x2AC
#define PLAYER_SKILL_INFO_1_53									 UNIT_END + 0x2AD
#define PLAYER_SKILL_INFO_1_54									 UNIT_END + 0x2AE
#define PLAYER_SKILL_INFO_1_55									 UNIT_END + 0x2AF
#define PLAYER_SKILL_INFO_1_56									 UNIT_END + 0x2B0
#define PLAYER_SKILL_INFO_1_57									 UNIT_END + 0x2B1
#define PLAYER_SKILL_INFO_1_58									 UNIT_END + 0x2B2
#define PLAYER_SKILL_INFO_1_59									 UNIT_END + 0x2B3
#define PLAYER_SKILL_INFO_1_60									 UNIT_END + 0x2B4
#define PLAYER_SKILL_INFO_1_61									 UNIT_END + 0x2B5
#define PLAYER_SKILL_INFO_1_62									 UNIT_END + 0x2B6
#define PLAYER_SKILL_INFO_1_63									 UNIT_END + 0x2B7
#define PLAYER_SKILL_INFO_1_64									 UNIT_END + 0x2B8
#define PLAYER_SKILL_INFO_1_65									 UNIT_END + 0x2B9
#define PLAYER_SKILL_INFO_1_66									 UNIT_END + 0x2BA
#define PLAYER_SKILL_INFO_1_67									 UNIT_END + 0x2BB
#define PLAYER_SKILL_INFO_1_68									 UNIT_END + 0x2BC
#define PLAYER_SKILL_INFO_1_69									 UNIT_END + 0x2BD
#define PLAYER_SKILL_INFO_1_70									 UNIT_END + 0x2BE
#define PLAYER_SKILL_INFO_1_71									 UNIT_END + 0x2BF
#define PLAYER_SKILL_INFO_1_72									 UNIT_END + 0x2C0
#define PLAYER_SKILL_INFO_1_73									 UNIT_END + 0x2C1
#define PLAYER_SKILL_INFO_1_74									 UNIT_END + 0x2C2
#define PLAYER_SKILL_INFO_1_75									 UNIT_END + 0x2C3
#define PLAYER_SKILL_INFO_1_76									 UNIT_END + 0x2C4
#define PLAYER_SKILL_INFO_1_77									 UNIT_END + 0x2C5
#define PLAYER_SKILL_INFO_1_78									 UNIT_END + 0x2C6
#define PLAYER_SKILL_INFO_1_79									 UNIT_END + 0x2C7
#define PLAYER_SKILL_INFO_1_80									 UNIT_END + 0x2C8
#define PLAYER_SKILL_INFO_1_81									 UNIT_END + 0x2C9
#define PLAYER_SKILL_INFO_1_82									 UNIT_END + 0x2CA
#define PLAYER_SKILL_INFO_1_83									 UNIT_END + 0x2CB
#define PLAYER_SKILL_INFO_1_84									 UNIT_END + 0x2CC
#define PLAYER_SKILL_INFO_1_85									 UNIT_END + 0x2CD
#define PLAYER_SKILL_INFO_1_86									 UNIT_END + 0x2CE
#define PLAYER_SKILL_INFO_1_87									 UNIT_END + 0x2CF
#define PLAYER_SKILL_INFO_1_88									 UNIT_END + 0x2D0
#define PLAYER_SKILL_INFO_1_89									 UNIT_END + 0x2D1
#define PLAYER_SKILL_INFO_1_90									 UNIT_END + 0x2D2
#define PLAYER_SKILL_INFO_1_91									 UNIT_END + 0x2D3
#define PLAYER_SKILL_INFO_1_92									 UNIT_END + 0x2D4
#define PLAYER_SKILL_INFO_1_93									 UNIT_END + 0x2D5
#define PLAYER_SKILL_INFO_1_94									 UNIT_END + 0x2D6
#define PLAYER_SKILL_INFO_1_95									 UNIT_END + 0x2D7
#define PLAYER_SKILL_INFO_1_96									 UNIT_END + 0x2D8
#define PLAYER_SKILL_INFO_1_97									 UNIT_END + 0x2D9
#define PLAYER_SKILL_INFO_1_98									 UNIT_END + 0x2DA
#define PLAYER_SKILL_INFO_1_99									 UNIT_END + 0x2DB
#define PLAYER_SKILL_INFO_1_100									UNIT_END + 0x2DC
#define PLAYER_SKILL_INFO_1_101									UNIT_END + 0x2DD
#define PLAYER_SKILL_INFO_1_102									UNIT_END + 0x2DE
#define PLAYER_SKILL_INFO_1_103									UNIT_END + 0x2DF
#define PLAYER_SKILL_INFO_1_104									UNIT_END + 0x2E0
#define PLAYER_SKILL_INFO_1_105									UNIT_END + 0x2E1
#define PLAYER_SKILL_INFO_1_106									UNIT_END + 0x2E2
#define PLAYER_SKILL_INFO_1_107									UNIT_END + 0x2E3
#define PLAYER_SKILL_INFO_1_108									UNIT_END + 0x2E4
#define PLAYER_SKILL_INFO_1_109									UNIT_END + 0x2E5
#define PLAYER_SKILL_INFO_1_110									UNIT_END + 0x2E6
#define PLAYER_SKILL_INFO_1_111									UNIT_END + 0x2E7
#define PLAYER_SKILL_INFO_1_112									UNIT_END + 0x2E8
#define PLAYER_SKILL_INFO_1_113									UNIT_END + 0x2E9
#define PLAYER_SKILL_INFO_1_114									UNIT_END + 0x2EA
#define PLAYER_SKILL_INFO_1_115									UNIT_END + 0x2EB
#define PLAYER_SKILL_INFO_1_116									UNIT_END + 0x2EC
#define PLAYER_SKILL_INFO_1_117									UNIT_END + 0x2ED
#define PLAYER_SKILL_INFO_1_118									UNIT_END + 0x2EE
#define PLAYER_SKILL_INFO_1_119									UNIT_END + 0x2EF
#define PLAYER_SKILL_INFO_1_120									UNIT_END + 0x2F0
#define PLAYER_SKILL_INFO_1_121									UNIT_END + 0x2F1
#define PLAYER_SKILL_INFO_1_122									UNIT_END + 0x2F2
#define PLAYER_SKILL_INFO_1_123									UNIT_END + 0x2F3
#define PLAYER_SKILL_INFO_1_124									UNIT_END + 0x2F4
#define PLAYER_SKILL_INFO_1_125									UNIT_END + 0x2F5
#define PLAYER_SKILL_INFO_1_126									UNIT_END + 0x2F6
#define PLAYER_SKILL_INFO_1_127									UNIT_END + 0x2F7
#define PLAYER_SKILL_INFO_1_128									UNIT_END + 0x2F8
#define PLAYER_SKILL_INFO_1_129									UNIT_END + 0x2F9
#define PLAYER_SKILL_INFO_1_130									UNIT_END + 0x2FA
#define PLAYER_SKILL_INFO_1_131									UNIT_END + 0x2FB
#define PLAYER_SKILL_INFO_1_132									UNIT_END + 0x2FC
#define PLAYER_SKILL_INFO_1_133									UNIT_END + 0x2FD
#define PLAYER_SKILL_INFO_1_134									UNIT_END + 0x2FE
#define PLAYER_SKILL_INFO_1_135									UNIT_END + 0x2FF
#define PLAYER_SKILL_INFO_1_136									UNIT_END + 0x300
#define PLAYER_SKILL_INFO_1_137									UNIT_END + 0x301
#define PLAYER_SKILL_INFO_1_138									UNIT_END + 0x302
#define PLAYER_SKILL_INFO_1_139									UNIT_END + 0x303
#define PLAYER_SKILL_INFO_1_140									UNIT_END + 0x304
#define PLAYER_SKILL_INFO_1_141									UNIT_END + 0x305
#define PLAYER_SKILL_INFO_1_142									UNIT_END + 0x306
#define PLAYER_SKILL_INFO_1_143									UNIT_END + 0x307
#define PLAYER_SKILL_INFO_1_144									UNIT_END + 0x308
#define PLAYER_SKILL_INFO_1_145									UNIT_END + 0x309
#define PLAYER_SKILL_INFO_1_146									UNIT_END + 0x30A
#define PLAYER_SKILL_INFO_1_147									UNIT_END + 0x30B
#define PLAYER_SKILL_INFO_1_148									UNIT_END + 0x30C
#define PLAYER_SKILL_INFO_1_149									UNIT_END + 0x30D
#define PLAYER_SKILL_INFO_1_150									UNIT_END + 0x30E
#define PLAYER_SKILL_INFO_1_151									UNIT_END + 0x30F
#define PLAYER_SKILL_INFO_1_152									UNIT_END + 0x310
#define PLAYER_SKILL_INFO_1_153									UNIT_END + 0x311
#define PLAYER_SKILL_INFO_1_154									UNIT_END + 0x312
#define PLAYER_SKILL_INFO_1_155									UNIT_END + 0x313
#define PLAYER_SKILL_INFO_1_156									UNIT_END + 0x314
#define PLAYER_SKILL_INFO_1_157									UNIT_END + 0x315
#define PLAYER_SKILL_INFO_1_158									UNIT_END + 0x316
#define PLAYER_SKILL_INFO_1_159									UNIT_END + 0x317
#define PLAYER_SKILL_INFO_1_160									UNIT_END + 0x318
#define PLAYER_SKILL_INFO_1_161									UNIT_END + 0x319
#define PLAYER_SKILL_INFO_1_162									UNIT_END + 0x31A
#define PLAYER_SKILL_INFO_1_163									UNIT_END + 0x31B
#define PLAYER_SKILL_INFO_1_164									UNIT_END + 0x31C
#define PLAYER_SKILL_INFO_1_165									UNIT_END + 0x31D
#define PLAYER_SKILL_INFO_1_166									UNIT_END + 0x31E
#define PLAYER_SKILL_INFO_1_167									UNIT_END + 0x31F
#define PLAYER_SKILL_INFO_1_168									UNIT_END + 0x320
#define PLAYER_SKILL_INFO_1_169									UNIT_END + 0x321
#define PLAYER_SKILL_INFO_1_170									UNIT_END + 0x322
#define PLAYER_SKILL_INFO_1_171									UNIT_END + 0x323
#define PLAYER_SKILL_INFO_1_172									UNIT_END + 0x324
#define PLAYER_SKILL_INFO_1_173									UNIT_END + 0x325
#define PLAYER_SKILL_INFO_1_174									UNIT_END + 0x326
#define PLAYER_SKILL_INFO_1_175									UNIT_END + 0x327
#define PLAYER_SKILL_INFO_1_176									UNIT_END + 0x328
#define PLAYER_SKILL_INFO_1_177									UNIT_END + 0x329
#define PLAYER_SKILL_INFO_1_178									UNIT_END + 0x32A
#define PLAYER_SKILL_INFO_1_179									UNIT_END + 0x32B
#define PLAYER_SKILL_INFO_1_180									UNIT_END + 0x32C
#define PLAYER_SKILL_INFO_1_181									UNIT_END + 0x32D
#define PLAYER_SKILL_INFO_1_182									UNIT_END + 0x32E
#define PLAYER_SKILL_INFO_1_183									UNIT_END + 0x32F
#define PLAYER_SKILL_INFO_1_184									UNIT_END + 0x330
#define PLAYER_SKILL_INFO_1_185									UNIT_END + 0x331
#define PLAYER_SKILL_INFO_1_186									UNIT_END + 0x332
#define PLAYER_SKILL_INFO_1_187									UNIT_END + 0x333
#define PLAYER_SKILL_INFO_1_188									UNIT_END + 0x334
#define PLAYER_SKILL_INFO_1_189									UNIT_END + 0x335
#define PLAYER_SKILL_INFO_1_190									UNIT_END + 0x336
#define PLAYER_SKILL_INFO_1_191									UNIT_END + 0x337
#define PLAYER_SKILL_INFO_1_192									UNIT_END + 0x338
#define PLAYER_SKILL_INFO_1_193									UNIT_END + 0x339
#define PLAYER_SKILL_INFO_1_194									UNIT_END + 0x33A
#define PLAYER_SKILL_INFO_1_195									UNIT_END + 0x33B
#define PLAYER_SKILL_INFO_1_196									UNIT_END + 0x33C
#define PLAYER_SKILL_INFO_1_197									UNIT_END + 0x33D
#define PLAYER_SKILL_INFO_1_198									UNIT_END + 0x33E
#define PLAYER_SKILL_INFO_1_199									UNIT_END + 0x33F
#define PLAYER_SKILL_INFO_1_200									UNIT_END + 0x340
#define PLAYER_SKILL_INFO_1_201									UNIT_END + 0x341
#define PLAYER_SKILL_INFO_1_202									UNIT_END + 0x342
#define PLAYER_SKILL_INFO_1_203									UNIT_END + 0x343
#define PLAYER_SKILL_INFO_1_204									UNIT_END + 0x344
#define PLAYER_SKILL_INFO_1_205									UNIT_END + 0x345
#define PLAYER_SKILL_INFO_1_206									UNIT_END + 0x346
#define PLAYER_SKILL_INFO_1_207									UNIT_END + 0x347
#define PLAYER_SKILL_INFO_1_208									UNIT_END + 0x348
#define PLAYER_SKILL_INFO_1_209									UNIT_END + 0x349
#define PLAYER_SKILL_INFO_1_210									UNIT_END + 0x34A
#define PLAYER_SKILL_INFO_1_211									UNIT_END + 0x34B
#define PLAYER_SKILL_INFO_1_212									UNIT_END + 0x34C
#define PLAYER_SKILL_INFO_1_213									UNIT_END + 0x34D
#define PLAYER_SKILL_INFO_1_214									UNIT_END + 0x34E
#define PLAYER_SKILL_INFO_1_215									UNIT_END + 0x34F
#define PLAYER_SKILL_INFO_1_216									UNIT_END + 0x350
#define PLAYER_SKILL_INFO_1_217									UNIT_END + 0x351
#define PLAYER_SKILL_INFO_1_218									UNIT_END + 0x352
#define PLAYER_SKILL_INFO_1_219									UNIT_END + 0x353
#define PLAYER_SKILL_INFO_1_220									UNIT_END + 0x354
#define PLAYER_SKILL_INFO_1_221									UNIT_END + 0x355
#define PLAYER_SKILL_INFO_1_222									UNIT_END + 0x356
#define PLAYER_SKILL_INFO_1_223									UNIT_END + 0x357
#define PLAYER_SKILL_INFO_1_224									UNIT_END + 0x358
#define PLAYER_SKILL_INFO_1_225									UNIT_END + 0x359
#define PLAYER_SKILL_INFO_1_226									UNIT_END + 0x35A
#define PLAYER_SKILL_INFO_1_227									UNIT_END + 0x35B
#define PLAYER_SKILL_INFO_1_228									UNIT_END + 0x35C
#define PLAYER_SKILL_INFO_1_229									UNIT_END + 0x35D
#define PLAYER_SKILL_INFO_1_230									UNIT_END + 0x35E
#define PLAYER_SKILL_INFO_1_231									UNIT_END + 0x35F
#define PLAYER_SKILL_INFO_1_232									UNIT_END + 0x360
#define PLAYER_SKILL_INFO_1_233									UNIT_END + 0x361
#define PLAYER_SKILL_INFO_1_234									UNIT_END + 0x362
#define PLAYER_SKILL_INFO_1_235									UNIT_END + 0x363
#define PLAYER_SKILL_INFO_1_236									UNIT_END + 0x364
#define PLAYER_SKILL_INFO_1_237									UNIT_END + 0x365
#define PLAYER_SKILL_INFO_1_238									UNIT_END + 0x366
#define PLAYER_SKILL_INFO_1_239									UNIT_END + 0x367
#define PLAYER_SKILL_INFO_1_240									UNIT_END + 0x368
#define PLAYER_SKILL_INFO_1_241									UNIT_END + 0x369
#define PLAYER_SKILL_INFO_1_242									UNIT_END + 0x36A
#define PLAYER_SKILL_INFO_1_243									UNIT_END + 0x36B
#define PLAYER_SKILL_INFO_1_244									UNIT_END + 0x36C
#define PLAYER_SKILL_INFO_1_245									UNIT_END + 0x36D
#define PLAYER_SKILL_INFO_1_246									UNIT_END + 0x36E
#define PLAYER_SKILL_INFO_1_247									UNIT_END + 0x36F
#define PLAYER_SKILL_INFO_1_248									UNIT_END + 0x370
#define PLAYER_SKILL_INFO_1_249									UNIT_END + 0x371
#define PLAYER_SKILL_INFO_1_250									UNIT_END + 0x372
#define PLAYER_SKILL_INFO_1_251									UNIT_END + 0x373
#define PLAYER_SKILL_INFO_1_252									UNIT_END + 0x374
#define PLAYER_SKILL_INFO_1_253									UNIT_END + 0x375
#define PLAYER_SKILL_INFO_1_254									UNIT_END + 0x376
#define PLAYER_SKILL_INFO_1_255									UNIT_END + 0x377
#define PLAYER_SKILL_INFO_1_256									UNIT_END + 0x378
#define PLAYER_SKILL_INFO_1_257									UNIT_END + 0x379
#define PLAYER_SKILL_INFO_1_258									UNIT_END + 0x37A
#define PLAYER_SKILL_INFO_1_259									UNIT_END + 0x37B
#define PLAYER_SKILL_INFO_1_260									UNIT_END + 0x37C
#define PLAYER_SKILL_INFO_1_261									UNIT_END + 0x37D
#define PLAYER_SKILL_INFO_1_262									UNIT_END + 0x37E
#define PLAYER_SKILL_INFO_1_263									UNIT_END + 0x37F
#define PLAYER_SKILL_INFO_1_264									UNIT_END + 0x380
#define PLAYER_SKILL_INFO_1_265									UNIT_END + 0x381
#define PLAYER_SKILL_INFO_1_266									UNIT_END + 0x382
#define PLAYER_SKILL_INFO_1_267									UNIT_END + 0x383
#define PLAYER_SKILL_INFO_1_268									UNIT_END + 0x384
#define PLAYER_SKILL_INFO_1_269									UNIT_END + 0x385
#define PLAYER_SKILL_INFO_1_270									UNIT_END + 0x386
#define PLAYER_SKILL_INFO_1_271									UNIT_END + 0x387
#define PLAYER_SKILL_INFO_1_272									UNIT_END + 0x388
#define PLAYER_SKILL_INFO_1_273									UNIT_END + 0x389
#define PLAYER_SKILL_INFO_1_274									UNIT_END + 0x38A
#define PLAYER_SKILL_INFO_1_275									UNIT_END + 0x38B
#define PLAYER_SKILL_INFO_1_276									UNIT_END + 0x38C
#define PLAYER_SKILL_INFO_1_277									UNIT_END + 0x38D
#define PLAYER_SKILL_INFO_1_278									UNIT_END + 0x38E
#define PLAYER_SKILL_INFO_1_279									UNIT_END + 0x38F
#define PLAYER_SKILL_INFO_1_280									UNIT_END + 0x390
#define PLAYER_SKILL_INFO_1_281									UNIT_END + 0x391
#define PLAYER_SKILL_INFO_1_282									UNIT_END + 0x392
#define PLAYER_SKILL_INFO_1_283									UNIT_END + 0x393
#define PLAYER_SKILL_INFO_1_284									UNIT_END + 0x394
#define PLAYER_SKILL_INFO_1_285									UNIT_END + 0x395
#define PLAYER_SKILL_INFO_1_286									UNIT_END + 0x396
#define PLAYER_SKILL_INFO_1_287									UNIT_END + 0x397
#define PLAYER_SKILL_INFO_1_288									UNIT_END + 0x398
#define PLAYER_SKILL_INFO_1_289									UNIT_END + 0x399
#define PLAYER_SKILL_INFO_1_290									UNIT_END + 0x39A
#define PLAYER_SKILL_INFO_1_291									UNIT_END + 0x39B
#define PLAYER_SKILL_INFO_1_292									UNIT_END + 0x39C
#define PLAYER_SKILL_INFO_1_293									UNIT_END + 0x39D
#define PLAYER_SKILL_INFO_1_294									UNIT_END + 0x39E
#define PLAYER_SKILL_INFO_1_295									UNIT_END + 0x39F
#define PLAYER_SKILL_INFO_1_296									UNIT_END + 0x3A0
#define PLAYER_SKILL_INFO_1_297									UNIT_END + 0x3A1
#define PLAYER_SKILL_INFO_1_298									UNIT_END + 0x3A2
#define PLAYER_SKILL_INFO_1_299									UNIT_END + 0x3A3
#define PLAYER_SKILL_INFO_1_300									UNIT_END + 0x3A4
#define PLAYER_SKILL_INFO_1_301									UNIT_END + 0x3A5
#define PLAYER_SKILL_INFO_1_302									UNIT_END + 0x3A6
#define PLAYER_SKILL_INFO_1_303									UNIT_END + 0x3A7
#define PLAYER_SKILL_INFO_1_304									UNIT_END + 0x3A8
#define PLAYER_SKILL_INFO_1_305									UNIT_END + 0x3A9
#define PLAYER_SKILL_INFO_1_306									UNIT_END + 0x3AA
#define PLAYER_SKILL_INFO_1_307									UNIT_END + 0x3AB
#define PLAYER_SKILL_INFO_1_308									UNIT_END + 0x3AC
#define PLAYER_SKILL_INFO_1_309									UNIT_END + 0x3AD
#define PLAYER_SKILL_INFO_1_310									UNIT_END + 0x3AE
#define PLAYER_SKILL_INFO_1_311									UNIT_END + 0x3AF
#define PLAYER_SKILL_INFO_1_312									UNIT_END + 0x3B0
#define PLAYER_SKILL_INFO_1_313									UNIT_END + 0x3B1
#define PLAYER_SKILL_INFO_1_314									UNIT_END + 0x3B2
#define PLAYER_SKILL_INFO_1_315									UNIT_END + 0x3B3
#define PLAYER_SKILL_INFO_1_316									UNIT_END + 0x3B4
#define PLAYER_SKILL_INFO_1_317									UNIT_END + 0x3B5
#define PLAYER_SKILL_INFO_1_318									UNIT_END + 0x3B6
#define PLAYER_SKILL_INFO_1_319									UNIT_END + 0x3B7
#define PLAYER_SKILL_INFO_1_320									UNIT_END + 0x3B8
#define PLAYER_SKILL_INFO_1_321									UNIT_END + 0x3B9
#define PLAYER_SKILL_INFO_1_322									UNIT_END + 0x3BA
#define PLAYER_SKILL_INFO_1_323									UNIT_END + 0x3BB
#define PLAYER_SKILL_INFO_1_324									UNIT_END + 0x3BC
#define PLAYER_SKILL_INFO_1_325									UNIT_END + 0x3BD
#define PLAYER_SKILL_INFO_1_326									UNIT_END + 0x3BE
#define PLAYER_SKILL_INFO_1_327									UNIT_END + 0x3BF
#define PLAYER_SKILL_INFO_1_328									UNIT_END + 0x3C0
#define PLAYER_SKILL_INFO_1_329									UNIT_END + 0x3C1
#define PLAYER_SKILL_INFO_1_330									UNIT_END + 0x3C2
#define PLAYER_SKILL_INFO_1_331									UNIT_END + 0x3C3
#define PLAYER_SKILL_INFO_1_332									UNIT_END + 0x3C4
#define PLAYER_SKILL_INFO_1_333									UNIT_END + 0x3C5
#define PLAYER_SKILL_INFO_1_334									UNIT_END + 0x3C6
#define PLAYER_SKILL_INFO_1_335									UNIT_END + 0x3C7
#define PLAYER_SKILL_INFO_1_336									UNIT_END + 0x3C8
#define PLAYER_SKILL_INFO_1_337									UNIT_END + 0x3C9
#define PLAYER_SKILL_INFO_1_338									UNIT_END + 0x3CA
#define PLAYER_SKILL_INFO_1_339									UNIT_END + 0x3CB
#define PLAYER_SKILL_INFO_1_340									UNIT_END + 0x3CC
#define PLAYER_SKILL_INFO_1_341									UNIT_END + 0x3CD
#define PLAYER_SKILL_INFO_1_342									UNIT_END + 0x3CE
#define PLAYER_SKILL_INFO_1_343									UNIT_END + 0x3CF
#define PLAYER_SKILL_INFO_1_344									UNIT_END + 0x3D0
#define PLAYER_SKILL_INFO_1_345									UNIT_END + 0x3D1
#define PLAYER_SKILL_INFO_1_346									UNIT_END + 0x3D2
#define PLAYER_SKILL_INFO_1_347									UNIT_END + 0x3D3
#define PLAYER_SKILL_INFO_1_348									UNIT_END + 0x3D4
#define PLAYER_SKILL_INFO_1_349									UNIT_END + 0x3D5
#define PLAYER_SKILL_INFO_1_350									UNIT_END + 0x3D6
#define PLAYER_SKILL_INFO_1_351									UNIT_END + 0x3D7
#define PLAYER_SKILL_INFO_1_352									UNIT_END + 0x3D8
#define PLAYER_SKILL_INFO_1_353									UNIT_END + 0x3D9
#define PLAYER_SKILL_INFO_1_354									UNIT_END + 0x3DA
#define PLAYER_SKILL_INFO_1_355									UNIT_END + 0x3DB
#define PLAYER_SKILL_INFO_1_356									UNIT_END + 0x3DC
#define PLAYER_SKILL_INFO_1_357									UNIT_END + 0x3DD
#define PLAYER_SKILL_INFO_1_358									UNIT_END + 0x3DE
#define PLAYER_SKILL_INFO_1_359									UNIT_END + 0x3DF
#define PLAYER_SKILL_INFO_1_360									UNIT_END + 0x3E0
#define PLAYER_SKILL_INFO_1_361									UNIT_END + 0x3E1
#define PLAYER_SKILL_INFO_1_362									UNIT_END + 0x3E2
#define PLAYER_SKILL_INFO_1_363									UNIT_END + 0x3E3
#define PLAYER_SKILL_INFO_1_364									UNIT_END + 0x3E4
#define PLAYER_SKILL_INFO_1_365									UNIT_END + 0x3E5
#define PLAYER_SKILL_INFO_1_366									UNIT_END + 0x3E6
#define PLAYER_SKILL_INFO_1_367									UNIT_END + 0x3E7
#define PLAYER_SKILL_INFO_1_368									UNIT_END + 0x3E8
#define PLAYER_SKILL_INFO_1_369									UNIT_END + 0x3E9
#define PLAYER_SKILL_INFO_1_370									UNIT_END + 0x3EA
#define PLAYER_SKILL_INFO_1_371									UNIT_END + 0x3EB
#define PLAYER_SKILL_INFO_1_372									UNIT_END + 0x3EC
#define PLAYER_SKILL_INFO_1_373									UNIT_END + 0x3ED
#define PLAYER_SKILL_INFO_1_374									UNIT_END + 0x3EE
#define PLAYER_SKILL_INFO_1_375									UNIT_END + 0x3EF
#define PLAYER_SKILL_INFO_1_376									UNIT_END + 0x3F0
#define PLAYER_SKILL_INFO_1_377									UNIT_END + 0x3F1
#define PLAYER_SKILL_INFO_1_378									UNIT_END + 0x3F2
#define PLAYER_SKILL_INFO_1_379									UNIT_END + 0x3F3
#define PLAYER_SKILL_INFO_1_380									UNIT_END + 0x3F4
#define PLAYER_SKILL_INFO_1_381									UNIT_END + 0x3F5
#define PLAYER_SKILL_INFO_1_382									UNIT_END + 0x3F6
#define PLAYER_SKILL_INFO_1_383									UNIT_END + 0x3F7
#define PLAYER_CHARACTER_POINTS1								   UNIT_END + 0x3F8
#define PLAYER_CHARACTER_POINTS2								   UNIT_END + 0x3F9
#define PLAYER_TRACK_CREATURES									 UNIT_END + 0x3FA
#define PLAYER_TRACK_RESOURCES									 UNIT_END + 0x3FB
#define PLAYER_BLOCK_PERCENTAGE									UNIT_END + 0x3FC
#define PLAYER_DODGE_PERCENTAGE									UNIT_END + 0x3FD
#define PLAYER_PARRY_PERCENTAGE									UNIT_END + 0x3FE
#define PLAYER_CRIT_PERCENTAGE									 UNIT_END + 0x3FF
#define PLAYER_RANGED_CRIT_PERCENTAGE							  UNIT_END + 0x400
#define PLAYER_OFFHAND_CRIT_PERCENTAGE							 UNIT_END + 0x401
#define PLAYER_SPELL_CRIT_PERCENTAGE1							  UNIT_END + 0x402
#define PLAYER_SPELL_CRIT_PERCENTAGE01							 UNIT_END + 0x403
#define PLAYER_SPELL_CRIT_PERCENTAGE02							 UNIT_END + 0x404
#define PLAYER_SPELL_CRIT_PERCENTAGE03							 UNIT_END + 0x405
#define PLAYER_SPELL_CRIT_PERCENTAGE04							 UNIT_END + 0x406
#define PLAYER_SPELL_CRIT_PERCENTAGE05							 UNIT_END + 0x407
#define PLAYER_SPELL_CRIT_PERCENTAGE06							 UNIT_END + 0x408
#define PLAYER_EXPLORED_ZONES_1									UNIT_END + 0x409
#define PLAYER_EXPLORED_ZONES_01								   UNIT_END + 0x40A
#define PLAYER_EXPLORED_ZONES_02								   UNIT_END + 0x40B
#define PLAYER_EXPLORED_ZONES_03								   UNIT_END + 0x40C
#define PLAYER_EXPLORED_ZONES_04								   UNIT_END + 0x40D
#define PLAYER_EXPLORED_ZONES_05								   UNIT_END + 0x40E
#define PLAYER_EXPLORED_ZONES_06								   UNIT_END + 0x40F
#define PLAYER_EXPLORED_ZONES_07								   UNIT_END + 0x410
#define PLAYER_EXPLORED_ZONES_08								   UNIT_END + 0x411
#define PLAYER_EXPLORED_ZONES_09								   UNIT_END + 0x412
#define PLAYER_EXPLORED_ZONES_10								   UNIT_END + 0x413
#define PLAYER_EXPLORED_ZONES_11								   UNIT_END + 0x414
#define PLAYER_EXPLORED_ZONES_12								   UNIT_END + 0x415
#define PLAYER_EXPLORED_ZONES_13								   UNIT_END + 0x416
#define PLAYER_EXPLORED_ZONES_14								   UNIT_END + 0x417
#define PLAYER_EXPLORED_ZONES_15								   UNIT_END + 0x418
#define PLAYER_EXPLORED_ZONES_16								   UNIT_END + 0x419
#define PLAYER_EXPLORED_ZONES_17								   UNIT_END + 0x41A
#define PLAYER_EXPLORED_ZONES_18								   UNIT_END + 0x41B
#define PLAYER_EXPLORED_ZONES_19								   UNIT_END + 0x41C
#define PLAYER_EXPLORED_ZONES_20								   UNIT_END + 0x41D
#define PLAYER_EXPLORED_ZONES_21								   UNIT_END + 0x41E
#define PLAYER_EXPLORED_ZONES_22								   UNIT_END + 0x41F
#define PLAYER_EXPLORED_ZONES_23								   UNIT_END + 0x420
#define PLAYER_EXPLORED_ZONES_24								   UNIT_END + 0x421
#define PLAYER_EXPLORED_ZONES_25								   UNIT_END + 0x422
#define PLAYER_EXPLORED_ZONES_26								   UNIT_END + 0x423
#define PLAYER_EXPLORED_ZONES_27								   UNIT_END + 0x424
#define PLAYER_EXPLORED_ZONES_28								   UNIT_END + 0x425
#define PLAYER_EXPLORED_ZONES_29								   UNIT_END + 0x426
#define PLAYER_EXPLORED_ZONES_30								   UNIT_END + 0x427
#define PLAYER_EXPLORED_ZONES_31								   UNIT_END + 0x428
#define PLAYER_EXPLORED_ZONES_32								   UNIT_END + 0x429
#define PLAYER_EXPLORED_ZONES_33								   UNIT_END + 0x42A
#define PLAYER_EXPLORED_ZONES_34								   UNIT_END + 0x42B
#define PLAYER_EXPLORED_ZONES_35								   UNIT_END + 0x42C
#define PLAYER_EXPLORED_ZONES_36								   UNIT_END + 0x42D
#define PLAYER_EXPLORED_ZONES_37								   UNIT_END + 0x42E
#define PLAYER_EXPLORED_ZONES_38								   UNIT_END + 0x42F
#define PLAYER_EXPLORED_ZONES_39								   UNIT_END + 0x430
#define PLAYER_EXPLORED_ZONES_40								   UNIT_END + 0x431
#define PLAYER_EXPLORED_ZONES_41								   UNIT_END + 0x432
#define PLAYER_EXPLORED_ZONES_42								   UNIT_END + 0x433
#define PLAYER_EXPLORED_ZONES_43								   UNIT_END + 0x434
#define PLAYER_EXPLORED_ZONES_44								   UNIT_END + 0x435
#define PLAYER_EXPLORED_ZONES_45								   UNIT_END + 0x436
#define PLAYER_EXPLORED_ZONES_46								   UNIT_END + 0x437
#define PLAYER_EXPLORED_ZONES_47								   UNIT_END + 0x438
#define PLAYER_EXPLORED_ZONES_48								   UNIT_END + 0x439
#define PLAYER_EXPLORED_ZONES_49								   UNIT_END + 0x43A
#define PLAYER_EXPLORED_ZONES_50								   UNIT_END + 0x43B
#define PLAYER_EXPLORED_ZONES_51								   UNIT_END + 0x43C
#define PLAYER_EXPLORED_ZONES_52								   UNIT_END + 0x43D
#define PLAYER_EXPLORED_ZONES_53								   UNIT_END + 0x43E
#define PLAYER_EXPLORED_ZONES_54								   UNIT_END + 0x43F
#define PLAYER_EXPLORED_ZONES_55								   UNIT_END + 0x440
#define PLAYER_EXPLORED_ZONES_56								   UNIT_END + 0x441
#define PLAYER_EXPLORED_ZONES_57								   UNIT_END + 0x442
#define PLAYER_EXPLORED_ZONES_58								   UNIT_END + 0x443
#define PLAYER_EXPLORED_ZONES_59								   UNIT_END + 0x444
#define PLAYER_EXPLORED_ZONES_60								   UNIT_END + 0x445
#define PLAYER_EXPLORED_ZONES_61								   UNIT_END + 0x446
#define PLAYER_EXPLORED_ZONES_62								   UNIT_END + 0x447
#define PLAYER_EXPLORED_ZONES_63								   UNIT_END + 0x448
#define PLAYER_REST_STATE_EXPERIENCE							   UNIT_END + 0x449
#define PLAYER_FIELD_COINAGE									   UNIT_END + 0x44A
#define PLAYER_FIELD_MOD_DAMAGE_DONE_POS						   UNIT_END + 0x44B
#define PLAYER_FIELD_MOD_DAMAGE_DONE_POS_01						UNIT_END + 0x44C
#define PLAYER_FIELD_MOD_DAMAGE_DONE_POS_02						UNIT_END + 0x44D
#define PLAYER_FIELD_MOD_DAMAGE_DONE_POS_03						UNIT_END + 0x44E
#define PLAYER_FIELD_MOD_DAMAGE_DONE_POS_04						UNIT_END + 0x44F
#define PLAYER_FIELD_MOD_DAMAGE_DONE_POS_05						UNIT_END + 0x450
#define PLAYER_FIELD_MOD_DAMAGE_DONE_POS_06						UNIT_END + 0x451
#define PLAYER_FIELD_MOD_DAMAGE_DONE_NEG						   UNIT_END + 0x452
#define PLAYER_FIELD_MOD_DAMAGE_DONE_NEG_01						UNIT_END + 0x453
#define PLAYER_FIELD_MOD_DAMAGE_DONE_NEG_02						UNIT_END + 0x454
#define PLAYER_FIELD_MOD_DAMAGE_DONE_NEG_03						UNIT_END + 0x455
#define PLAYER_FIELD_MOD_DAMAGE_DONE_NEG_04						UNIT_END + 0x456
#define PLAYER_FIELD_MOD_DAMAGE_DONE_NEG_05						UNIT_END + 0x457
#define PLAYER_FIELD_MOD_DAMAGE_DONE_NEG_06						UNIT_END + 0x458
#define PLAYER_FIELD_MOD_DAMAGE_DONE_PCT						   UNIT_END + 0x459
#define PLAYER_FIELD_MOD_DAMAGE_DONE_PCT_01						UNIT_END + 0x45A
#define PLAYER_FIELD_MOD_DAMAGE_DONE_PCT_02						UNIT_END + 0x45B
#define PLAYER_FIELD_MOD_DAMAGE_DONE_PCT_03						UNIT_END + 0x45C
#define PLAYER_FIELD_MOD_DAMAGE_DONE_PCT_04						UNIT_END + 0x45D
#define PLAYER_FIELD_MOD_DAMAGE_DONE_PCT_05						UNIT_END + 0x45E
#define PLAYER_FIELD_MOD_DAMAGE_DONE_PCT_06						UNIT_END + 0x45F
#define PLAYER_FIELD_MOD_HEALING_DONE_POS						  UNIT_END + 0x460
#define PLAYER_FIELD_MOD_TARGET_RESISTANCE						 UNIT_END + 0x461
#define PLAYER_FIELD_BYTES										 UNIT_END + 0x462
#define PLAYER_AMMO_ID											 UNIT_END + 0x463
#define PLAYER_SELF_RES_SPELL									  UNIT_END + 0x464
#define PLAYER_FIELD_PVP_MEDALS									UNIT_END + 0x465
#define PLAYER_FIELD_BUYBACK_PRICE_1							   UNIT_END + 0x466
#define PLAYER_FIELD_BUYBACK_PRICE_01							  UNIT_END + 0x467
#define PLAYER_FIELD_BUYBACK_PRICE_02							  UNIT_END + 0x468
#define PLAYER_FIELD_BUYBACK_PRICE_03							  UNIT_END + 0x469
#define PLAYER_FIELD_BUYBACK_PRICE_04							  UNIT_END + 0x46A
#define PLAYER_FIELD_BUYBACK_PRICE_05							  UNIT_END + 0x46B
#define PLAYER_FIELD_BUYBACK_PRICE_06							  UNIT_END + 0x46C
#define PLAYER_FIELD_BUYBACK_PRICE_07							  UNIT_END + 0x46D
#define PLAYER_FIELD_BUYBACK_PRICE_08							  UNIT_END + 0x46E
#define PLAYER_FIELD_BUYBACK_PRICE_09							  UNIT_END + 0x46F
#define PLAYER_FIELD_BUYBACK_PRICE_10							  UNIT_END + 0x470
#define PLAYER_FIELD_BUYBACK_PRICE_11							  UNIT_END + 0x471
#define PLAYER_FIELD_BUYBACK_TIMESTAMP_1						   UNIT_END + 0x472
#define PLAYER_FIELD_BUYBACK_TIMESTAMP_01						  UNIT_END + 0x473
#define PLAYER_FIELD_BUYBACK_TIMESTAMP_02						  UNIT_END + 0x474
#define PLAYER_FIELD_BUYBACK_TIMESTAMP_03						  UNIT_END + 0x475
#define PLAYER_FIELD_BUYBACK_TIMESTAMP_04						  UNIT_END + 0x476
#define PLAYER_FIELD_BUYBACK_TIMESTAMP_05						  UNIT_END + 0x477
#define PLAYER_FIELD_BUYBACK_TIMESTAMP_06						  UNIT_END + 0x478
#define PLAYER_FIELD_BUYBACK_TIMESTAMP_07						  UNIT_END + 0x479
#define PLAYER_FIELD_BUYBACK_TIMESTAMP_08						  UNIT_END + 0x47A
#define PLAYER_FIELD_BUYBACK_TIMESTAMP_09						  UNIT_END + 0x47B
#define PLAYER_FIELD_BUYBACK_TIMESTAMP_10						  UNIT_END + 0x47C
#define PLAYER_FIELD_BUYBACK_TIMESTAMP_11						  UNIT_END + 0x47D
#define PLAYER_FIELD_KILLS										 UNIT_END + 0x47E
#define PLAYER_FIELD_TODAY_CONTRIBUTION							UNIT_END + 0x47F
#define PLAYER_FIELD_YESTERDAY_CONTRIBUTION						UNIT_END + 0x480
#define PLAYER_FIELD_LIFETIME_HONORBALE_KILLS					  UNIT_END + 0x481
#define PLAYER_FIELD_BYTES2										UNIT_END + 0x482
#define PLAYER_FIELD_WATCHED_FACTION_INDEX						 UNIT_END + 0x483
#define PLAYER_FIELD_COMBAT_RATING_1							   UNIT_END + 0x484
#define PLAYER_FIELD_COMBAT_RATING_01							  UNIT_END + 0x485
#define PLAYER_FIELD_COMBAT_RATING_02							  UNIT_END + 0x486
#define PLAYER_FIELD_COMBAT_RATING_03							  UNIT_END + 0x487
#define PLAYER_FIELD_COMBAT_RATING_04							  UNIT_END + 0x488
#define PLAYER_FIELD_COMBAT_RATING_05							  UNIT_END + 0x489
#define PLAYER_FIELD_COMBAT_RATING_06							  UNIT_END + 0x48A
#define PLAYER_FIELD_COMBAT_RATING_07							  UNIT_END + 0x48B
#define PLAYER_FIELD_COMBAT_RATING_08							  UNIT_END + 0x48C
#define PLAYER_FIELD_COMBAT_RATING_09							  UNIT_END + 0x48D
#define PLAYER_FIELD_COMBAT_RATING_10							  UNIT_END + 0x48E
#define PLAYER_FIELD_COMBAT_RATING_11							  UNIT_END + 0x48F
#define PLAYER_FIELD_COMBAT_RATING_12							  UNIT_END + 0x490
#define PLAYER_FIELD_COMBAT_RATING_13							  UNIT_END + 0x491
#define PLAYER_FIELD_COMBAT_RATING_14							  UNIT_END + 0x492
#define PLAYER_FIELD_COMBAT_RATING_15							  UNIT_END + 0x493
#define PLAYER_FIELD_COMBAT_RATING_16							  UNIT_END + 0x494
#define PLAYER_FIELD_COMBAT_RATING_17							  UNIT_END + 0x495
#define PLAYER_FIELD_COMBAT_RATING_18							  UNIT_END + 0x496
#define PLAYER_FIELD_COMBAT_RATING_19							  UNIT_END + 0x497
#define PLAYER_FIELD_COMBAT_RATING_20							  UNIT_END + 0x498
#define PLAYER_FIELD_COMBAT_RATING_21							  UNIT_END + 0x499
#define PLAYER_FIELD_COMBAT_RATING_22							  UNIT_END + 0x49A
#define PLAYER_FIELD_ARENA_TEAM_INFO_1_1						   UNIT_END + 0x49B
#define PLAYER_FIELD_ARENA_TEAM_INFO_1_01						  UNIT_END + 0x49C
#define PLAYER_FIELD_ARENA_TEAM_INFO_1_02						  UNIT_END + 0x49D
#define PLAYER_FIELD_ARENA_TEAM_INFO_1_03						  UNIT_END + 0x49E
#define PLAYER_FIELD_ARENA_TEAM_INFO_1_04						  UNIT_END + 0x49F
#define PLAYER_FIELD_ARENA_TEAM_INFO_1_05						  UNIT_END + 0x4A0
#define PLAYER_FIELD_ARENA_TEAM_INFO_1_06						  UNIT_END + 0x4A1
#define PLAYER_FIELD_ARENA_TEAM_INFO_1_07						  UNIT_END + 0x4A2
#define PLAYER_FIELD_ARENA_TEAM_INFO_1_08						  UNIT_END + 0x4A3
#define PLAYER_FIELD_ARENA_TEAM_INFO_1_09						  UNIT_END + 0x4A4
#define PLAYER_FIELD_ARENA_TEAM_INFO_1_10						  UNIT_END + 0x4A5
#define PLAYER_FIELD_ARENA_TEAM_INFO_1_11						  UNIT_END + 0x4A6
#define PLAYER_FIELD_ARENA_TEAM_INFO_1_12						  UNIT_END + 0x4A7
#define PLAYER_FIELD_ARENA_TEAM_INFO_1_13						  UNIT_END + 0x4A8
#define PLAYER_FIELD_ARENA_TEAM_INFO_1_14						  UNIT_END + 0x4A9
#define PLAYER_FIELD_HONOR_CURRENCY								UNIT_END + 0x4AA
#define PLAYER_FIELD_ARENA_CURRENCY								UNIT_END + 0x4AB
#define PLAYER_FIELD_MOD_MANA_REGEN								UNIT_END + 0x4AC
#define PLAYER_FIELD_MOD_MANA_REGEN_INTERRUPT					  UNIT_END + 0x4AD
#define PLAYER_FIELD_MAX_LEVEL									 UNIT_END + 0x4AE
#define PLAYER_FIELD_DAILY_QUESTS_1								UNIT_END + 0x4AF
#define PLAYER_FIELD_DAILY_QUESTS_01							   UNIT_END + 0x4B0
#define PLAYER_FIELD_DAILY_QUESTS_02							   UNIT_END + 0x4B1
#define PLAYER_FIELD_DAILY_QUESTS_03							   UNIT_END + 0x4B2
#define PLAYER_FIELD_DAILY_QUESTS_04							   UNIT_END + 0x4B3
#define PLAYER_FIELD_DAILY_QUESTS_05							   UNIT_END + 0x4B4
#define PLAYER_FIELD_DAILY_QUESTS_06							   UNIT_END + 0x4B5
#define PLAYER_FIELD_DAILY_QUESTS_07							   UNIT_END + 0x4B6
#define PLAYER_FIELD_DAILY_QUESTS_08							   UNIT_END + 0x4B7
#define PLAYER_FIELD_DAILY_QUESTS_09							   UNIT_END + 0x4B8
#define PLAYER_FIELD_PADDING									   UNIT_END + 0x4B9
#define PLAYER_END												UNIT_END + 0x4BA

// GameObject Fields
#define OBJECT_FIELD_CREATED_BY									OBJECT_END + 0x000
#define OBJECT_FIELD_CREATED_BY_01								 OBJECT_END + 0x001
#define GAMEOBJECT_DISPLAYID									   OBJECT_END + 0x002
#define GAMEOBJECT_FLAGS										   OBJECT_END + 0x003
#define GAMEOBJECT_ROTATION										OBJECT_END + 0x004
#define GAMEOBJECT_ROTATION_01									 OBJECT_END + 0x005
#define GAMEOBJECT_ROTATION_02									 OBJECT_END + 0x006
#define GAMEOBJECT_ROTATION_03									 OBJECT_END + 0x007
#define GAMEOBJECT_STATE										   OBJECT_END + 0x008
#define GAMEOBJECT_POS_X										   OBJECT_END + 0x009
#define GAMEOBJECT_POS_Y										   OBJECT_END + 0x00A
#define GAMEOBJECT_POS_Z										   OBJECT_END + 0x00B
#define GAMEOBJECT_FACING										  OBJECT_END + 0x00C
#define GAMEOBJECT_DYN_FLAGS									   OBJECT_END + 0x00D
#define GAMEOBJECT_FACTION										 OBJECT_END + 0x00E
#define GAMEOBJECT_TYPE_ID										 OBJECT_END + 0x00F
#define GAMEOBJECT_LEVEL										   OBJECT_END + 0x010
#define GAMEOBJECT_ARTKIT										  OBJECT_END + 0x011
#define GAMEOBJECT_ANIMPROGRESS									OBJECT_END + 0x012
#define GAMEOBJECT_PADDING										 OBJECT_END + 0x013
#define GAMEOBJECT_END											OBJECT_END + 0x014

// DynamicObject Fields
#define DYNAMICOBJECT_CASTER									   OBJECT_END + 0x000
#define DYNAMICOBJECT_CASTER_01									OBJECT_END + 0x001
#define DYNAMICOBJECT_BYTES										OBJECT_END + 0x002
#define DYNAMICOBJECT_SPELLID									  OBJECT_END + 0x003
#define DYNAMICOBJECT_RADIUS									   OBJECT_END + 0x004
#define DYNAMICOBJECT_POS_X										OBJECT_END + 0x005
#define DYNAMICOBJECT_POS_Y										OBJECT_END + 0x006
#define DYNAMICOBJECT_POS_Z										OBJECT_END + 0x007
#define DYNAMICOBJECT_FACING									   OBJECT_END + 0x008
#define DYNAMICOBJECT_PAD										  OBJECT_END + 0x009
#define DYNAMICOBJECT_END										OBJECT_END + 0x00A

// Corpse Fields
#define CORPSE_FIELD_OWNER										 OBJECT_END + 0x000
#define CORPSE_FIELD_OWNER_01									  OBJECT_END + 0x001
#define CORPSE_FIELD_FACING										OBJECT_END + 0x002
#define CORPSE_FIELD_POS_X										 OBJECT_END + 0x003
#define CORPSE_FIELD_POS_Y										 OBJECT_END + 0x004
#define CORPSE_FIELD_POS_Z										 OBJECT_END + 0x005
#define CORPSE_FIELD_DISPLAY_ID									OBJECT_END + 0x006
#define CORPSE_FIELD_ITEM										  OBJECT_END + 0x007
#define CORPSE_FIELD_ITEM_01									   OBJECT_END + 0x008
#define CORPSE_FIELD_ITEM_02									   OBJECT_END + 0x009
#define CORPSE_FIELD_ITEM_03									   OBJECT_END + 0x00A
#define CORPSE_FIELD_ITEM_04									   OBJECT_END + 0x00B
#define CORPSE_FIELD_ITEM_05									   OBJECT_END + 0x00C
#define CORPSE_FIELD_ITEM_06									   OBJECT_END + 0x00D
#define CORPSE_FIELD_ITEM_07									   OBJECT_END + 0x00E
#define CORPSE_FIELD_ITEM_08									   OBJECT_END + 0x00F
#define CORPSE_FIELD_ITEM_09									   OBJECT_END + 0x010
#define CORPSE_FIELD_ITEM_10									   OBJECT_END + 0x011
#define CORPSE_FIELD_ITEM_11									   OBJECT_END + 0x012
#define CORPSE_FIELD_ITEM_12									   OBJECT_END + 0x013
#define CORPSE_FIELD_ITEM_13									   OBJECT_END + 0x014
#define CORPSE_FIELD_ITEM_14									   OBJECT_END + 0x015
#define CORPSE_FIELD_ITEM_15									   OBJECT_END + 0x016
#define CORPSE_FIELD_ITEM_16									   OBJECT_END + 0x017
#define CORPSE_FIELD_ITEM_17									   OBJECT_END + 0x018
#define CORPSE_FIELD_ITEM_18									   OBJECT_END + 0x019
#define CORPSE_FIELD_BYTES_1									   OBJECT_END + 0x01A
#define CORPSE_FIELD_BYTES_2									   OBJECT_END + 0x01B
#define CORPSE_FIELD_GUILD										 OBJECT_END + 0x01C
#define CORPSE_FIELD_FLAGS										 OBJECT_END + 0x01D
#define CORPSE_FIELD_DYNAMIC_FLAGS								 OBJECT_END + 0x01E
#define CORPSE_FIELD_PAD										   OBJECT_END + 0x01F
#define CORPSE_END												OBJECT_END + 0x020

#endif // __ASCENT_UPDATEFIELDS_H

